/* $Id: Parser.c,v 2.9 1992/08/07 15:28:42 grosch rel $ */

# define bool		char
# define true		1
# define false		0

# include "Parser.h"
# include "Errors.h"

# ifdef __cplusplus
extern "C" {
#    include "Memory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    ifndef BCOPY
#       include <memory.h>
#    endif
}
# else
#    include "Memory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    ifndef BCOPY
#       include <memory.h>
#    endif
# endif

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifdef lex_interface
#    define GetToken	yylex
     extern int yylex ();
#    ifndef AttributeDef
#	include "Positions.h"
        typedef struct { tPosition Position; } tScanAttribute;
        static	tScanAttribute	Attribute = {{ 0, 0 }};
#    endif
#    ifndef ErrorAttributeDef
#	define ErrorAttribute(Token, RepairAttribute)
#    endif
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) * yyAttrStackPtr = yylval
#    endif
# else
#    include "Scanner.h"
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) (yyAttrStackPtr)->Scan = Attribute
#    endif
# endif

/* line 25 "/tmp/lalr5400" */
/* line 39 "occam.lalr" */

  #include "Scanner.h"
  #include "TreeFix.h"
  #include "Tree.h"
  #include "Symbol.h"
  #include "TypeChk.h"
  
  #define InheritTypes(t)
  #define DEBUG(s) fprintf(stderr,"DEBUG: %s\n",s);

  typedef struct { tScanAttribute Scan; tTree Tree; } tParsAttribute;

  #define Posn(a)  ((a).Scan.Position)
  #define Val(a) ((a).Scan.Value)
  #define InsertASpec(a,s) a=mASpec(s,a)

  static tSymbol S;
  static tTree T;
  static bool last_type_was_chan = false;
  static tValue Vtrue,Vfalse;

  /* All features of the Occam language are initially supported. */
  /* ParserDrv.c will disable those which a particular back-end cannot support. */
  bool AreRealsSupported = true;
  bool ArePortsSupported = true;
  bool IsPlaceSupported  = true;
  /*bool IsPragmaSupported = true;*/


# if defined lex_interface & ! defined yylvalDef
     tParsAttribute yylval;
# endif

# ifndef yyInitStackSize
#    define yyInitStackSize	100
# endif
# define yyNoState		0

# define yyFirstTerminal	0
# define yyLastTerminal		113
# define yyTableMax		3235
# define yyNTableMax		5624
# define yyFirstReadState	1
# define yyLastReadState	460
# define yyFirstReadTermState	461
# define yyLastReadTermState	614
# define yyLastReadNontermState	740
# define yyFirstReduceState	741
# define yyLastReduceState	1070
# define yyStartState		1
# define yyStopState		741

# define yyFirstFinalState	yyFirstReadTermState

typedef unsigned short	yyStateRange	;
typedef unsigned short	yySymbolRange	;
typedef struct	{ yyStateRange Check, Next; } yyTCombType ;

	char *		Parser_TokenName	[yyLastTerminal + 1] = {
"_EndOfFile",
"DECLCOMMA",
"ID",
"EOL",
"NUMBER",
"HEXNUMBER",
"CHCON",
"STR",
"CSTR",
"RNUMBER",
"BEGIN",
"END",
"LT",
"GT",
"LE",
"GE",
"EQ",
"NE",
"ADD",
"SUBTRACT",
"MULTIPLY",
"DIVIDE",
"BITEOR",
"LSHIFT",
"RSHIFT",
"DCOLON",
"ASSIGN",
"LP",
"RP",
"COLON",
"SEMICOLON",
"COMMA",
"AMPERSAND",
"LSB",
"RSB",
"QUERY",
"PLING",
"HASHC",
"HASHH",
"PRAGMATRACK",
"TYPEID",
"AFTER",
"ALT",
"AND",
"ANY",
"BITAND",
"BITNOT",
"BITOR",
"BOOL",
"BYTE",
"CASE",
"CHAN",
"ELSE",
"FALSE",
"FOR",
"FROM",
"FUNCTION",
"IF",
"INT",
"INT16",
"INT32",
"INT64",
"IS",
"MINUS",
"MOSTNEG",
"MOSTPOS",
"NOT",
"OF",
"OR",
"PAR",
"PLACED",
"PLUS",
"PORT",
"PRI",
"PROC",
"PROCESSOR",
"PROTOCOL",
"REAL32",
"REAL64",
"REM",
"RESULT",
"RETYPES",
"ROUND",
"SEQ",
"SIZE",
"SKIP",
"STOP",
"TIMER",
"TIMES",
"TRUE",
"TRUNC",
"VAL",
"VALOF",
"WHILE",
"EXTERN_OCCAM",
"EXTERN_ATOMIC",
"EXTERN_F90",
"EXTERN_F77",
"EXTERN_C",
"DATA",
"TYPE",
"RECORD",
"PACKED",
"BYTESIN",
"OFFSETOF",
"RESHAPES",
"ASM",
"AT",
"GUY",
"IN",
"INLINE",
"PLACE",
"WORKSPACE",
"VECSPACE",
};
static	yyTCombType	yyTComb		[yyTableMax + 1] = {
{458, 741},
{0, 0},
{1, 2},
{21, 473},
{46, 47},
{98, 99},
{99, 751},
{99, 100},
{101, 525},
{2, 952},
{105, 106},
{108, 109},
{108, 883},
{111, 532},
{119, 120},
{128, 129},
{132, 133},
{137, 138},
{144, 145},
{146, 147},
{152, 153},
{157, 158},
{161, 162},
{45, 487},
{167, 168},
{100, 101},
{174, 175},
{40, 41},
{3, 452},
{5, 612},
{8, 470},
{11, 471},
{14, 472},
{1, 130},
{2, 952},
{2, 3},
{26, 27},
{1, 132},
{1, 457},
{2, 952},
{27, 28},
{2, 952},
{1, 536},
{2, 952},
{2, 952},
{29, 476},
{33, 482},
{39, 486},
{41, 42},
{43, 44},
{1, 537},
{1, 102},
{44, 45},
{45, 488},
{47, 489},
{48, 49},
{19, 20},
{1, 538},
{50, 437},
{56, 490},
{59, 491},
{62, 492},
{64, 65},
{65, 493},
{68, 494},
{74, 75},
{84, 520},
{20, 21},
{22, 23},
{1, 539},
{1, 135},
{88, 522},
{91, 92},
{1, 148},
{1, 121},
{1, 143},
{1, 152},
{19, 22},
{76, 51},
{93, 523},
{86, 521},
{76, 496},
{52, 53},
{1, 543},
{94, 524},
{1, 170},
{1, 172},
{96, 61},
{109, 17},
{112, 114},
{52, 396},
{1, 174},
{19, 475},
{1, 186},
{1, 550},
{1, 551},
{1, 552},
{1, 553},
{1, 554},
{1, 190},
{86, 87},
{4, 952},
{4, 952},
{4, 952},
{95, 957},
{97, 967},
{102, 103},
{120, 533},
{95, 55},
{97, 17},
{1, 202},
{1, 210},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{122, 123},
{4, 5},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{4, 952},
{71, 952},
{116, 113},
{126, 127},
{71, 952},
{71, 952},
{36, 461},
{4, 952},
{71, 952},
{4, 952},
{130, 480},
{4, 952},
{131, 519},
{4, 952},
{36, 462},
{36, 463},
{135, 539},
{36, 20},
{139, 140},
{148, 539},
{4, 952},
{4, 952},
{153, 154},
{158, 159},
{36, 464},
{36, 465},
{36, 466},
{36, 467},
{162, 906},
{4, 952},
{116, 117},
{155, 540},
{155, 156},
{163, 474},
{4, 952},
{160, 161},
{160, 169},
{4, 952},
{36, 22},
{168, 541},
{169, 542},
{166, 529},
{177, 544},
{36, 468},
{36, 469},
{4, 952},
{6, 1030},
{6, 1030},
{6, 1030},
{166, 167},
{178, 179},
{164, 907},
{181, 547},
{36, 475},
{4, 952},
{162, 163},
{179, 545},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{183, 548},
{6, 7},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{6, 1030},
{164, 156},
{6, 1030},
{179, 546},
{185, 549},
{188, 189},
{190, 191},
{192, 193},
{38, 461},
{6, 1030},
{193, 17},
{6, 1030},
{194, 555},
{6, 1030},
{191, 526},
{6, 1030},
{38, 462},
{38, 463},
{195, 196},
{196, 197},
{197, 107},
{198, 199},
{6, 1030},
{199, 556},
{200, 201},
{201, 557},
{38, 464},
{38, 465},
{38, 466},
{38, 467},
{202, 203},
{6, 1030},
{204, 205},
{206, 207},
{208, 209},
{210, 211},
{6, 1030},
{212, 213},
{211, 212},
{6, 1030},
{211, 216},
{214, 558},
{215, 559},
{216, 217},
{216, 218},
{38, 468},
{38, 469},
{6, 1030},
{9, 1031},
{9, 1031},
{9, 1031},
{217, 560},
{191, 527},
{218, 561},
{221, 222},
{224, 225},
{6, 1030},
{228, 562},
{115, 885},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{230, 529},
{9, 10},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{9, 1031},
{115, 885},
{9, 1031},
{234, 563},
{236, 237},
{238, 564},
{244, 529},
{246, 247},
{115, 885},
{9, 1031},
{248, 565},
{9, 1031},
{249, 137},
{9, 1031},
{252, 536},
{9, 1031},
{115, 885},
{115, 885},
{254, 529},
{115, 885},
{256, 257},
{258, 566},
{9, 1031},
{260, 848},
{262, 567},
{264, 568},
{115, 885},
{115, 885},
{115, 885},
{115, 885},
{265, 569},
{9, 1031},
{268, 546},
{270, 570},
{272, 571},
{266, 530},
{9, 1031},
{274, 572},
{278, 279},
{9, 1031},
{115, 885},
{280, 281},
{281, 282},
{276, 277},
{283, 574},
{115, 885},
{115, 885},
{9, 1031},
{12, 1034},
{12, 1034},
{12, 1034},
{260, 848},
{285, 286},
{273, 4},
{288, 495},
{115, 885},
{9, 1031},
{275, 266},
{118, 884},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{266, 531},
{12, 13},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{12, 1034},
{118, 884},
{12, 1034},
{259, 936},
{259, 260},
{273, 73},
{275, 573},
{290, 529},
{118, 884},
{12, 1034},
{291, 292},
{12, 1034},
{293, 294},
{12, 1034},
{295, 296},
{12, 1034},
{118, 884},
{118, 884},
{276, 356},
{118, 884},
{296, 297},
{299, 941},
{12, 1034},
{304, 943},
{260, 545},
{306, 307},
{118, 884},
{118, 884},
{118, 884},
{118, 884},
{305, 577},
{12, 1034},
{308, 309},
{259, 936},
{310, 311},
{311, 312},
{12, 1034},
{312, 576},
{312, 897},
{12, 1034},
{118, 884},
{315, 316},
{317, 578},
{267, 937},
{267, 268},
{118, 884},
{118, 884},
{12, 1034},
{15, 968},
{15, 968},
{15, 968},
{321, 322},
{323, 910},
{336, 529},
{342, 343},
{118, 884},
{12, 1034},
{344, 581},
{259, 936},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{267, 937},
{15, 16},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{15, 968},
{326, 55},
{320, 529},
{303, 950},
{303, 535},
{334, 952},
{345, 582},
{15, 968},
{348, 911},
{15, 968},
{320, 579},
{15, 968},
{339, 929},
{15, 968},
{337, 928},
{354, 355},
{352, 921},
{267, 937},
{355, 583},
{327, 935},
{15, 968},
{15, 968},
{326, 83},
{326, 85},
{341, 580},
{356, 357},
{357, 534},
{334, 952},
{358, 359},
{15, 968},
{303, 950},
{259, 936},
{334, 952},
{303, 950},
{15, 968},
{334, 952},
{337, 338},
{15, 968},
{305, 301},
{339, 929},
{359, 939},
{337, 928},
{339, 55},
{352, 353},
{327, 935},
{15, 968},
{18, 989},
{18, 989},
{18, 989},
{327, 935},
{360, 361},
{327, 55},
{361, 362},
{363, 584},
{15, 968},
{341, 325},
{350, 924},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{267, 937},
{18, 19},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{18, 989},
{350, 351},
{18, 989},
{328, 934},
{364, 365},
{367, 368},
{350, 924},
{368, 585},
{370, 371},
{18, 989},
{372, 586},
{18, 989},
{366, 288},
{18, 989},
{373, 374},
{18, 989},
{374, 375},
{376, 377},
{378, 587},
{380, 381},
{382, 588},
{25, 1051},
{18, 989},
{25, 1051},
{384, 385},
{386, 589},
{359, 124},
{387, 55},
{328, 934},
{387, 388},
{389, 528},
{18, 989},
{388, 330},
{328, 934},
{390, 341},
{391, 392},
{18, 989},
{328, 329},
{328, 349},
{18, 989},
{393, 590},
{388, 537},
{394, 395},
{366, 17},
{399, 591},
{25, 26},
{401, 402},
{18, 989},
{25, 1051},
{25, 1051},
{25, 1051},
{25, 1051},
{25, 1051},
{403, 592},
{25, 1051},
{395, 952},
{18, 989},
{407, 593},
{395, 952},
{395, 952},
{25, 1051},
{409, 410},
{411, 594},
{413, 414},
{415, 595},
{416, 596},
{31, 1033},
{31, 1033},
{31, 1033},
{418, 529},
{419, 51},
{420, 421},
{219, 477},
{219, 478},
{25, 1051},
{422, 597},
{25, 1051},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{405, 952},
{31, 32},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{31, 1033},
{423, 424},
{31, 1033},
{219, 481},
{424, 598},
{366, 575},
{425, 599},
{426, 600},
{427, 601},
{31, 1033},
{428, 602},
{31, 1033},
{430, 529},
{31, 1033},
{432, 603},
{31, 1033},
{431, 135},
{433, 434},
{405, 5},
{430, 431},
{219, 483},
{431, 143},
{31, 1033},
{219, 484},
{405, 952},
{434, 604},
{435, 605},
{436, 606},
{219, 485},
{438, 439},
{439, 607},
{31, 1033},
{443, 444},
{25, 1051},
{445, 608},
{446, 609},
{31, 1033},
{447, 610},
{450, 611},
{31, 1033},
{451, 613},
{219, 36},
{454, 455},
{404, 936},
{404, 405},
{454, 51},
{457, 614},
{31, 1033},
{37, 1032},
{37, 1032},
{37, 1032},
{459, 528},
{460, 744},
{0, 0},
{0, 0},
{460, 529},
{31, 1033},
{0, 0},
{0, 0},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{404, 936},
{37, 38},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{37, 1032},
{0, 0},
{37, 1032},
{404, 531},
{398, 967},
{398, 967},
{0, 0},
{0, 0},
{0, 0},
{37, 1032},
{0, 0},
{37, 1032},
{0, 0},
{37, 1032},
{0, 0},
{37, 1032},
{0, 0},
{0, 0},
{0, 0},
{404, 936},
{0, 0},
{0, 0},
{37, 1032},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{398, 967},
{0, 0},
{0, 0},
{37, 1032},
{398, 967},
{398, 967},
{398, 967},
{398, 967},
{37, 1032},
{398, 967},
{0, 0},
{37, 1032},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{37, 1032},
{54, 984},
{54, 984},
{54, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{37, 1032},
{398, 967},
{0, 0},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{404, 936},
{0, 0},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{54, 984},
{0, 0},
{54, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{54, 984},
{0, 0},
{54, 984},
{0, 0},
{54, 984},
{0, 0},
{54, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{54, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{54, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{54, 984},
{0, 0},
{0, 0},
{54, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{54, 984},
{57, 966},
{57, 966},
{57, 966},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{54, 984},
{0, 0},
{0, 0},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{0, 0},
{0, 0},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{57, 966},
{57, 58},
{57, 966},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{57, 966},
{0, 0},
{57, 966},
{0, 0},
{57, 966},
{0, 0},
{57, 966},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{57, 966},
{57, 966},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{57, 966},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{57, 966},
{0, 0},
{0, 0},
{57, 966},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{57, 966},
{60, 998},
{60, 998},
{60, 998},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{57, 966},
{0, 0},
{0, 0},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{0, 0},
{0, 0},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{60, 998},
{0, 0},
{60, 998},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 998},
{0, 0},
{60, 998},
{0, 0},
{60, 998},
{0, 0},
{60, 998},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 998},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 998},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 998},
{0, 0},
{0, 0},
{60, 998},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 998},
{63, 967},
{63, 967},
{63, 967},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 998},
{0, 0},
{0, 0},
{63, 967},
{63, 967},
{63, 967},
{63, 967},
{63, 967},
{63, 967},
{63, 967},
{63, 967},
{63, 967},
{63, 967},
{63, 967},
{63, 967},
{63, 967},
{63, 967},
{0, 0},
{63, 64},
{63, 967},
{0, 0},
{63, 967},
{63, 967},
{63, 967},
{0, 0},
{63, 967},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{63, 967},
{0, 0},
{63, 967},
{0, 0},
{63, 967},
{0, 0},
{63, 967},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{63, 967},
{63, 967},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{63, 967},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{63, 967},
{0, 0},
{0, 0},
{63, 967},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{63, 967},
{66, 986},
{66, 986},
{66, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{63, 967},
{0, 0},
{70, 71},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{0, 0},
{0, 0},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{66, 986},
{66, 67},
{66, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{66, 986},
{0, 0},
{66, 986},
{0, 0},
{66, 986},
{0, 0},
{66, 986},
{70, 98},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{66, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{70, 102},
{0, 0},
{0, 0},
{66, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{66, 986},
{0, 0},
{0, 0},
{66, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{66, 986},
{0, 0},
{0, 0},
{0, 0},
{70, 121},
{0, 0},
{70, 152},
{0, 0},
{0, 0},
{66, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{70, 174},
{70, 575},
{0, 0},
{70, 550},
{70, 551},
{70, 552},
{70, 553},
{70, 554},
{70, 190},
{0, 0},
{77, 976},
{77, 976},
{77, 976},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{70, 202},
{70, 210},
{77, 497},
{77, 498},
{77, 499},
{77, 500},
{77, 501},
{77, 502},
{77, 503},
{77, 504},
{77, 505},
{77, 506},
{77, 507},
{77, 508},
{77, 509},
{77, 976},
{0, 0},
{0, 0},
{77, 976},
{77, 976},
{77, 976},
{77, 976},
{77, 976},
{0, 0},
{77, 976},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{77, 510},
{0, 0},
{0, 0},
{0, 0},
{77, 512},
{0, 0},
{77, 513},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{77, 976},
{0, 0},
{80, 978},
{80, 978},
{80, 978},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{77, 514},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{77, 516},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{77, 517},
{80, 978},
{0, 0},
{0, 0},
{80, 978},
{80, 978},
{80, 978},
{80, 978},
{80, 978},
{77, 518},
{80, 978},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{80, 511},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{80, 978},
{89, 985},
{89, 985},
{89, 985},
{89, 985},
{89, 985},
{89, 985},
{89, 985},
{89, 985},
{89, 985},
{89, 985},
{89, 985},
{89, 985},
{89, 985},
{80, 515},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{89, 985},
{0, 0},
{134, 761},
{89, 985},
{134, 761},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{89, 985},
{0, 0},
{89, 985},
{134, 761},
{89, 985},
{0, 0},
{89, 985},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{89, 90},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{89, 985},
{0, 0},
{0, 0},
{134, 761},
{0, 0},
{89, 985},
{0, 0},
{134, 761},
{89, 985},
{134, 761},
{134, 761},
{0, 0},
{134, 761},
{0, 0},
{0, 0},
{0, 0},
{89, 985},
{0, 0},
{134, 761},
{134, 761},
{134, 761},
{134, 761},
{0, 0},
{0, 0},
{0, 0},
{89, 985},
{0, 0},
{134, 761},
{134, 761},
{134, 761},
{134, 761},
{134, 761},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{134, 761},
{134, 761},
{0, 0},
{134, 761},
{134, 761},
{134, 761},
{134, 761},
{134, 761},
{134, 761},
{134, 761},
{141, 798},
{134, 761},
{141, 798},
{0, 0},
{134, 761},
{0, 0},
{134, 761},
{134, 761},
{134, 761},
{0, 0},
{141, 142},
{141, 798},
{134, 761},
{0, 0},
{134, 761},
{134, 761},
{134, 761},
{134, 761},
{134, 761},
{134, 761},
{134, 761},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{134, 761},
{134, 761},
{141, 798},
{0, 0},
{0, 0},
{0, 0},
{141, 798},
{0, 0},
{141, 798},
{141, 798},
{0, 0},
{141, 798},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{141, 798},
{141, 798},
{141, 798},
{141, 798},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{141, 798},
{141, 798},
{141, 798},
{141, 798},
{141, 798},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{141, 798},
{141, 798},
{0, 0},
{141, 798},
{141, 798},
{141, 798},
{141, 798},
{141, 798},
{141, 798},
{141, 798},
{150, 792},
{141, 798},
{150, 792},
{0, 0},
{141, 798},
{0, 0},
{141, 798},
{141, 798},
{141, 798},
{0, 0},
{150, 151},
{150, 792},
{141, 798},
{0, 0},
{141, 798},
{141, 798},
{141, 798},
{141, 798},
{141, 798},
{141, 798},
{141, 798},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{141, 798},
{141, 798},
{150, 792},
{0, 0},
{0, 0},
{0, 0},
{150, 792},
{0, 0},
{150, 792},
{150, 792},
{0, 0},
{150, 792},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{150, 792},
{150, 792},
{150, 792},
{150, 792},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{150, 792},
{150, 792},
{150, 792},
{150, 792},
{150, 792},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{150, 792},
{150, 792},
{0, 0},
{150, 792},
{150, 792},
{150, 792},
{150, 792},
{150, 792},
{150, 792},
{150, 792},
{171, 754},
{150, 792},
{171, 754},
{0, 0},
{150, 792},
{0, 0},
{150, 792},
{150, 792},
{150, 792},
{0, 0},
{0, 0},
{171, 754},
{150, 792},
{0, 0},
{150, 792},
{150, 792},
{150, 792},
{150, 792},
{150, 792},
{150, 792},
{150, 792},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{150, 792},
{150, 792},
{171, 754},
{0, 0},
{0, 0},
{0, 0},
{171, 754},
{0, 0},
{171, 754},
{171, 754},
{0, 0},
{171, 754},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{171, 754},
{171, 754},
{171, 754},
{171, 754},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{171, 754},
{171, 754},
{171, 754},
{171, 754},
{171, 754},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{171, 754},
{171, 754},
{0, 0},
{171, 754},
{171, 754},
{171, 754},
{171, 754},
{171, 754},
{171, 754},
{171, 754},
{173, 755},
{171, 754},
{173, 755},
{0, 0},
{171, 754},
{0, 0},
{171, 754},
{171, 754},
{171, 754},
{0, 0},
{0, 0},
{173, 755},
{171, 754},
{0, 0},
{171, 754},
{171, 754},
{171, 754},
{171, 754},
{171, 754},
{171, 754},
{171, 754},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{171, 754},
{171, 754},
{173, 755},
{0, 0},
{0, 0},
{0, 0},
{173, 755},
{0, 0},
{173, 755},
{173, 755},
{0, 0},
{173, 755},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{173, 755},
{173, 755},
{173, 755},
{173, 755},
{222, 71},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{173, 755},
{173, 755},
{173, 755},
{173, 755},
{173, 755},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{173, 755},
{173, 755},
{0, 0},
{173, 755},
{173, 755},
{173, 755},
{173, 755},
{173, 755},
{173, 755},
{173, 755},
{0, 0},
{173, 755},
{0, 0},
{0, 0},
{173, 755},
{0, 0},
{173, 755},
{173, 755},
{173, 755},
{0, 0},
{222, 98},
{0, 0},
{173, 755},
{0, 0},
{173, 755},
{173, 755},
{173, 755},
{173, 755},
{173, 755},
{173, 755},
{173, 755},
{0, 0},
{222, 102},
{222, 223},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{173, 755},
{173, 755},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{227, 753},
{0, 0},
{227, 753},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{222, 121},
{0, 0},
{222, 152},
{0, 0},
{227, 753},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{222, 174},
{0, 0},
{0, 0},
{222, 550},
{222, 551},
{222, 552},
{222, 553},
{222, 554},
{222, 190},
{227, 753},
{0, 0},
{0, 0},
{0, 0},
{227, 753},
{0, 0},
{227, 753},
{227, 753},
{0, 0},
{227, 753},
{222, 202},
{222, 210},
{0, 0},
{0, 0},
{0, 0},
{227, 753},
{227, 753},
{227, 753},
{227, 753},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{227, 753},
{227, 753},
{227, 753},
{227, 753},
{227, 753},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{227, 753},
{227, 753},
{0, 0},
{227, 753},
{227, 753},
{227, 753},
{227, 753},
{227, 753},
{227, 753},
{227, 753},
{232, 783},
{227, 753},
{232, 783},
{0, 0},
{227, 753},
{0, 0},
{227, 753},
{227, 753},
{227, 753},
{0, 0},
{232, 233},
{232, 783},
{227, 753},
{0, 0},
{227, 753},
{227, 753},
{227, 753},
{227, 753},
{227, 753},
{227, 753},
{227, 753},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{227, 753},
{227, 753},
{232, 783},
{0, 0},
{0, 0},
{0, 0},
{232, 783},
{0, 0},
{232, 783},
{232, 783},
{0, 0},
{232, 783},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{232, 783},
{232, 783},
{232, 783},
{232, 783},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{232, 783},
{232, 783},
{232, 783},
{232, 783},
{232, 783},
{0, 0},
{0, 0},
{0, 0},
{233, 2},
{0, 0},
{0, 0},
{0, 0},
{232, 783},
{232, 783},
{0, 0},
{232, 783},
{232, 783},
{232, 783},
{232, 783},
{232, 783},
{232, 783},
{232, 783},
{0, 0},
{232, 783},
{0, 0},
{0, 0},
{232, 783},
{0, 0},
{232, 783},
{232, 783},
{232, 783},
{0, 0},
{0, 0},
{0, 0},
{232, 783},
{0, 0},
{232, 783},
{232, 783},
{232, 783},
{232, 783},
{232, 783},
{232, 783},
{232, 783},
{233, 132},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{233, 536},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{232, 783},
{232, 783},
{0, 0},
{233, 537},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{233, 538},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{233, 539},
{233, 135},
{0, 0},
{0, 0},
{233, 148},
{0, 0},
{233, 143},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{233, 543},
{0, 0},
{233, 170},
{233, 172},
{0, 0},
{0, 0},
{0, 0},
{240, 806},
{0, 0},
{240, 806},
{233, 186},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{0, 0},
{240, 806},
{240, 241},
{240, 806},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{240, 806},
{240, 806},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{240, 806},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{240, 806},
{0, 0},
{0, 0},
{0, 0},
{240, 806},
{0, 0},
{240, 806},
{240, 806},
{0, 0},
{240, 806},
{0, 0},
{0, 0},
{0, 0},
{240, 806},
{0, 0},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{0, 0},
{240, 806},
{0, 0},
{0, 0},
{0, 0},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{0, 0},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{0, 0},
{241, 242},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{0, 0},
{240, 806},
{0, 0},
{0, 0},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{0, 0},
{240, 806},
{0, 0},
{240, 806},
{0, 0},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{240, 806},
{0, 0},
{0, 0},
{0, 0},
{240, 806},
{240, 806},
{241, 98},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{240, 806},
{240, 806},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{241, 102},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{241, 538},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{241, 121},
{0, 0},
{241, 152},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{241, 174},
{0, 0},
{0, 0},
{241, 550},
{241, 551},
{241, 552},
{241, 553},
{241, 554},
{241, 190},
{0, 0},
{0, 0},
{0, 0},
{242, 952},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{241, 202},
{241, 210},
{242, 952},
{242, 952},
{242, 952},
{242, 952},
{242, 952},
{242, 952},
{242, 952},
{242, 952},
{242, 952},
{242, 952},
{242, 952},
{242, 952},
{242, 952},
{0, 0},
{0, 0},
{242, 5},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{242, 952},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{242, 952},
{0, 0},
{242, 952},
{0, 0},
{242, 952},
{0, 0},
{242, 952},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{242, 952},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{242, 952},
{0, 0},
{0, 0},
{242, 952},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{250, 812},
{0, 0},
{250, 812},
{242, 952},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{0, 0},
{250, 812},
{250, 251},
{250, 812},
{242, 952},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{250, 812},
{250, 812},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{250, 812},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{250, 812},
{0, 0},
{0, 0},
{0, 0},
{250, 812},
{0, 0},
{250, 812},
{250, 812},
{0, 0},
{250, 812},
{0, 0},
{0, 0},
{0, 0},
{250, 812},
{0, 0},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{0, 0},
{250, 812},
{0, 0},
{0, 0},
{0, 0},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{0, 0},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{0, 0},
{251, 71},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{0, 0},
{250, 812},
{0, 0},
{0, 0},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{0, 0},
{250, 812},
{0, 0},
{250, 812},
{0, 0},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{250, 812},
{0, 0},
{0, 0},
{0, 0},
{250, 812},
{250, 812},
{251, 98},
{0, 0},
{0, 0},
{251, 536},
{0, 0},
{250, 812},
{250, 812},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{251, 102},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{251, 252},
{251, 121},
{0, 0},
{251, 152},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{251, 174},
{0, 0},
{0, 0},
{251, 550},
{251, 551},
{251, 552},
{251, 553},
{251, 554},
{251, 190},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{251, 202},
{251, 210},
{332, 913},
{0, 0},
{332, 913},
{0, 0},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{0, 0},
{332, 913},
{332, 333},
{332, 913},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{332, 913},
{332, 913},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{332, 913},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{332, 913},
{0, 0},
{0, 0},
{0, 0},
{332, 913},
{0, 0},
{332, 913},
{332, 913},
{0, 0},
{332, 913},
{0, 0},
{0, 0},
{0, 0},
{332, 913},
{0, 0},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{0, 0},
{332, 913},
{0, 0},
{0, 0},
{0, 0},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{0, 0},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{0, 0},
{0, 0},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{0, 0},
{332, 913},
{333, 334},
{0, 0},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{0, 0},
{332, 913},
{0, 0},
{332, 913},
{0, 0},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{332, 913},
{0, 0},
{0, 0},
{0, 0},
{332, 913},
{332, 913},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{332, 913},
{332, 913},
{333, 130},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{333, 98},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{333, 102},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{347, 915},
{0, 0},
{347, 915},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{333, 121},
{0, 0},
{333, 152},
{0, 0},
{347, 915},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{333, 174},
{0, 0},
{0, 0},
{333, 550},
{333, 551},
{333, 552},
{333, 553},
{333, 554},
{333, 190},
{347, 915},
{0, 0},
{0, 0},
{0, 0},
{347, 915},
{0, 0},
{347, 915},
{347, 915},
{0, 0},
{347, 915},
{333, 202},
{333, 210},
{0, 0},
{0, 0},
{0, 0},
{347, 915},
{347, 915},
{347, 915},
{347, 915},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{347, 915},
{347, 915},
{347, 915},
{347, 915},
{347, 915},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{347, 915},
{347, 915},
{365, 862},
{347, 915},
{347, 915},
{347, 915},
{347, 915},
{347, 915},
{347, 915},
{347, 915},
{0, 0},
{347, 915},
{0, 0},
{0, 0},
{347, 915},
{0, 0},
{347, 915},
{347, 915},
{347, 915},
{0, 0},
{0, 0},
{0, 0},
{347, 915},
{0, 0},
{347, 915},
{347, 915},
{347, 915},
{347, 915},
{347, 915},
{347, 915},
{347, 915},
{0, 0},
{0, 0},
{365, 862},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{365, 862},
{365, 862},
{347, 915},
{347, 915},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{365, 862},
{365, 862},
{0, 0},
{365, 862},
{396, 6},
{396, 9},
{396, 12},
{396, 15},
{0, 0},
{396, 18},
{365, 862},
{365, 862},
{365, 862},
{365, 862},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{365, 862},
{0, 0},
{365, 862},
{396, 479},
{365, 862},
{365, 862},
{365, 862},
{0, 0},
{0, 0},
{396, 30},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{365, 862},
{0, 0},
{0, 0},
{0, 0},
{365, 862},
{365, 862},
{0, 0},
{365, 862},
{365, 862},
{365, 862},
{365, 862},
{365, 862},
{365, 862},
{0, 0},
{396, 31},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{365, 862},
{365, 862},
{396, 34},
{396, 35},
{397, 984},
{397, 984},
{397, 984},
{397, 984},
{397, 984},
{397, 984},
{397, 984},
{397, 984},
{397, 984},
{397, 984},
{397, 984},
{397, 984},
{397, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{397, 984},
{0, 0},
{0, 0},
{396, 37},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{397, 984},
{0, 0},
{397, 984},
{0, 0},
{397, 984},
{0, 0},
{397, 984},
{0, 0},
{396, 40},
{396, 43},
{448, 1051},
{0, 0},
{448, 1051},
{448, 1051},
{448, 1051},
{448, 1051},
{0, 0},
{448, 1051},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{397, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{397, 984},
{0, 0},
{0, 0},
{397, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{448, 1051},
{448, 1046},
{0, 0},
{397, 984},
{406, 967},
{0, 0},
{448, 1051},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{397, 984},
{406, 967},
{406, 967},
{406, 967},
{406, 967},
{406, 967},
{406, 967},
{406, 967},
{406, 967},
{406, 967},
{406, 967},
{406, 967},
{406, 967},
{406, 967},
{448, 1051},
{0, 0},
{406, 64},
{406, 967},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{448, 1051},
{448, 1051},
{0, 0},
{0, 0},
{0, 0},
{406, 967},
{0, 0},
{406, 967},
{0, 0},
{406, 967},
{0, 0},
{406, 967},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{448, 1051},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{448, 1051},
{448, 1051},
{406, 967},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{406, 967},
{0, 0},
{0, 0},
{406, 967},
{0, 0},
{0, 0},
{0, 0},
{448, 1051},
{448, 1051},
{0, 0},
{0, 0},
{406, 967},
{437, 960},
{437, 960},
{437, 960},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{406, 967},
{0, 0},
{0, 0},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{0, 0},
{437, 438},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{437, 960},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{437, 960},
{0, 0},
{437, 960},
{0, 0},
{437, 960},
{0, 0},
{437, 960},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{437, 960},
{437, 960},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{437, 960},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{437, 960},
{0, 0},
{0, 0},
{437, 960},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{437, 960},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{437, 960},
{440, 984},
{440, 984},
{440, 984},
{440, 984},
{440, 984},
{440, 984},
{440, 984},
{440, 984},
{440, 984},
{440, 984},
{440, 984},
{440, 984},
{440, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 984},
{0, 0},
{0, 0},
{440, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 984},
{0, 0},
{440, 984},
{0, 0},
{440, 984},
{0, 0},
{440, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 984},
{0, 0},
{0, 0},
{440, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 984},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 984},
{449, 986},
{449, 986},
{449, 986},
{449, 986},
{449, 986},
{449, 986},
{449, 986},
{449, 986},
{449, 986},
{449, 986},
{449, 986},
{449, 986},
{449, 986},
{453, 780},
{0, 0},
{453, 780},
{0, 0},
{0, 0},
{0, 0},
{449, 986},
{0, 0},
{449, 67},
{449, 986},
{0, 0},
{453, 780},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 986},
{0, 0},
{449, 986},
{0, 0},
{449, 986},
{0, 0},
{449, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 442},
{0, 0},
{0, 0},
{453, 780},
{0, 0},
{0, 0},
{0, 0},
{453, 780},
{449, 986},
{453, 780},
{453, 780},
{0, 0},
{453, 780},
{449, 986},
{0, 0},
{0, 0},
{449, 986},
{0, 0},
{453, 780},
{453, 780},
{453, 780},
{453, 780},
{0, 0},
{0, 0},
{449, 986},
{0, 0},
{0, 0},
{453, 780},
{453, 780},
{453, 780},
{453, 780},
{453, 780},
{0, 0},
{449, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{453, 780},
{453, 780},
{0, 0},
{453, 780},
{453, 780},
{453, 780},
{453, 780},
{453, 780},
{453, 780},
{453, 780},
{456, 779},
{453, 780},
{456, 779},
{0, 0},
{453, 780},
{0, 0},
{453, 780},
{453, 780},
{453, 780},
{0, 0},
{0, 0},
{456, 779},
{453, 780},
{0, 0},
{453, 780},
{453, 780},
{453, 780},
{453, 780},
{453, 780},
{453, 780},
{453, 780},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{453, 780},
{453, 780},
{456, 779},
{0, 0},
{0, 0},
{0, 0},
{456, 779},
{0, 0},
{456, 779},
{456, 779},
{0, 0},
{456, 779},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{456, 779},
{456, 779},
{456, 779},
{456, 779},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{456, 779},
{456, 779},
{456, 779},
{456, 779},
{456, 779},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{456, 779},
{456, 779},
{0, 0},
{456, 779},
{456, 779},
{456, 779},
{456, 779},
{456, 779},
{456, 779},
{456, 779},
{0, 0},
{456, 779},
{0, 0},
{0, 0},
{456, 779},
{0, 0},
{456, 779},
{456, 779},
{456, 779},
{0, 0},
{0, 0},
{0, 0},
{456, 779},
{0, 0},
{456, 779},
{456, 779},
{456, 779},
{456, 779},
{456, 779},
{456, 779},
{456, 779},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{456, 779},
{456, 779},
{0, 0},
{0, 0},
};
static	unsigned short	yyNComb		[yyNTableMax - yyLastTerminal] = {
735,
458,
736,
459,
105,
738,
739,
740,
108,
219,
226,
115,
118,
659,
660,
661,
662,
128,
134,
664,
665,
666,
667,
141,
146,
157,
668,
669,
670,
671,
672,
231,
160,
150,
149,
675,
676,
136,
235,
730,
239,
429,
428,
249,
682,
454,
635,
166,
171,
173,
149,
729,
728,
259,
235,
267,
642,
72,
643,
249,
680,
122,
728,
176,
165,
188,
276,
180,
182,
184,
688,
689,
104,
192,
52,
119,
195,
291,
451,
635,
620,
651,
650,
321,
328,
200,
29,
198,
204,
208,
221,
46,
224,
227,
230,
236,
644,
244,
246,
254,
256,
620,
24,
683,
232,
54,
8,
52,
11,
313,
14,
81,
278,
620,
615,
616,
623,
622,
285,
632,
57,
60,
633,
63,
66,
69,
77,
78,
639,
80,
70,
79,
637,
412,
620,
615,
616,
623,
54,
131,
615,
616,
615,
616,
615,
616,
652,
615,
616,
240,
250,
284,
632,
57,
60,
633,
63,
66,
69,
77,
287,
639,
80,
70,
450,
637,
290,
52,
615,
616,
623,
653,
261,
263,
33,
617,
293,
618,
408,
400,
265,
690,
684,
617,
275,
618,
684,
269,
271,
273,
691,
624,
300,
24,
620,
693,
694,
305,
54,
619,
621,
625,
25,
308,
627,
615,
616,
623,
615,
616,
620,
94,
632,
57,
60,
633,
63,
66,
69,
77,
699,
639,
80,
70,
24,
637,
48,
620,
615,
616,
623,
617,
24,
618,
628,
95,
615,
616,
623,
629,
315,
39,
318,
320,
615,
616,
623,
626,
324,
641,
57,
96,
327,
97,
52,
326,
336,
339,
620,
342,
337,
615,
616,
622,
347,
358,
702,
623,
615,
616,
364,
652,
366,
615,
616,
615,
616,
370,
376,
380,
24,
620,
384,
391,
401,
82,
409,
413,
418,
194,
420,
446,
615,
616,
623,
617,
653,
618,
731,
89,
57,
60,
633,
63,
449,
69,
77,
332,
639,
80,
70,
733,
637,
430,
432,
615,
616,
623,
24,
52,
453,
652,
620,
456,
48,
460,
54,
0,
0,
0,
615,
616,
623,
0,
0,
0,
331,
0,
0,
447,
632,
57,
60,
633,
398,
66,
448,
734,
389,
681,
54,
70,
52,
637,
379,
383,
615,
616,
623,
0,
50,
635,
0,
0,
632,
57,
60,
633,
406,
66,
69,
77,
0,
639,
80,
70,
332,
637,
0,
620,
615,
616,
623,
440,
0,
712,
713,
337,
346,
52,
0,
0,
0,
704,
630,
0,
0,
89,
57,
60,
633,
63,
441,
69,
77,
0,
639,
80,
70,
0,
637,
337,
348,
615,
616,
623,
620,
704,
387,
0,
54,
0,
52,
337,
348,
0,
0,
0,
0,
704,
0,
0,
0,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
620,
615,
616,
623,
54,
0,
0,
337,
390,
0,
0,
631,
0,
704,
0,
0,
0,
0,
632,
57,
60,
633,
63,
66,
69,
77,
54,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
0,
0,
52,
632,
57,
60,
633,
63,
66,
54,
717,
631,
0,
0,
70,
0,
637,
0,
0,
0,
0,
623,
0,
632,
57,
60,
633,
63,
66,
620,
732,
0,
0,
54,
70,
0,
637,
0,
0,
52,
0,
623,
0,
0,
631,
0,
56,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
620,
0,
0,
0,
54,
0,
52,
0,
0,
0,
0,
631,
0,
0,
617,
0,
618,
59,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
125,
637,
0,
620,
615,
616,
623,
54,
0,
52,
0,
620,
0,
0,
0,
0,
0,
0,
0,
0,
62,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
24,
637,
0,
620,
615,
616,
623,
54,
74,
0,
0,
0,
615,
616,
623,
0,
0,
0,
0,
0,
68,
632,
57,
60,
633,
63,
66,
69,
77,
54,
639,
80,
70,
0,
637,
0,
52,
615,
616,
623,
0,
0,
0,
632,
57,
60,
633,
63,
66,
0,
634,
0,
0,
0,
70,
0,
637,
655,
656,
657,
658,
623,
0,
620,
0,
0,
0,
82,
0,
0,
289,
262,
0,
0,
0,
0,
0,
435,
0,
0,
0,
89,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
95,
0,
615,
616,
623,
0,
0,
76,
635,
0,
394,
0,
267,
0,
641,
57,
96,
0,
97,
0,
0,
0,
0,
276,
436,
0,
0,
688,
689,
0,
0,
0,
623,
0,
291,
0,
52,
620,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
398,
66,
69,
77,
620,
639,
80,
70,
54,
637,
314,
0,
615,
616,
623,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
63,
66,
69,
77,
54,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
0,
0,
0,
632,
57,
60,
633,
63,
66,
54,
636,
631,
0,
0,
70,
617,
637,
618,
0,
0,
0,
623,
0,
632,
57,
60,
633,
63,
66,
54,
638,
110,
0,
0,
70,
0,
637,
631,
112,
52,
0,
623,
620,
632,
57,
60,
633,
63,
66,
0,
640,
0,
0,
0,
70,
0,
637,
0,
0,
0,
0,
623,
0,
0,
24,
52,
620,
0,
0,
0,
54,
0,
0,
0,
0,
631,
615,
616,
623,
0,
0,
0,
0,
84,
632,
57,
60,
633,
63,
66,
69,
77,
620,
639,
80,
70,
54,
637,
0,
0,
615,
616,
623,
52,
0,
0,
0,
0,
631,
86,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
0,
620,
0,
0,
0,
54,
0,
52,
0,
0,
0,
0,
631,
0,
0,
0,
0,
0,
88,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
620,
615,
616,
623,
54,
0,
52,
0,
0,
0,
0,
0,
0,
0,
617,
0,
618,
91,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
624,
637,
0,
620,
615,
616,
623,
54,
0,
0,
648,
25,
0,
617,
0,
618,
0,
0,
0,
0,
93,
632,
57,
60,
633,
63,
66,
69,
77,
110,
639,
80,
70,
24,
637,
111,
116,
615,
616,
623,
620,
617,
0,
618,
0,
615,
616,
623,
0,
0,
0,
0,
0,
126,
0,
0,
0,
298,
264,
0,
0,
0,
24,
0,
0,
0,
0,
0,
620,
0,
0,
0,
0,
0,
615,
616,
623,
0,
0,
0,
692,
299,
95,
0,
0,
0,
0,
0,
0,
0,
24,
0,
0,
0,
0,
0,
641,
57,
96,
0,
97,
0,
615,
616,
623,
654,
0,
0,
655,
656,
657,
658,
219,
226,
623,
0,
659,
660,
661,
662,
433,
229,
664,
665,
666,
667,
270,
0,
0,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
131,
0,
95,
617,
0,
618,
0,
272,
259,
0,
267,
0,
0,
155,
0,
0,
641,
57,
96,
624,
97,
276,
0,
0,
0,
688,
689,
0,
52,
649,
25,
95,
291,
0,
623,
620,
0,
0,
321,
328,
645,
0,
0,
0,
0,
641,
57,
96,
0,
97,
0,
0,
24,
0,
0,
620,
0,
24,
0,
82,
0,
0,
139,
623,
615,
616,
623,
0,
52,
615,
616,
623,
0,
632,
57,
60,
633,
63,
66,
69,
77,
646,
639,
80,
70,
617,
637,
618,
0,
615,
616,
623,
0,
0,
0,
620,
0,
0,
0,
54,
0,
178,
0,
0,
647,
0,
0,
144,
0,
52,
0,
0,
620,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
0,
0,
24,
52,
620,
0,
0,
0,
54,
0,
0,
0,
0,
0,
615,
616,
623,
0,
0,
0,
0,
0,
632,
57,
60,
633,
63,
66,
69,
77,
620,
639,
80,
70,
54,
637,
0,
0,
615,
616,
623,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
654,
0,
0,
655,
656,
657,
658,
219,
226,
0,
0,
659,
660,
661,
662,
427,
229,
664,
665,
666,
667,
274,
0,
0,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
95,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
641,
57,
96,
0,
97,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
623,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
654,
0,
0,
655,
656,
657,
658,
219,
226,
24,
0,
659,
660,
661,
662,
726,
229,
664,
665,
666,
667,
615,
616,
623,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
426,
235,
0,
239,
0,
0,
249,
682,
0,
617,
0,
618,
0,
0,
177,
0,
259,
0,
267,
164,
0,
0,
0,
0,
0,
624,
0,
0,
0,
276,
0,
0,
0,
688,
689,
649,
25,
0,
0,
0,
291,
0,
52,
620,
0,
0,
321,
328,
0,
0,
0,
0,
181,
0,
0,
0,
0,
0,
24,
617,
0,
618,
0,
0,
0,
24,
0,
0,
0,
620,
615,
616,
623,
54,
0,
302,
0,
615,
616,
623,
52,
0,
0,
0,
0,
183,
620,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
0,
620,
24,
0,
0,
54,
0,
52,
0,
0,
0,
0,
185,
0,
615,
616,
623,
0,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
620,
615,
616,
623,
54,
0,
52,
0,
0,
0,
0,
187,
0,
0,
617,
0,
618,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
700,
637,
0,
620,
615,
616,
623,
54,
0,
52,
0,
620,
0,
0,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
24,
637,
0,
620,
615,
616,
623,
54,
0,
0,
0,
0,
615,
616,
623,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
654,
0,
0,
655,
656,
657,
658,
219,
226,
0,
0,
659,
660,
661,
662,
425,
229,
664,
665,
666,
667,
0,
0,
0,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
617,
0,
618,
617,
0,
618,
0,
259,
0,
267,
0,
0,
206,
0,
0,
280,
298,
0,
0,
298,
276,
0,
0,
0,
688,
689,
0,
620,
0,
0,
620,
291,
0,
0,
620,
0,
0,
321,
328,
692,
299,
0,
692,
299,
0,
0,
0,
0,
0,
24,
0,
0,
24,
0,
0,
0,
24,
0,
0,
0,
0,
615,
616,
623,
615,
616,
623,
0,
615,
616,
623,
654,
0,
0,
655,
656,
657,
658,
219,
226,
0,
0,
659,
660,
661,
662,
423,
229,
664,
665,
666,
667,
0,
0,
0,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
215,
0,
697,
0,
698,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
306,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
52,
620,
0,
0,
291,
214,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
24,
220,
0,
0,
620,
0,
24,
0,
54,
0,
52,
0,
615,
616,
623,
725,
0,
0,
615,
616,
623,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
620,
615,
616,
623,
54,
0,
52,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
620,
615,
616,
623,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
617,
0,
618,
0,
632,
57,
60,
633,
63,
66,
69,
77,
295,
639,
80,
70,
298,
637,
0,
0,
615,
616,
623,
655,
656,
657,
658,
620,
0,
0,
416,
0,
0,
0,
0,
0,
417,
0,
0,
692,
299,
724,
419,
635,
0,
0,
0,
0,
0,
24,
617,
0,
618,
0,
0,
0,
0,
0,
0,
0,
0,
615,
616,
623,
0,
0,
303,
0,
0,
0,
0,
394,
0,
267,
0,
0,
0,
620,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
695,
304,
0,
0,
291,
0,
0,
620,
24,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
615,
616,
623,
0,
0,
632,
57,
60,
633,
398,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
654,
0,
0,
655,
656,
657,
658,
219,
226,
0,
0,
659,
660,
661,
662,
228,
229,
664,
665,
666,
667,
0,
0,
0,
668,
669,
670,
671,
672,
231,
0,
54,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
632,
57,
60,
633,
63,
66,
259,
716,
267,
0,
0,
70,
0,
637,
0,
0,
0,
0,
623,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
654,
0,
0,
655,
656,
657,
658,
219,
226,
24,
0,
659,
660,
661,
662,
663,
229,
664,
665,
666,
667,
615,
616,
623,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
654,
0,
0,
655,
656,
657,
658,
219,
226,
24,
0,
659,
660,
661,
662,
673,
229,
664,
665,
666,
667,
615,
616,
623,
668,
669,
670,
671,
672,
231,
234,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
654,
0,
0,
655,
656,
657,
658,
219,
226,
24,
0,
659,
660,
661,
662,
674,
229,
664,
665,
666,
667,
615,
616,
623,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
654,
0,
0,
655,
656,
657,
658,
219,
226,
24,
0,
659,
660,
661,
662,
238,
229,
664,
665,
666,
667,
615,
616,
623,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
617,
0,
618,
0,
0,
0,
0,
259,
0,
267,
655,
656,
657,
658,
0,
0,
303,
0,
0,
0,
276,
0,
0,
243,
688,
689,
0,
620,
0,
0,
677,
291,
0,
678,
620,
0,
0,
321,
328,
0,
0,
696,
304,
0,
0,
239,
407,
721,
0,
24,
0,
0,
0,
0,
245,
0,
24,
0,
404,
0,
267,
615,
616,
623,
0,
0,
0,
0,
615,
616,
623,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
617,
0,
618,
0,
632,
57,
60,
633,
406,
66,
69,
77,
310,
639,
80,
70,
298,
637,
0,
0,
615,
616,
623,
655,
656,
657,
658,
620,
0,
617,
0,
618,
0,
0,
0,
0,
243,
0,
0,
692,
299,
360,
0,
677,
0,
298,
678,
0,
0,
24,
0,
0,
0,
0,
0,
0,
620,
0,
239,
0,
679,
615,
616,
623,
0,
0,
0,
245,
692,
299,
0,
404,
0,
267,
0,
0,
0,
0,
24,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
615,
616,
623,
0,
0,
291,
0,
0,
620,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
406,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
654,
0,
0,
655,
656,
657,
658,
219,
226,
0,
0,
659,
660,
661,
662,
248,
229,
664,
665,
666,
667,
0,
0,
0,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
655,
656,
657,
658,
0,
0,
0,
265,
0,
684,
681,
0,
0,
253,
0,
255,
369,
24,
0,
0,
677,
0,
0,
0,
710,
0,
0,
0,
0,
615,
616,
623,
0,
0,
0,
0,
0,
54,
249,
682,
399,
719,
0,
0,
373,
714,
715,
713,
394,
0,
267,
632,
57,
60,
633,
63,
66,
0,
717,
0,
0,
276,
70,
0,
637,
688,
689,
0,
0,
623,
0,
0,
291,
0,
0,
620,
0,
0,
0,
397,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
398,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
655,
656,
657,
658,
0,
0,
0,
0,
0,
0,
681,
0,
0,
253,
0,
255,
369,
0,
0,
0,
677,
0,
0,
0,
710,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
249,
682,
0,
711,
0,
0,
373,
714,
715,
713,
394,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
0,
397,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
398,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
654,
0,
0,
655,
656,
657,
658,
219,
226,
0,
0,
659,
660,
661,
662,
258,
229,
664,
665,
666,
667,
0,
0,
0,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
685,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
52,
0,
0,
0,
291,
686,
0,
620,
0,
0,
321,
328,
0,
0,
0,
283,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
620,
0,
24,
0,
54,
0,
52,
0,
0,
0,
0,
0,
0,
0,
615,
616,
623,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
620,
615,
616,
623,
54,
0,
0,
0,
0,
0,
0,
0,
0,
655,
656,
657,
658,
0,
632,
57,
60,
633,
63,
66,
69,
77,
289,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
0,
0,
655,
656,
657,
658,
0,
0,
0,
0,
0,
0,
0,
0,
0,
289,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
354,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
259,
620,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
687,
0,
0,
688,
689,
0,
0,
0,
0,
24,
291,
0,
0,
620,
0,
0,
0,
0,
0,
314,
0,
615,
616,
623,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
24,
0,
0,
0,
0,
0,
0,
0,
0,
0,
314,
0,
615,
616,
623,
654,
0,
0,
655,
656,
657,
658,
219,
226,
0,
0,
659,
660,
661,
662,
317,
229,
664,
665,
666,
667,
0,
0,
0,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
319,
635,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
52,
0,
0,
291,
323,
635,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
620,
24,
0,
0,
54,
0,
52,
0,
0,
0,
0,
701,
0,
615,
616,
623,
0,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
620,
615,
616,
623,
54,
0,
52,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
620,
615,
616,
623,
54,
0,
0,
0,
0,
0,
0,
0,
0,
655,
656,
657,
658,
0,
632,
57,
60,
633,
63,
66,
69,
77,
335,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
655,
656,
657,
658,
0,
0,
0,
0,
259,
0,
267,
0,
0,
335,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
0,
337,
340,
345,
706,
0,
0,
704,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
24,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
615,
616,
623,
291,
0,
0,
620,
0,
0,
0,
337,
340,
0,
703,
0,
0,
704,
0,
0,
654,
0,
0,
655,
656,
657,
658,
219,
226,
24,
0,
659,
660,
661,
662,
344,
229,
664,
665,
666,
667,
615,
616,
623,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
655,
656,
657,
658,
0,
0,
0,
0,
259,
0,
267,
0,
0,
335,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
350,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
24,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
52,
615,
616,
623,
291,
707,
0,
620,
0,
0,
0,
337,
340,
0,
705,
0,
0,
704,
0,
0,
0,
0,
0,
0,
0,
0,
0,
620,
0,
24,
0,
54,
0,
52,
0,
352,
709,
0,
350,
0,
0,
615,
616,
623,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
620,
615,
616,
623,
54,
0,
52,
0,
0,
0,
0,
0,
0,
0,
0,
0,
685,
0,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
620,
615,
616,
623,
54,
0,
0,
0,
0,
708,
0,
52,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
63,
66,
69,
77,
363,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
0,
620,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
655,
656,
657,
658,
631,
632,
57,
60,
633,
63,
66,
69,
77,
289,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
0,
0,
0,
0,
0,
0,
0,
0,
52,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
620,
0,
276,
367,
54,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
443,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
0,
24,
0,
0,
0,
0,
0,
0,
0,
0,
0,
314,
0,
615,
616,
623,
654,
0,
0,
655,
656,
657,
658,
219,
226,
0,
0,
659,
660,
661,
662,
372,
229,
664,
665,
666,
667,
0,
0,
0,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
654,
0,
0,
655,
656,
657,
658,
219,
226,
24,
0,
659,
660,
661,
662,
378,
229,
664,
665,
666,
667,
615,
616,
623,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
654,
0,
0,
655,
656,
657,
658,
219,
226,
24,
0,
659,
660,
661,
662,
382,
229,
664,
665,
666,
667,
615,
616,
623,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
654,
0,
0,
655,
656,
657,
658,
219,
226,
24,
0,
659,
660,
661,
662,
386,
229,
664,
665,
666,
667,
615,
616,
623,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
654,
0,
0,
655,
656,
657,
658,
219,
226,
24,
0,
659,
660,
661,
662,
393,
229,
664,
665,
666,
667,
615,
616,
623,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
655,
656,
657,
658,
0,
0,
0,
0,
0,
0,
681,
0,
0,
253,
0,
255,
369,
24,
0,
0,
677,
0,
0,
0,
710,
0,
0,
0,
0,
615,
616,
623,
0,
0,
0,
0,
0,
0,
249,
682,
0,
718,
0,
0,
373,
714,
715,
713,
394,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
0,
397,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
398,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
655,
656,
657,
658,
0,
0,
0,
0,
0,
0,
681,
0,
0,
253,
0,
255,
369,
0,
0,
0,
677,
0,
0,
0,
710,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
249,
682,
0,
403,
0,
0,
373,
714,
715,
713,
394,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
0,
397,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
398,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
655,
656,
657,
658,
0,
0,
0,
0,
0,
0,
0,
0,
0,
243,
0,
0,
0,
0,
0,
0,
677,
0,
0,
678,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
239,
0,
720,
0,
0,
0,
0,
0,
0,
245,
0,
0,
0,
404,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
406,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
655,
656,
657,
658,
0,
0,
0,
0,
0,
0,
0,
0,
0,
243,
0,
0,
0,
0,
0,
0,
677,
0,
0,
678,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
239,
0,
411,
0,
0,
0,
0,
0,
0,
245,
0,
0,
0,
404,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
406,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
654,
0,
0,
655,
656,
657,
658,
219,
226,
0,
0,
659,
660,
661,
662,
415,
229,
664,
665,
666,
667,
0,
0,
0,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
655,
656,
657,
658,
0,
0,
0,
0,
259,
0,
267,
0,
0,
417,
0,
0,
0,
0,
723,
419,
635,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
394,
0,
267,
0,
0,
0,
0,
0,
0,
24,
0,
0,
0,
276,
631,
0,
0,
688,
689,
0,
0,
615,
616,
623,
291,
0,
0,
620,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
52,
0,
0,
632,
57,
60,
633,
398,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
655,
656,
657,
658,
0,
620,
0,
0,
0,
54,
0,
0,
0,
417,
0,
0,
0,
0,
722,
419,
635,
0,
445,
632,
57,
60,
633,
63,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
0,
0,
0,
0,
0,
0,
394,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
632,
57,
60,
633,
398,
66,
69,
77,
0,
639,
80,
70,
0,
637,
0,
0,
615,
616,
623,
654,
0,
0,
655,
656,
657,
658,
219,
226,
0,
0,
659,
660,
661,
662,
422,
229,
664,
665,
666,
667,
0,
0,
0,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
654,
0,
0,
655,
656,
657,
658,
219,
226,
24,
0,
659,
660,
661,
662,
727,
229,
664,
665,
666,
667,
615,
616,
623,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
737,
0,
736,
459,
0,
738,
739,
740,
0,
219,
226,
24,
0,
659,
660,
661,
662,
0,
0,
664,
665,
666,
667,
615,
616,
623,
668,
669,
670,
671,
672,
231,
0,
0,
149,
675,
676,
0,
235,
0,
239,
0,
0,
249,
682,
0,
0,
0,
0,
0,
0,
0,
0,
259,
0,
267,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
276,
0,
0,
0,
688,
689,
0,
0,
0,
0,
0,
291,
0,
0,
620,
0,
0,
321,
328,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
24,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
615,
616,
623,
0,
};
static	yyTCombType *	yyTBasePtr	[yyLastReadState + 1] = {
& yyTComb [0],
& yyTComb [0],
& yyTComb [8],
& yyTComb [0],
& yyTComb [100],
& yyTComb [1],
& yyTComb [179],
& yyTComb [0],
& yyTComb [2],
& yyTComb [258],
& yyTComb [0],
& yyTComb [3],
& yyTComb [337],
& yyTComb [0],
& yyTComb [4],
& yyTComb [416],
& yyTComb [0],
& yyTComb [0],
& yyTComb [495],
& yyTComb [5],
& yyTComb [0],
& yyTComb [1],
& yyTComb [1],
& yyTComb [0],
& yyTComb [0],
& yyTComb [547],
& yyTComb [3],
& yyTComb [6],
& yyTComb [0],
& yyTComb [17],
& yyTComb [0],
& yyTComb [592],
& yyTComb [0],
& yyTComb [18],
& yyTComb [0],
& yyTComb [0],
& yyTComb [100],
& yyTComb [671],
& yyTComb [179],
& yyTComb [19],
& yyTComb [0],
& yyTComb [15],
& yyTComb [0],
& yyTComb [22],
& yyTComb [12],
& yyTComb [22],
& yyTComb [2],
& yyTComb [26],
& yyTComb [24],
& yyTComb [0],
& yyTComb [24],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [750],
& yyTComb [0],
& yyTComb [25],
& yyTComb [829],
& yyTComb [0],
& yyTComb [26],
& yyTComb [908],
& yyTComb [0],
& yyTComb [27],
& yyTComb [987],
& yyTComb [22],
& yyTComb [35],
& yyTComb [1066],
& yyTComb [0],
& yyTComb [30],
& yyTComb [0],
& yyTComb [1075],
& yyTComb [107],
& yyTComb [0],
& yyTComb [0],
& yyTComb [34],
& yyTComb [0],
& yyTComb [47],
& yyTComb [1175],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1230],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [32],
& yyTComb [0],
& yyTComb [46],
& yyTComb [0],
& yyTComb [37],
& yyTComb [1273],
& yyTComb [0],
& yyTComb [18],
& yyTComb [0],
& yyTComb [45],
& yyTComb [55],
& yyTComb [75],
& yyTComb [54],
& yyTComb [76],
& yyTComb [3],
& yyTComb [3],
& yyTComb [0],
& yyTComb [4],
& yyTComb [6],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1],
& yyTComb [55],
& yyTComb [0],
& yyTComb [2],
& yyTComb [60],
& yyTComb [0],
& yyTComb [0],
& yyTComb [258],
& yyTComb [135],
& yyTComb [0],
& yyTComb [337],
& yyTComb [3],
& yyTComb [78],
& yyTComb [0],
& yyTComb [99],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [109],
& yyTComb [0],
& yyTComb [5],
& yyTComb [0],
& yyTComb [110],
& yyTComb [112],
& yyTComb [8],
& yyTComb [0],
& yyTComb [1306],
& yyTComb [81],
& yyTComb [0],
& yyTComb [1],
& yyTComb [0],
& yyTComb [98],
& yyTComb [0],
& yyTComb [1385],
& yyTComb [0],
& yyTComb [0],
& yyTComb [16],
& yyTComb [0],
& yyTComb [9],
& yyTComb [0],
& yyTComb [84],
& yyTComb [0],
& yyTComb [1464],
& yyTComb [0],
& yyTComb [18],
& yyTComb [94],
& yyTComb [0],
& yyTComb [136],
& yyTComb [0],
& yyTComb [11],
& yyTComb [107],
& yyTComb [0],
& yyTComb [159],
& yyTComb [20],
& yyTComb [159],
& yyTComb [123],
& yyTComb [182],
& yyTComb [0],
& yyTComb [172],
& yyTComb [13],
& yyTComb [144],
& yyTComb [145],
& yyTComb [0],
& yyTComb [1543],
& yyTComb [0],
& yyTComb [1622],
& yyTComb [24],
& yyTComb [0],
& yyTComb [0],
& yyTComb [147],
& yyTComb [182],
& yyTComb [109],
& yyTComb [0],
& yyTComb [157],
& yyTComb [0],
& yyTComb [176],
& yyTComb [0],
& yyTComb [186],
& yyTComb [0],
& yyTComb [0],
& yyTComb [206],
& yyTComb [0],
& yyTComb [117],
& yyTComb [223],
& yyTComb [156],
& yyTComb [188],
& yyTComb [194],
& yyTComb [219],
& yyTComb [128],
& yyTComb [130],
& yyTComb [221],
& yyTComb [205],
& yyTComb [224],
& yyTComb [207],
& yyTComb [167],
& yyTComb [0],
& yyTComb [216],
& yyTComb [0],
& yyTComb [216],
& yyTComb [0],
& yyTComb [235],
& yyTComb [0],
& yyTComb [244],
& yyTComb [142],
& yyTComb [136],
& yyTComb [0],
& yyTComb [223],
& yyTComb [224],
& yyTComb [142],
& yyTComb [233],
& yyTComb [235],
& yyTComb [581],
& yyTComb [0],
& yyTComb [255],
& yyTComb [1672],
& yyTComb [0],
& yyTComb [256],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1739],
& yyTComb [257],
& yyTComb [0],
& yyTComb [281],
& yyTComb [0],
& yyTComb [1818],
& yyTComb [1881],
& yyTComb [282],
& yyTComb [0],
& yyTComb [284],
& yyTComb [0],
& yyTComb [284],
& yyTComb [0],
& yyTComb [1971],
& yyTComb [2037],
& yyTComb [2137],
& yyTComb [0],
& yyTComb [293],
& yyTComb [0],
& yyTComb [287],
& yyTComb [0],
& yyTComb [289],
& yyTComb [300],
& yyTComb [2213],
& yyTComb [2279],
& yyTComb [262],
& yyTComb [0],
& yyTComb [305],
& yyTComb [0],
& yyTComb [300],
& yyTComb [0],
& yyTComb [300],
& yyTComb [371],
& yyTComb [312],
& yyTComb [0],
& yyTComb [285],
& yyTComb [0],
& yyTComb [286],
& yyTComb [291],
& yyTComb [323],
& yyTComb [411],
& yyTComb [217],
& yyTComb [0],
& yyTComb [294],
& yyTComb [0],
& yyTComb [295],
& yyTComb [341],
& yyTComb [298],
& yyTComb [346],
& yyTComb [277],
& yyTComb [0],
& yyTComb [301],
& yyTComb [0],
& yyTComb [303],
& yyTComb [270],
& yyTComb [0],
& yyTComb [305],
& yyTComb [0],
& yyTComb [332],
& yyTComb [0],
& yyTComb [0],
& yyTComb [282],
& yyTComb [0],
& yyTComb [373],
& yyTComb [305],
& yyTComb [0],
& yyTComb [354],
& yyTComb [0],
& yyTComb [355],
& yyTComb [360],
& yyTComb [0],
& yyTComb [0],
& yyTComb [362],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [452],
& yyTComb [364],
& yyTComb [397],
& yyTComb [338],
& yyTComb [0],
& yyTComb [374],
& yyTComb [0],
& yyTComb [375],
& yyTComb [375],
& yyTComb [404],
& yyTComb [0],
& yyTComb [0],
& yyTComb [400],
& yyTComb [0],
& yyTComb [331],
& yyTComb [0],
& yyTComb [0],
& yyTComb [449],
& yyTComb [394],
& yyTComb [0],
& yyTComb [418],
& yyTComb [0],
& yyTComb [0],
& yyTComb [418],
& yyTComb [468],
& yyTComb [529],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [2391],
& yyTComb [2470],
& yyTComb [452],
& yyTComb [0],
& yyTComb [419],
& yyTComb [461],
& yyTComb [0],
& yyTComb [459],
& yyTComb [0],
& yyTComb [472],
& yyTComb [413],
& yyTComb [0],
& yyTComb [415],
& yyTComb [445],
& yyTComb [0],
& yyTComb [2537],
& yyTComb [455],
& yyTComb [0],
& yyTComb [503],
& yyTComb [0],
& yyTComb [463],
& yyTComb [0],
& yyTComb [454],
& yyTComb [439],
& yyTComb [419],
& yyTComb [474],
& yyTComb [451],
& yyTComb [462],
& yyTComb [472],
& yyTComb [440],
& yyTComb [0],
& yyTComb [474],
& yyTComb [521],
& yyTComb [2606],
& yyTComb [537],
& yyTComb [521],
& yyTComb [505],
& yyTComb [0],
& yyTComb [525],
& yyTComb [0],
& yyTComb [526],
& yyTComb [509],
& yyTComb [458],
& yyTComb [0],
& yyTComb [534],
& yyTComb [0],
& yyTComb [534],
& yyTComb [0],
& yyTComb [536],
& yyTComb [0],
& yyTComb [536],
& yyTComb [0],
& yyTComb [541],
& yyTComb [0],
& yyTComb [541],
& yyTComb [521],
& yyTComb [518],
& yyTComb [554],
& yyTComb [531],
& yyTComb [552],
& yyTComb [0],
& yyTComb [556],
& yyTComb [567],
& yyTComb [554],
& yyTComb [2654],
& yyTComb [2708],
& yyTComb [706],
& yyTComb [560],
& yyTComb [0],
& yyTComb [563],
& yyTComb [0],
& yyTComb [569],
& yyTComb [666],
& yyTComb [615],
& yyTComb [2785],
& yyTComb [573],
& yyTComb [0],
& yyTComb [578],
& yyTComb [0],
& yyTComb [578],
& yyTComb [0],
& yyTComb [580],
& yyTComb [0],
& yyTComb [580],
& yyTComb [581],
& yyTComb [0],
& yyTComb [593],
& yyTComb [566],
& yyTComb [588],
& yyTComb [0],
& yyTComb [591],
& yyTComb [614],
& yyTComb [599],
& yyTComb [619],
& yyTComb [620],
& yyTComb [621],
& yyTComb [623],
& yyTComb [0],
& yyTComb [633],
& yyTComb [570],
& yyTComb [627],
& yyTComb [630],
& yyTComb [620],
& yyTComb [622],
& yyTComb [623],
& yyTComb [2864],
& yyTComb [613],
& yyTComb [626],
& yyTComb [2941],
& yyTComb [0],
& yyTComb [0],
& yyTComb [602],
& yyTComb [0],
& yyTComb [624],
& yyTComb [631],
& yyTComb [633],
& yyTComb [2757],
& yyTComb [3018],
& yyTComb [634],
& yyTComb [636],
& yyTComb [0],
& yyTComb [3043],
& yyTComb [638],
& yyTComb [0],
& yyTComb [3122],
& yyTComb [662],
& yyTComb [0],
& yyTComb [672],
& yyTComb [676],
};
static	unsigned short*	yyNBasePtr	[yyLastReadState + 1] = {
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-93],
& yyNComb [-114],
& yyNComb [-60],
& yyNComb [-114],
& yyNComb [-88],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-86],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-84],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-23],
& yyNComb [0],
& yyNComb [-114],
& yyNComb [-81],
& yyNComb [-114],
& yyNComb [8],
& yyNComb [-114],
& yyNComb [16],
& yyNComb [33],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [64],
& yyNComb [-114],
& yyNComb [87],
& yyNComb [-114],
& yyNComb [-20],
& yyNComb [-114],
& yyNComb [40],
& yyNComb [45],
& yyNComb [128],
& yyNComb [-114],
& yyNComb [47],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [152],
& yyNComb [185],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [222],
& yyNComb [-114],
& yyNComb [255],
& yyNComb [277],
& yyNComb [297],
& yyNComb [-114],
& yyNComb [321],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [358],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [391],
& yyNComb [-114],
& yyNComb [-113],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [424],
& yyNComb [-114],
& yyNComb [446],
& yyNComb [553],
& yyNComb [-114],
& yyNComb [37],
& yyNComb [484],
& yyNComb [-114],
& yyNComb [579],
& yyNComb [-114],
& yyNComb [-93],
& yyNComb [601],
& yyNComb [621],
& yyNComb [-113],
& yyNComb [641],
& yyNComb [-114],
& yyNComb [682],
& yyNComb [-114],
& yyNComb [708],
& yyNComb [-114],
& yyNComb [746],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [779],
& yyNComb [-114],
& yyNComb [812],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-113],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-113],
& yyNComb [-110],
& yyNComb [-114],
& yyNComb [849],
& yyNComb [-114],
& yyNComb [658],
& yyNComb [-114],
& yyNComb [-112],
& yyNComb [-107],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-106],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [877],
& yyNComb [399],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-101],
& yyNComb [-114],
& yyNComb [992],
& yyNComb [1012],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-100],
& yyNComb [-114],
& yyNComb [-111],
& yyNComb [-95],
& yyNComb [-114],
& yyNComb [1052],
& yyNComb [-114],
& yyNComb [1093],
& yyNComb [-114],
& yyNComb [-111],
& yyNComb [1119],
& yyNComb [-114],
& yyNComb [-94],
& yyNComb [-114],
& yyNComb [1234],
& yyNComb [-98],
& yyNComb [-85],
& yyNComb [-114],
& yyNComb [1325],
& yyNComb [-114],
& yyNComb [-93],
& yyNComb [987],
& yyNComb [-114],
& yyNComb [820],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-86],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [1318],
& yyNComb [-114],
& yyNComb [-71],
& yyNComb [-113],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-70],
& yyNComb [-114],
& yyNComb [-69],
& yyNComb [-114],
& yyNComb [1069],
& yyNComb [-108],
& yyNComb [1351],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-104],
& yyNComb [1389],
& yyNComb [-114],
& yyNComb [1422],
& yyNComb [-114],
& yyNComb [1455],
& yyNComb [-114],
& yyNComb [1488],
& yyNComb [-53],
& yyNComb [-114],
& yyNComb [1603],
& yyNComb [-114],
& yyNComb [-113],
& yyNComb [-42],
& yyNComb [102],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-103],
& yyNComb [-101],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-87],
& yyNComb [-114],
& yyNComb [1596],
& yyNComb [-114],
& yyNComb [-29],
& yyNComb [-114],
& yyNComb [1718],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [1738],
& yyNComb [1771],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [1804],
& yyNComb [-28],
& yyNComb [-114],
& yyNComb [1916],
& yyNComb [-26],
& yyNComb [-114],
& yyNComb [2031],
& yyNComb [-25],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-24],
& yyNComb [2122],
& yyNComb [-14],
& yyNComb [-114],
& yyNComb [2213],
& yyNComb [2304],
& yyNComb [-23],
& yyNComb [-114],
& yyNComb [2395],
& yyNComb [-114],
& yyNComb [31],
& yyNComb [-114],
& yyNComb [2446],
& yyNComb [-114],
& yyNComb [-21],
& yyNComb [2558],
& yyNComb [-20],
& yyNComb [-114],
& yyNComb [2673],
& yyNComb [-114],
& yyNComb [32],
& yyNComb [-114],
& yyNComb [2753],
& yyNComb [-98],
& yyNComb [-19],
& yyNComb [2865],
& yyNComb [-18],
& yyNComb [-114],
& yyNComb [2980],
& yyNComb [-114],
& yyNComb [12],
& yyNComb [1],
& yyNComb [512],
& yyNComb [-114],
& yyNComb [887],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-67],
& yyNComb [16],
& yyNComb [16],
& yyNComb [955],
& yyNComb [-114],
& yyNComb [984],
& yyNComb [-114],
& yyNComb [1197],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-96],
& yyNComb [-63],
& yyNComb [-114],
& yyNComb [1599],
& yyNComb [-114],
& yyNComb [0],
& yyNComb [3000],
& yyNComb [-54],
& yyNComb [3033],
& yyNComb [-114],
& yyNComb [-16],
& yyNComb [3121],
& yyNComb [-114],
& yyNComb [48],
& yyNComb [3147],
& yyNComb [1712],
& yyNComb [1],
& yyNComb [-114],
& yyNComb [1845],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-11],
& yyNComb [-20],
& yyNComb [-13],
& yyNComb [1895],
& yyNComb [1368],
& yyNComb [-15],
& yyNComb [-14],
& yyNComb [-8],
& yyNComb [2388],
& yyNComb [-96],
& yyNComb [28],
& yyNComb [-114],
& yyNComb [2487],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [28],
& yyNComb [1463],
& yyNComb [122],
& yyNComb [-114],
& yyNComb [3262],
& yyNComb [15],
& yyNComb [3283],
& yyNComb [125],
& yyNComb [-114],
& yyNComb [43],
& yyNComb [3316],
& yyNComb [-114],
& yyNComb [54],
& yyNComb [57],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [213],
& yyNComb [3349],
& yyNComb [189],
& yyNComb [-114],
& yyNComb [3437],
& yyNComb [-114],
& yyNComb [138],
& yyNComb [3477],
& yyNComb [-114],
& yyNComb [59],
& yyNComb [-114],
& yyNComb [141],
& yyNComb [62],
& yyNComb [-114],
& yyNComb [3568],
& yyNComb [-114],
& yyNComb [3608],
& yyNComb [146],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [3628],
& yyNComb [-114],
& yyNComb [3661],
& yyNComb [-114],
& yyNComb [3694],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [90],
& yyNComb [-114],
& yyNComb [2516],
& yyNComb [-114],
& yyNComb [152],
& yyNComb [3732],
& yyNComb [-54],
& yyNComb [-114],
& yyNComb [96],
& yyNComb [3820],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [159],
& yyNComb [-114],
& yyNComb [3935],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [220],
& yyNComb [160],
& yyNComb [-114],
& yyNComb [4026],
& yyNComb [-114],
& yyNComb [161],
& yyNComb [-114],
& yyNComb [4117],
& yyNComb [-114],
& yyNComb [164],
& yyNComb [-114],
& yyNComb [4208],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [225],
& yyNComb [258],
& yyNComb [165],
& yyNComb [-114],
& yyNComb [4299],
& yyNComb [-114],
& yyNComb [2711],
& yyNComb [1],
& yyNComb [1980],
& yyNComb [-114],
& yyNComb [33],
& yyNComb [4379],
& yyNComb [166],
& yyNComb [-114],
& yyNComb [4491],
& yyNComb [-114],
& yyNComb [2711],
& yyNComb [1],
& yyNComb [33],
& yyNComb [4603],
& yyNComb [168],
& yyNComb [-114],
& yyNComb [4715],
& yyNComb [-114],
& yyNComb [169],
& yyNComb [-114],
& yyNComb [4830],
& yyNComb [-114],
& yyNComb [4870],
& yyNComb [170],
& yyNComb [4982],
& yyNComb [172],
& yyNComb [-114],
& yyNComb [5097],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [5188],
& yyNComb [-114],
& yyNComb [148],
& yyNComb [195],
& yyNComb [-114],
& yyNComb [164],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [3804],
& yyNComb [-114],
& yyNComb [4912],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [202],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [205],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [-114],
& yyNComb [207],
& yyNComb [5279],
};
static	unsigned short	yyDefault	[yyLastReadState + 1] = {
0,
19,
288,
219,
0,
219,
0,
38,
0,
0,
38,
0,
0,
38,
0,
0,
193,
130,
0,
38,
0,
163,
0,
109,
109,
448,
0,
0,
109,
0,
130,
0,
38,
0,
38,
38,
396,
0,
0,
0,
0,
219,
130,
0,
0,
0,
0,
0,
131,
219,
76,
219,
396,
396,
95,
219,
0,
0,
219,
0,
96,
219,
0,
97,
0,
0,
0,
219,
0,
396,
219,
242,
273,
130,
131,
219,
0,
80,
396,
396,
0,
396,
440,
219,
0,
219,
0,
219,
0,
0,
219,
0,
219,
0,
0,
0,
0,
0,
0,
0,
0,
0,
20,
191,
459,
430,
197,
459,
430,
19,
266,
109,
116,
266,
459,
320,
0,
459,
320,
0,
0,
357,
0,
359,
109,
303,
0,
459,
430,
233,
219,
0,
0,
459,
320,
0,
249,
0,
219,
0,
219,
430,
431,
219,
0,
459,
430,
233,
252,
249,
430,
233,
0,
459,
163,
0,
163,
430,
0,
459,
430,
0,
0,
109,
0,
459,
161,
0,
0,
0,
459,
320,
459,
320,
109,
288,
219,
0,
0,
288,
219,
0,
219,
0,
219,
0,
219,
459,
430,
233,
0,
0,
459,
38,
0,
430,
197,
0,
0,
0,
0,
0,
0,
357,
0,
359,
0,
459,
430,
233,
0,
0,
219,
219,
0,
0,
0,
0,
0,
36,
459,
430,
219,
459,
430,
233,
459,
320,
0,
459,
233,
249,
430,
333,
233,
459,
430,
233,
0,
249,
430,
41,
288,
459,
241,
459,
430,
233,
0,
459,
430,
219,
0,
459,
251,
459,
430,
233,
0,
266,
288,
273,
0,
273,
0,
275,
0,
266,
260,
273,
0,
273,
0,
0,
0,
0,
45,
357,
0,
359,
0,
459,
219,
45,
219,
430,
365,
366,
0,
459,
366,
109,
357,
0,
359,
0,
0,
312,
303,
45,
305,
109,
303,
0,
45,
109,
45,
357,
0,
359,
0,
0,
0,
109,
459,
430,
233,
0,
219,
419,
0,
45,
219,
419,
341,
341,
0,
0,
387,
388,
219,
389,
430,
19,
288,
459,
333,
339,
341,
0,
390,
0,
430,
233,
0,
333,
390,
320,
390,
219,
0,
219,
0,
219,
0,
0,
0,
0,
0,
109,
0,
459,
219,
45,
430,
0,
333,
0,
0,
459,
430,
233,
0,
0,
341,
459,
430,
233,
0,
459,
430,
233,
0,
459,
430,
233,
0,
0,
341,
341,
459,
430,
233,
0,
404,
405,
273,
387,
406,
251,
459,
430,
251,
0,
52,
260,
109,
241,
459,
430,
241,
0,
459,
430,
233,
0,
222,
459,
222,
459,
430,
233,
0,
0,
0,
0,
233,
0,
431,
459,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
326,
449,
219,
0,
219,
0,
0,
0,
0,
0,
0,
454,
459,
320,
0,
459,
320,
0,
0,
0,
1,
};
static	unsigned char	yyLength	[yyLastReduceState - yyFirstReduceState + 1] = {
2,
1,
1,
2,
3,
1,
1,
1,
2,
5,
2,
1,
2,
2,
2,
6,
1,
1,
1,
1,
3,
1,
3,
1,
1,
1,
1,
1,
2,
5,
5,
3,
1,
1,
1,
1,
1,
1,
5,
4,
1,
5,
2,
6,
1,
2,
1,
1,
2,
1,
5,
2,
5,
1,
2,
2,
6,
3,
6,
7,
1,
2,
1,
5,
6,
2,
1,
1,
2,
5,
6,
2,
6,
1,
2,
1,
2,
1,
2,
5,
1,
1,
5,
1,
3,
1,
3,
1,
7,
5,
7,
5,
7,
3,
1,
1,
1,
1,
1,
1,
1,
3,
3,
5,
6,
5,
5,
1,
1,
1,
3,
1,
1,
1,
5,
5,
4,
5,
5,
5,
1,
0,
5,
8,
12,
10,
12,
9,
11,
13,
10,
5,
6,
6,
6,
1,
1,
6,
8,
9,
8,
5,
2,
3,
4,
2,
3,
1,
1,
1,
1,
1,
1,
1,
8,
9,
0,
1,
1,
5,
1,
1,
3,
1,
3,
1,
3,
1,
1,
3,
3,
4,
4,
7,
5,
8,
1,
2,
5,
3,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
1,
3,
0,
1,
1,
3,
1,
3,
2,
3,
2,
3,
1,
0,
1,
1,
4,
7,
5,
5,
1,
1,
1,
5,
4,
4,
7,
8,
4,
1,
1,
1,
4,
4,
7,
2,
2,
2,
3,
1,
1,
1,
1,
3,
3,
4,
3,
1,
1,
1,
1,
4,
1,
3,
3,
2,
2,
1,
4,
4,
6,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
2,
3,
3,
1,
1,
1,
1,
1,
4,
4,
4,
4,
4,
1,
1,
8,
3,
1,
1,
1,
1,
3,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
2,
2,
3,
1,
2,
1,
1,
1,
};
static	yySymbolRange	yyLeftHandSide	[yyLastReduceState - yyFirstReduceState + 1] = {
231,
115,
114,
114,
114,
117,
117,
117,
117,
122,
122,
123,
116,
116,
116,
116,
116,
116,
116,
116,
116,
131,
131,
124,
124,
124,
124,
126,
126,
137,
137,
137,
125,
127,
127,
127,
127,
127,
128,
128,
145,
140,
140,
140,
146,
146,
148,
141,
141,
141,
149,
149,
149,
151,
151,
152,
150,
150,
150,
150,
153,
153,
154,
142,
142,
142,
157,
143,
143,
158,
158,
158,
144,
118,
118,
155,
155,
159,
159,
147,
161,
162,
156,
156,
156,
160,
160,
160,
164,
164,
164,
164,
164,
164,
164,
165,
165,
132,
132,
132,
132,
121,
121,
121,
121,
121,
121,
170,
170,
168,
168,
171,
172,
173,
120,
120,
120,
120,
120,
120,
175,
176,
119,
119,
119,
119,
119,
119,
119,
119,
119,
119,
119,
119,
119,
119,
119,
185,
185,
185,
185,
188,
188,
189,
189,
190,
190,
186,
186,
191,
191,
191,
191,
191,
184,
184,
192,
192,
193,
193,
193,
177,
177,
178,
178,
195,
195,
196,
196,
133,
134,
135,
129,
129,
130,
166,
200,
200,
201,
201,
136,
202,
202,
203,
203,
199,
199,
204,
204,
138,
138,
182,
182,
197,
197,
180,
180,
180,
179,
179,
206,
206,
208,
208,
207,
207,
209,
209,
209,
210,
210,
198,
198,
198,
198,
198,
174,
174,
211,
213,
213,
213,
213,
215,
215,
212,
212,
217,
217,
217,
217,
139,
139,
139,
139,
139,
139,
139,
223,
222,
222,
214,
214,
219,
219,
219,
219,
219,
219,
219,
219,
219,
219,
219,
219,
219,
219,
219,
218,
218,
218,
218,
218,
218,
220,
220,
220,
220,
220,
220,
220,
220,
220,
220,
220,
220,
220,
220,
220,
220,
220,
220,
220,
220,
224,
224,
221,
221,
221,
225,
225,
225,
225,
225,
225,
225,
225,
225,
225,
226,
227,
181,
181,
183,
183,
187,
187,
167,
167,
167,
167,
194,
194,
194,
228,
228,
228,
228,
228,
228,
229,
229,
169,
230,
230,
216,
216,
163,
205,
205,
};
static	yySymbolRange	yyContinuation	[yyLastReadState + 1] = {
0,
85,
1,
28,
1,
28,
1,
48,
28,
1,
48,
28,
1,
48,
28,
1,
48,
34,
1,
87,
67,
2,
67,
87,
87,
1,
33,
34,
87,
28,
2,
1,
48,
28,
48,
48,
2,
1,
48,
28,
27,
48,
34,
27,
40,
31,
2,
28,
34,
2,
34,
2,
2,
2,
1,
2,
34,
1,
2,
34,
33,
2,
34,
1,
40,
28,
1,
2,
34,
2,
2,
3,
2,
2,
34,
2,
34,
1,
2,
2,
1,
2,
54,
2,
34,
2,
34,
2,
34,
12,
2,
54,
2,
34,
29,
29,
33,
29,
2,
3,
25,
4,
67,
2,
3,
10,
101,
3,
11,
87,
2,
11,
29,
2,
3,
11,
29,
3,
11,
11,
29,
2,
27,
28,
87,
1,
28,
3,
10,
85,
2,
34,
8,
3,
0,
69,
3,
16,
2,
54,
2,
0,
70,
2,
2,
3,
10,
85,
69,
3,
0,
85,
2,
62,
87,
29,
87,
10,
50,
3,
11,
2,
3,
87,
3,
3,
11,
11,
29,
29,
3,
0,
3,
0,
2,
62,
2,
29,
2,
62,
2,
29,
2,
29,
2,
29,
2,
3,
10,
85,
100,
2,
62,
48,
29,
10,
101,
101,
11,
29,
11,
29,
74,
2,
27,
28,
28,
3,
10,
85,
2,
107,
2,
2,
29,
29,
113,
29,
29,
2,
3,
10,
2,
3,
10,
85,
3,
0,
11,
3,
85,
3,
0,
85,
11,
3,
10,
85,
11,
3,
0,
57,
62,
3,
57,
3,
10,
85,
11,
3,
0,
42,
42,
3,
42,
3,
10,
85,
11,
2,
1,
2,
29,
2,
29,
29,
2,
2,
1,
2,
29,
2,
29,
2,
29,
29,
56,
2,
27,
28,
28,
62,
2,
29,
2,
10,
2,
92,
62,
3,
92,
74,
2,
27,
28,
28,
29,
3,
1,
28,
87,
87,
1,
1,
28,
87,
56,
2,
27,
28,
28,
29,
3,
87,
3,
10,
85,
80,
2,
3,
11,
26,
2,
3,
2,
2,
54,
1,
1,
2,
2,
3,
0,
2,
3,
3,
2,
3,
2,
3,
3,
2,
10,
85,
11,
11,
3,
0,
3,
2,
3,
2,
3,
2,
11,
29,
56,
2,
27,
28,
28,
62,
2,
29,
10,
2,
92,
11,
29,
3,
10,
85,
11,
32,
2,
3,
10,
85,
11,
3,
10,
85,
11,
3,
10,
85,
11,
35,
50,
3,
3,
10,
85,
11,
2,
3,
2,
35,
1,
11,
3,
10,
42,
11,
2,
1,
87,
11,
3,
10,
57,
11,
3,
10,
85,
11,
11,
3,
2,
3,
10,
85,
11,
11,
29,
11,
11,
11,
11,
3,
10,
70,
11,
11,
29,
28,
28,
1,
40,
28,
12,
12,
2,
54,
2,
34,
28,
28,
28,
55,
28,
28,
3,
0,
28,
3,
0,
8,
0,
3,
0,
};
static	unsigned short	yyFinalToProd	[yyLastReadNontermState - yyFirstReadTermState + 1] = {
1054,
1055,
1056,
1057,
1058,
1059,
1060,
1061,
1062,
1035,
1036,
1037,
908,
901,
1050,
988,
1002,
999,
979,
1064,
1001,
1039,
1003,
1000,
1004,
1038,
1070,
1069,
997,
953,
961,
962,
965,
970,
852,
960,
1005,
1006,
1007,
1008,
1009,
1010,
1011,
1012,
1013,
1014,
1017,
1018,
1019,
1024,
1025,
1015,
1016,
1021,
1026,
1022,
1020,
1023,
1065,
955,
956,
954,
963,
857,
750,
888,
889,
814,
815,
848,
849,
882,
881,
861,
951,
807,
752,
803,
787,
863,
865,
864,
781,
872,
853,
854,
873,
874,
875,
890,
894,
891,
892,
893,
878,
880,
879,
845,
844,
847,
846,
771,
782,
793,
823,
830,
855,
858,
842,
856,
859,
860,
843,
868,
1040,
898,
949,
1041,
1042,
952,
919,
914,
867,
871,
870,
832,
833,
829,
831,
916,
810,
811,
804,
805,
784,
756,
770,
869,
813,
791,
800,
797,
799,
866,
990,
991,
964,
971,
996,
995,
969,
983,
982,
749,
1052,
1053,
1044,
1045,
1049,
1051,
1063,
1067,
1066,
899,
909,
900,
1048,
993,
992,
931,
959,
985,
994,
972,
930,
975,
987,
980,
977,
981,
958,
886,
887,
946,
821,
822,
820,
903,
902,
905,
904,
1047,
1046,
762,
840,
839,
838,
841,
757,
758,
759,
760,
763,
764,
765,
766,
767,
774,
775,
776,
777,
778,
785,
786,
788,
790,
1068,
824,
825,
809,
836,
808,
851,
850,
932,
933,
1043,
876,
877,
895,
945,
940,
948,
947,
942,
944,
936,
937,
896,
938,
912,
927,
920,
926,
918,
917,
925,
923,
922,
828,
827,
834,
837,
826,
835,
1029,
1027,
819,
818,
817,
816,
772,
769,
768,
773,
794,
795,
796,
789,
801,
802,
1028,
974,
973,
742,
743,
745,
746,
747,
748,
};

static	void	yyErrorRecovery		ARGS((yySymbolRange * yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr));
static	void	yyComputeContinuation	ARGS((yyStateRange * yyStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyContinueSet));
static	bool	yyIsContinuation	ARGS((yySymbolRange yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr));
static	void	yyComputeRestartPoints	ARGS((yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyRestartSet));
static	yyStateRange yyNext		ARGS((yyStateRange yyState, yySymbolRange yySymbol));
static	void	BeginParser		();

int Parser ()
   {
      register	yyStateRange	yyState		;
      register	long		yyTerminal	;
      register	yyStateRange *	yyStateStackPtr ;
      register	tParsAttribute *yyAttrStackPtr	;
      register	bool		yyIsRepairing	;
		unsigned long	yyStateStackSize= yyInitStackSize;
		unsigned long	yyAttrStackSize = yyInitStackSize;
		yyStateRange *	yyStateStack	;
		tParsAttribute* yyAttributeStack;
		tParsAttribute	yySynAttribute	;	/* synthesized attribute */
      register	yyStateRange *	yyEndOfStack	;
		int		yyErrorCount	= 0;
   


      BeginParser ();
      yyState		= yyStartState;
      yyTerminal	= GetToken ();
      MakeArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
      MakeArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
      yyEndOfStack	= & yyStateStack [yyStateStackSize];
      yyStateStackPtr	= yyStateStack;
      yyAttrStackPtr	= yyAttributeStack;
      yyIsRepairing	= false;

   ParseLoop:
      for (;;) {
	 if (yyStateStackPtr >= yyEndOfStack) {
	    int yyyStateStackPtr= yyStateStackPtr - yyStateStack;
	    int yyyAttrStackPtr	= yyAttrStackPtr - yyAttributeStack;
	    ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
	    ExtendArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
	    yyStateStackPtr	= yyStateStack + yyyStateStackPtr;
	    yyAttrStackPtr	= yyAttributeStack + yyyAttrStackPtr;
	    yyEndOfStack	= & yyStateStack [yyStateStackSize];
	 }
	 * yyStateStackPtr = yyState;

   TermTrans:
	 for (;;) {	/* SPEC State = Next (State, Terminal); terminal transition */
	    register short * yyTCombPtr;

	    yyTCombPtr = (short *) (yyTBasePtr [yyState] + yyTerminal);
	    if (* yyTCombPtr ++ == yyState) { yyState = * yyTCombPtr; break; }
	    if ((yyState = yyDefault [yyState]) != yyNoState) goto TermTrans;

							/* syntax error */
	    if (! yyIsRepairing) {			/* report and recover */
	       yySymbolRange yyyTerminal = yyTerminal;

	       yyErrorCount ++;
	       yyErrorRecovery (& yyyTerminal, yyStateStack, yyStateStackSize, yyStateStackPtr - yyStateStack);
	       yyTerminal = yyyTerminal;
	       yyIsRepairing = true;
	    }
	    yyState = * yyStateStackPtr;
	    for (;;) {
	       if (yyNext (yyState, (yySymbolRange) yyTerminal) == yyNoState) { /* repair */
		  yySymbolRange		yyRepairToken;
		  tScanAttribute	yyRepairAttribute;
	    
		  yyRepairToken = yyContinuation [yyState];
		  yyState = yyNext (yyState, yyRepairToken);
		  if (yyState <= yyLastReadTermState) { /* read or read terminal reduce ? */
		     ErrorAttribute ((int) yyRepairToken, & yyRepairAttribute);
		     ErrorMessageI (xxTokenInserted, xxRepair, Attribute.Position,
			xxString, Parser_TokenName [yyRepairToken]);
		     if (yyState >= yyFirstFinalState) {	/* avoid second push */
			yyState = yyFinalToProd [yyState - yyFirstReadTermState];
		     }
		     yyGetAttribute (yyAttrStackPtr ++, yyRepairAttribute);
		     * ++ yyStateStackPtr = yyState;
		  }
		  if (yyState >= yyFirstFinalState) goto Final; /* final state ? */
	       } else {
		  yyState = yyNext (yyState, (yySymbolRange) yyTerminal);
		  goto Final;
	       }
	    }
	 }

   Final:
	 if (yyState >= yyFirstFinalState) {		/* final state ? */
	    if (yyState <= yyLastReadTermState) {	/* read terminal reduce ? */
	       yyStateStackPtr ++;
	       yyGetAttribute (yyAttrStackPtr ++, Attribute);
	       yyTerminal = GetToken ();
	       yyIsRepairing = false;
	    }

	    for (;;) {
	       /* register long yyNonterminal;		/* left-hand side */
# define yyNonterminal yyState

switch (yyState) {
case 741: /* _0000_ : __START__ _EndOfFile .*/
  ReleaseArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
  ReleaseArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
  return yyErrorCount;

case 742:
case 735: /* __START__ : program .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 115; {
/* line 177 "/tmp/lalr5400" */
/* line 191 "occam.lalr" */
 TreeRoot = mStart(yyAttrStackPtr [1-1].Tree); 
} break;
case 743:
case 736: /* program : proc .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 114; {
/* line 181 "/tmp/lalr5400" */
/* line 194 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; Message("Not allowed at outermost level of compilation unit",xxError,Posn(yyAttrStackPtr [1-1]));
} break;
case 744: /* program : outerspec sep .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 114; {
/* line 182 "/tmp/lalr5400" */
/* line 195 "occam.lalr" */
 yySynAttribute.Tree = mNullProcess(Posn(yyAttrStackPtr [1-1]),mNoSpec()); InsertASpec(yySynAttribute.Tree->Process.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 745:
case 737: /* program : outerspec sep program .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 114; {
/* line 184 "/tmp/lalr5400" */
/* line 196 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->Process.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 746:
case 738: /* outerspec : definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 117; {
/* line 187 "/tmp/lalr5400" */
/* line 199 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 747:
case 739: /* outerspec : abbreviation .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 117; {
/* line 190 "/tmp/lalr5400" */
/* line 200 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; Message("Not allowed at outermost level of compilation unit",xxError,Posn(yyAttrStackPtr [1-1]));
} break;
case 748:
case 740: /* outerspec : declaration .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 117; {
/* line 192 "/tmp/lalr5400" */
/* line 201 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; Message("Not allowed at outermost level of compilation unit",xxError,Posn(yyAttrStackPtr [1-1]));
} break;
case 749:
case 614: /* outerspec : HASHH CSTR .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 117; {
/* line 193 "/tmp/lalr5400" */
/* line 202 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; yySynAttribute.Tree = mHCode(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [2-1]).String,CurrentScope()); 
} break;
case 750:
case 525: /* pragma : PRAGMATRACK ID NUMBER DCOLON NUMBER .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 122; {
/* line 196 "/tmp/lalr5400" */
/* line 206 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; yySynAttribute.Tree = mPragmaTrack(Posn(yyAttrStackPtr [1-1]),LookupSymbolWithNoFail(Val(yyAttrStackPtr [2-1]).Ident),Val(yyAttrStackPtr [3-1]).Number,Val(yyAttrStackPtr [5-1]).Number,CurrentScope()); 
} break;
case 751: /* pragma : PRAGMATRACK ID .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 122; {
/* line 198 "/tmp/lalr5400" */
/* line 207 "occam.lalr" */
  yySynAttribute = yyAttrStackPtr [1-1]; yySynAttribute.Tree = mPragmaTrack(Posn(yyAttrStackPtr [1-1]),LookupSymbolWithNoFail(Val(yyAttrStackPtr [2-1]).Ident),0,1,CurrentScope()); 
} break;
case 752:
case 537: /* case : CASE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 123; {
/* line 201 "/tmp/lalr5400" */
/* line 210 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; OpenScope(); 
} break;
case 753: /* proc : action sep .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 116; {
/* line 204 "/tmp/lalr5400" */
/* line 212 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 754: /* proc : SKIP sep .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 116; {
/* line 206 "/tmp/lalr5400" */
/* line 213 "occam.lalr" */
 yySynAttribute.Tree = mSkip(Posn(yyAttrStackPtr [1-1]),mNoSpec()); 
} break;
case 755: /* proc : STOP sep .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 116; {
/* line 208 "/tmp/lalr5400" */
/* line 214 "occam.lalr" */
 yySynAttribute.Tree = mStop(Posn(yyAttrStackPtr [1-1]),mNoSpec()); 
} break;
case 756:
case 596: /* proc : case selector sep BEGIN selectlist END .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 116; {
/* line 210 "/tmp/lalr5400" */
/* line 215 "occam.lalr" */
 yySynAttribute.Tree = mCase(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree,ReverseTree(yyAttrStackPtr [5-1].Tree)); CloseScope();
} break;
case 757:
case 659: /* proc : construct .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 116; {
/* line 212 "/tmp/lalr5400" */
/* line 216 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 758:
case 660: /* proc : instance .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 116; {
/* line 214 "/tmp/lalr5400" */
/* line 217 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 759:
case 661: /* proc : caseinput .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 116; {
/* line 216 "/tmp/lalr5400" */
/* line 218 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 760:
case 662: /* proc : casesingle .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 116; {
/* line 218 "/tmp/lalr5400" */
/* line 219 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 761: /* proc : HASHC CSTR sep .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 116; {
/* line 220 "/tmp/lalr5400" */
/* line 220 "occam.lalr" */
 yySynAttribute.Tree = mCCode(Posn(yyAttrStackPtr [1-1]),mNoSpec(),Val(yyAttrStackPtr [2-1]).String,CurrentScope()); 
} break;
case 762:
case 654: /* process : proc .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 131; {
/* line 223 "/tmp/lalr5400" */
/* line 223 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 763:
case 663: /* process : specification sep process .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 131; {
/* line 225 "/tmp/lalr5400" */
/* line 224 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->Process.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 764:
case 664: /* action : assignment .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 124; {
/* line 228 "/tmp/lalr5400" */
/* line 227 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 765:
case 665: /* action : input .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 124; {
/* line 230 "/tmp/lalr5400" */
/* line 228 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 766:
case 666: /* action : after .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 124; {
/* line 232 "/tmp/lalr5400" */
/* line 229 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 767:
case 667: /* action : output .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 124; {
/* line 234 "/tmp/lalr5400" */
/* line 230 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 768:
case 724: /* selectlist : select .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 126; {
/* line 237 "/tmp/lalr5400" */
/* line 233 "occam.lalr" */
 yyAttrStackPtr [1-1].Tree->AChoice.Next= mNoChoice(); CloseScope(); OpenScope(); 
} break;
case 769:
case 723: /* selectlist : selectlist select .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 126; {
/* line 239 "/tmp/lalr5400" */
/* line 234 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; yyAttrStackPtr [2-1].Tree->AChoice.Next= yyAttrStackPtr [1-1].Tree; CloseScope(); OpenScope(); 
} break;
case 770:
case 597: /* select : explist sep BEGIN process END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 137; {
/* line 242 "/tmp/lalr5400" */
/* line 238 "occam.lalr" */
 yySynAttribute.Tree = mAChoice(mNoSpec(),NoTree,ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [4-1].Tree); 
} break;
case 771:
case 562: /* select : ELSE sep BEGIN process END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 137; {
/* line 244 "/tmp/lalr5400" */
/* line 239 "occam.lalr" */
 yySynAttribute.Tree = mAChoice(mNoSpec(),NoTree,mAnExpr(mNoExpr(),mDefault(Posn(yyAttrStackPtr [1-1]))),yyAttrStackPtr [4-1].Tree); 
} break;
case 772:
case 722: /* select : specification sep select .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 137; {
/* line 246 "/tmp/lalr5400" */
/* line 240 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->AChoice.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 773:
case 725: /* selector : expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 125; {
/* line 249 "/tmp/lalr5400" */
/* line 243 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 774:
case 668: /* construct : sequence .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 127; {
/* line 252 "/tmp/lalr5400" */
/* line 247 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 775:
case 669: /* construct : parallel .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 127; {
/* line 254 "/tmp/lalr5400" */
/* line 248 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 776:
case 670: /* construct : conditional .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 127; {
/* line 256 "/tmp/lalr5400" */
/* line 249 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 777:
case 671: /* construct : alternation .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 127; {
/* line 258 "/tmp/lalr5400" */
/* line 250 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 778:
case 672: /* construct : loop .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 127; {
/* line 260 "/tmp/lalr5400" */
/* line 251 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 779: /* instance : ID LP explist RP sep .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 128; {
/* line 263 "/tmp/lalr5400" */
/* line 255 "occam.lalr" */
 yySynAttribute.Tree = CreateProcCall(Posn(yyAttrStackPtr [1-1]),mNoSpec(), LookupSymbol(yyAttrStackPtr [1-1].Scan),ReverseTree(yyAttrStackPtr [3-1].Tree),CurrentScope()); 
} break;
case 780: /* instance : ID LP RP sep .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 128; {
/* line 265 "/tmp/lalr5400" */
/* line 256 "occam.lalr" */
 yySynAttribute.Tree = CreateProcCall(Posn(yyAttrStackPtr [1-1]),mNoSpec(), LookupSymbol(yyAttrStackPtr [1-1].Scan),mNoExpr(),CurrentScope()); 
} break;
case 781:
case 543: /* seq : SEQ .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 145; {
/* line 268 "/tmp/lalr5400" */
/* line 259 "occam.lalr" */
 OpenScope(); yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 782:
case 563: /* sequence : seq sep BEGIN proclist END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 140; {
/* line 271 "/tmp/lalr5400" */
/* line 262 "occam.lalr" */
 yySynAttribute.Tree = mSeq(Posn(yyAttrStackPtr [1-1]),mNoSpec(),ReverseTree(yyAttrStackPtr [4-1].Tree)); CloseScope(); 
} break;
case 783: /* sequence : seq sep .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 140; {
/* line 273 "/tmp/lalr5400" */
/* line 263 "occam.lalr" */
 yySynAttribute.Tree = mSeq(Posn(yyAttrStackPtr [1-1]),mNoSpec(),mNoProcess()); CloseScope(); 
} break;
case 784:
case 595: /* sequence : seq replic sep BEGIN process END .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 140; {
/* line 275 "/tmp/lalr5400" */
/* line 264 "occam.lalr" */
 yySynAttribute.Tree = mSeqRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [5-1].Tree); CloseScope(); 
} break;
case 785:
case 673: /* proclist : process .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 146; {
/* line 278 "/tmp/lalr5400" */
/* line 267 "occam.lalr" */
 yySynAttribute.Tree = mAProcess(mNoProcess(),yyAttrStackPtr [1-1].Tree,NoSymbol); CloseScope(); OpenScope(); 
} break;
case 786:
case 674: /* proclist : proclist process .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 146; {
/* line 280 "/tmp/lalr5400" */
/* line 268 "occam.lalr" */
 yySynAttribute.Tree = mAProcess(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [2-1].Tree,NoSymbol); CloseScope(); OpenScope(); 
} break;
case 787:
case 539: /* par : PAR .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 148; {
/* line 283 "/tmp/lalr5400" */
/* line 271 "occam.lalr" */
 OpenScope(); OpenScope(); yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 788:
case 675: /* parallel : partype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 141; {
/* line 286 "/tmp/lalr5400" */
/* line 274 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 789:
case 729: /* parallel : PRI partype .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 141; {
/* line 288 "/tmp/lalr5400" */
/* line 275 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [2-1]; ParType(yySynAttribute.Tree) = xxPriPar; 
} break;
case 790:
case 676: /* parallel : placedpar .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 141; {
/* line 290 "/tmp/lalr5400" */
/* line 276 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 791:
case 600: /* partype : par sep BEGIN parproclist END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 149; {
/* line 293 "/tmp/lalr5400" */
/* line 279 "occam.lalr" */
 yySynAttribute.Tree = mPar(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPar,ReverseTree(yyAttrStackPtr [4-1].Tree)); CloseScope(); CloseScope(); 
} break;
case 792: /* partype : par sep .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 149; {
/* line 295 "/tmp/lalr5400" */
/* line 280 "occam.lalr" */
 yySynAttribute.Tree = mPar(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPar,mNoProcess()); CloseScope(); CloseScope(); 
} break;
case 793:
case 564: /* partype : parrep sep BEGIN process END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 149; {
/* line 297 "/tmp/lalr5400" */
/* line 281 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mParRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPar,yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [4-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); CloseScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 794:
case 726: /* parproclist : process .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 151; {
/* line 300 "/tmp/lalr5400" */
/* line 284 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mAProcess(mNoProcess(),yyAttrStackPtr [1-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); OpenScope(); OpenScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 795:
case 727: /* parproclist : parproclist process .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 151; {
/* line 302 "/tmp/lalr5400" */
/* line 285 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mAProcess(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [2-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); OpenScope(); OpenScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 796:
case 728: /* parrep : par replic .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 152; {
/* line 305 "/tmp/lalr5400" */
/* line 288 "occam.lalr" */
 OpenScope(); S=AddSymbol(NoIdent); yySynAttribute.Tree=yyAttrStackPtr [2-1].Tree; yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; 
} break;
case 797:
case 602: /* placedpar : PLACED par sep BEGIN placedlist END .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 150; {
/* line 308 "/tmp/lalr5400" */
/* line 292 "occam.lalr" */
 yySynAttribute.Tree = mPar(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPlacedPar,ReverseTree(yyAttrStackPtr [5-1].Tree)); CloseScope(); CloseScope(); 
} break;
case 798: /* placedpar : PLACED par sep .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 150; {
/* line 310 "/tmp/lalr5400" */
/* line 293 "occam.lalr" */
 yySynAttribute.Tree = mPar(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPlacedPar,mNoProcess()); CloseScope(); CloseScope(); 
} break;
case 799:
case 603: /* placedpar : PLACED parrep sep BEGIN placedpar END .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 150; {
/* line 312 "/tmp/lalr5400" */
/* line 294 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mParRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPlacedPar,yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [5-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); CloseScope(); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 800:
case 601: /* placedpar : PROCESSOR expr ID sep BEGIN process END .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 150; {
/* line 314 "/tmp/lalr5400" */
/* line 295 "occam.lalr" */
 yySynAttribute.Tree = mProcessor(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree,Val(yyAttrStackPtr [3-1]).Ident,yyAttrStackPtr [6-1].Tree); 
} break;
case 801:
case 730: /* placedlist : placedpar .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 153; {
/* line 317 "/tmp/lalr5400" */
/* line 298 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mAProcess(mNoProcess(),yyAttrStackPtr [1-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); OpenScope(); OpenScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 802:
case 731: /* placedlist : placedlist placedpar .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 153; {
/* line 319 "/tmp/lalr5400" */
/* line 299 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mAProcess(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [2-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); OpenScope(); OpenScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 803:
case 538: /* if : IF .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 154; {
/* line 322 "/tmp/lalr5400" */
/* line 302 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; OpenScope(); 
} break;
case 804:
case 593: /* conditional : if sep BEGIN choicelist END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 142; {
/* line 325 "/tmp/lalr5400" */
/* line 304 "occam.lalr" */
 yySynAttribute.Tree = mIf(Posn(yyAttrStackPtr [1-1]),mNoSpec(),ReverseTree(yyAttrStackPtr [4-1].Tree)); CloseScope(); 
} break;
case 805:
case 594: /* conditional : if replic sep BEGIN choice END .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 142; {
/* line 327 "/tmp/lalr5400" */
/* line 305 "occam.lalr" */
 yySynAttribute.Tree = mIfRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [5-1].Tree); yyAttrStackPtr [5-1].Tree->AChoice.Next=mNoChoice(); CloseScope(); 
} break;
case 806: /* conditional : if sep .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 142; {
/* line 329 "/tmp/lalr5400" */
/* line 306 "occam.lalr" */
 yySynAttribute.Tree = mIf(Posn(yyAttrStackPtr [1-1]),mNoSpec(),mNoChoice()); CloseScope(); 
} break;
case 807:
case 536: /* alt : ALT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 157; {
/* line 332 "/tmp/lalr5400" */
/* line 309 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; OpenScope(); 
} break;
case 808:
case 682: /* alternation : alttype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 143; {
/* line 335 "/tmp/lalr5400" */
/* line 312 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 809:
case 680: /* alternation : PRI alttype .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 143; {
/* line 337 "/tmp/lalr5400" */
/* line 313 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [2-1]; AltIsPri(yySynAttribute.Tree) = true; 
} break;
case 810:
case 591: /* alttype : alt sep BEGIN alternativelist END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 158; {
/* line 340 "/tmp/lalr5400" */
/* line 316 "occam.lalr" */
 yySynAttribute.Tree = mAlt(Posn(yyAttrStackPtr [1-1]),mNoSpec(),false,ReverseTree(yyAttrStackPtr [4-1].Tree)); CloseScope(); 
} break;
case 811:
case 592: /* alttype : alt replic sep BEGIN alternative END .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 158; {
/* line 342 "/tmp/lalr5400" */
/* line 317 "occam.lalr" */
 yySynAttribute.Tree = mAltRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),false,yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [5-1].Tree); yyAttrStackPtr [5-1].Tree->AnAlts.Next = mNoAlt(); CloseScope(); 
} break;
case 812: /* alttype : alt sep .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 158; {
/* line 344 "/tmp/lalr5400" */
/* line 318 "occam.lalr" */
 yySynAttribute.Tree = mAlt(Posn(yyAttrStackPtr [1-1]),mNoSpec(),false,mNoAlt()); CloseScope(); 
} break;
case 813:
case 599: /* loop : WHILE expr sep BEGIN process END .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 144; {
/* line 347 "/tmp/lalr5400" */
/* line 322 "occam.lalr" */
 yySynAttribute.Tree = mWhile(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [5-1].Tree); 
} break;
case 814:
case 528: /* sep : EOL .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 118; {
/* line 350 "/tmp/lalr5400" */
/* line 326 "occam.lalr" */
yySynAttribute=yyAttrStackPtr [1-1];
} break;
case 815:
case 529: /* sep : sep EOL .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 118; {
/* line 352 "/tmp/lalr5400" */
/* line 327 "occam.lalr" */
yySynAttribute=yyAttrStackPtr [1-1];
} break;
case 816:
case 721: /* choicelist : choice .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 155; {
/* line 355 "/tmp/lalr5400" */
/* line 330 "occam.lalr" */
 yySynAttribute.Tree->AChoices.Next = mNoChoice(); CloseScope(); OpenScope();
} break;
case 817:
case 720: /* choicelist : choicelist choice .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 155; {
/* line 357 "/tmp/lalr5400" */
/* line 331 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; yySynAttribute.Tree->AChoices.Next=yyAttrStackPtr [1-1].Tree; CloseScope(); OpenScope(); 
} break;
case 818:
case 719: /* alternativelist : alternative .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 159; {
/* line 360 "/tmp/lalr5400" */
/* line 335 "occam.lalr" */
  yySynAttribute.Tree->AnAlts.Next = mNoAlt() ; CloseScope(); OpenScope(); 
} break;
case 819:
case 718: /* alternativelist : alternativelist alternative .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 159; {
/* line 362 "/tmp/lalr5400" */
/* line 336 "occam.lalr" */
 yySynAttribute.Scan =yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; yySynAttribute.Tree->AnAlts.Next = yyAttrStackPtr [1-1].Tree; CloseScope(); OpenScope(); 
} break;
case 820:
case 647: /* replic : ID EQ base FOR count .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 147; {
/* line 365 "/tmp/lalr5400" */
/* line 339 "occam.lalr" */
  yySynAttribute.Tree = mReplicator(S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident),yyAttrStackPtr [3-1].Tree,yyAttrStackPtr [5-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=mInt(); 
} break;
case 821:
case 645: /* base : expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 161; {
/* line 368 "/tmp/lalr5400" */
/* line 342 "occam.lalr" */
yySynAttribute=yyAttrStackPtr [1-1];
} break;
case 822:
case 646: /* count : expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 162; {
/* line 371 "/tmp/lalr5400" */
/* line 345 "occam.lalr" */
yySynAttribute=yyAttrStackPtr [1-1];
} break;
case 823:
case 565: /* choice : boolean sep BEGIN process END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 156; {
/* line 374 "/tmp/lalr5400" */
/* line 348 "occam.lalr" */
 yySynAttribute.Tree = mAChoice(mNoSpec(),NoTree,mAnExpr(mNoExpr(),yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [4-1].Tree);
} break;
case 824:
case 678: /* choice : conditional .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 156; {
/* line 376 "/tmp/lalr5400" */
/* line 349 "occam.lalr" */
 yySynAttribute.Tree = mANewIf(mNoSpec(),NoTree,yyAttrStackPtr [1-1].Tree);
} break;
case 825:
case 679: /* choice : specification sep choice .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 156; {
/* line 378 "/tmp/lalr5400" */
/* line 350 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->AChoice.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 826:
case 714: /* alternative : guard .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 160; {
/* line 381 "/tmp/lalr5400" */
/* line 354 "occam.lalr" */
 yySynAttribute.Tree = mAnAlt(mNoSpec(),NoTree,yyAttrStackPtr [1-1].Tree); 
} break;
case 827:
case 711: /* alternative : specification sep alternative .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 160; {
/* line 383 "/tmp/lalr5400" */
/* line 355 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->AnAlt.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 828:
case 710: /* alternative : alternation .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 160; {
/* line 385 "/tmp/lalr5400" */
/* line 356 "occam.lalr" */
 yySynAttribute.Tree = mANewAlt(mNoSpec(),NoTree,yyAttrStackPtr [1-1].Tree); 
} break;
case 829:
case 588: /* guard : boolean AMPERSAND input sep BEGIN process END .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 164; {
/* line 388 "/tmp/lalr5400" */
/* line 359 "occam.lalr" */
 yySynAttribute.Tree = mAltInput(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree,yyAttrStackPtr [6-1].Tree);
} break;
case 830:
case 566: /* guard : input sep BEGIN process END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 164; {
/* line 390 "/tmp/lalr5400" */
/* line 360 "occam.lalr" */
 yySynAttribute.Tree = mAltInput(Posn(yyAttrStackPtr [1-1]),mConst(Posn(yyAttrStackPtr [1-1]),Vtrue,mBool()),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [4-1].Tree);
} break;
case 831:
case 589: /* guard : boolean AMPERSAND after sep BEGIN process END .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 164; {
/* line 392 "/tmp/lalr5400" */
/* line 361 "occam.lalr" */
 yySynAttribute.Tree = mAltTimer(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree,yyAttrStackPtr [6-1].Tree);
} break;
case 832:
case 586: /* guard : after sep BEGIN process END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 164; {
/* line 394 "/tmp/lalr5400" */
/* line 362 "occam.lalr" */
 yySynAttribute.Tree = mAltTimer(Posn(yyAttrStackPtr [1-1]),mConst(Posn(yyAttrStackPtr [1-1]),Vtrue,mBool()),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [4-1].Tree);
} break;
case 833:
case 587: /* guard : boolean AMPERSAND SKIP sep BEGIN process END .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 164; {
/* line 396 "/tmp/lalr5400" */
/* line 363 "occam.lalr" */
 yySynAttribute.Tree = mNoInput(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [6-1].Tree);
} break;
case 834:
case 712: /* guard : boolean AMPERSAND caseguard .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 164; {
/* line 398 "/tmp/lalr5400" */
/* line 364 "occam.lalr" */
 yySynAttribute.Tree = mAltCaseIn(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree);
} break;
case 835:
case 715: /* guard : caseguard .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 164; {
/* line 400 "/tmp/lalr5400" */
/* line 365 "occam.lalr" */
 yySynAttribute.Tree = mAltCaseIn(Posn(yyAttrStackPtr [1-1]),mConst(Posn(yyAttrStackPtr [1-1]),Vtrue,mBool()),yyAttrStackPtr [1-1].Tree);
} break;
case 836:
case 681: /* caseguard : caseinput .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 165; {
/* line 403 "/tmp/lalr5400" */
/* line 368 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 837:
case 713: /* caseguard : casesingleproc .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 165; {
/* line 405 "/tmp/lalr5400" */
/* line 369 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 838:
case 657: /* specification : declaration .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 132; {
/* line 408 "/tmp/lalr5400" */
/* line 372 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1];
} break;
case 839:
case 656: /* specification : abbreviation .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 132; {
/* line 410 "/tmp/lalr5400" */
/* line 373 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1];
} break;
case 840:
case 655: /* specification : definition .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 132; {
/* line 412 "/tmp/lalr5400" */
/* line 374 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1];
} break;
case 841:
case 658: /* specification : pragma .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 132; {
/* line 414 "/tmp/lalr5400" */
/* line 375 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1];
} break;
case 842:
case 569: /* declaration : primtype namelist COLON .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 121; {
/* line 417 "/tmp/lalr5400" */
/* line 378 "occam.lalr" */
 yySynAttribute.Tree = mDecl(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,T=ReverseTree(yyAttrStackPtr [2-1].Tree)); TypeDecl(yyAttrStackPtr [1-1].Tree,T); 
} break;
case 843:
case 573: /* declaration : arrtype namelist COLON .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 121; {
/* line 419 "/tmp/lalr5400" */
/* line 379 "occam.lalr" */
 yySynAttribute.Tree = mDecl(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,T=ReverseTree(yyAttrStackPtr [2-1].Tree)); TypeDecl(yyAttrStackPtr [1-1].Tree,T); 
} break;
case 844:
case 559: /* declaration : PLACE ID AT expr COLON .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 121; {
/* line 422 "/tmp/lalr5400" */
/* line 380 "occam.lalr" */
 if (IsPlaceSupported==true) yySynAttribute.Tree = mPlace(Posn(yyAttrStackPtr [1-1]),LookupSymbol(yyAttrStackPtr [2-1].Scan),yyAttrStackPtr [4-1].Tree); else { yySynAttribute.Tree = mNullSpec(Posn(yyAttrStackPtr [1-1])); Message("Variable placement not allowed",xxWarning,Posn(yyAttrStackPtr [1-1]));} 
} break;
case 845:
case 558: /* declaration : PLACE ID AT WORKSPACE expr COLON .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 121; {
/* line 424 "/tmp/lalr5400" */
/* line 381 "occam.lalr" */
 yySynAttribute.Tree = mNullSpec(Posn(yyAttrStackPtr [1-1])); Message("Ignored variable placement",xxWarning,Posn(yyAttrStackPtr [1-1])); 
} break;
case 846:
case 561: /* declaration : PLACE ID IN VECSPACE COLON .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 121; {
/* line 426 "/tmp/lalr5400" */
/* line 382 "occam.lalr" */
 yySynAttribute.Tree = mNullSpec(Posn(yyAttrStackPtr [1-1])); Message("Ignored variable placement",xxWarning,Posn(yyAttrStackPtr [1-1])); 
} break;
case 847:
case 560: /* declaration : PLACE ID IN WORKSPACE COLON .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 121; {
/* line 428 "/tmp/lalr5400" */
/* line 383 "occam.lalr" */
 yySynAttribute.Tree = mNullSpec(Posn(yyAttrStackPtr [1-1])); Message("Ignored variable placement",xxWarning,Posn(yyAttrStackPtr [1-1])); 
} break;
case 848:
case 530: /* name : ID .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 170; {
/* line 430 "/tmp/lalr5400" */
/* line 386 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 849:
case 531: /* name : TYPEID .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 170; {
/* line 432 "/tmp/lalr5400" */
/* line 387 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 850:
case 684: /* namelist : name .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 168; {
/* line 435 "/tmp/lalr5400" */
/* line 390 "occam.lalr" */
 if (last_type_was_chan) S=AddChanSymbol(Val(yyAttrStackPtr [1-1]).Ident); else S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident); yySynAttribute.Tree = mAnId(mNoId(),S); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 851:
case 683: /* namelist : namelist DECLCOMMA name .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 168; {
/* line 437 "/tmp/lalr5400" */
/* line 391 "occam.lalr" */
 if (last_type_was_chan) S=AddChanSymbol(Val(yyAttrStackPtr [3-1]).Ident); else S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident); yySynAttribute.Tree = mAnId(yyAttrStackPtr [1-1].Tree,S); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 852:
case 495: /* is : IS .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 171; {
/* line 440 "/tmp/lalr5400" */
/* line 394 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; colon_ended=false; 
} break;
case 853:
case 545: /* retypes : RETYPES .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 172; {
/* line 443 "/tmp/lalr5400" */
/* line 397 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; colon_ended=false; 
} break;
case 854:
case 546: /* reshapes : RESHAPES .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 173; {
/* line 446 "/tmp/lalr5400" */
/* line 400 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; colon_ended=false; 
} break;
case 855:
case 567: /* abbreviation : primtype ID is elemental COLON .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 120; {
/* line 449 "/tmp/lalr5400" */
/* line 404 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mIs(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree;
} break;
case 856:
case 570: /* abbreviation : arrtype ID is elemental COLON .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 120; {
/* line 451 "/tmp/lalr5400" */
/* line 406 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mIs(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree;
} break;
case 857:
case 524: /* abbreviation : ID is elemental COLON .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 120; {
/* line 453 "/tmp/lalr5400" */
/* line 408 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mIs(Posn(yyAttrStackPtr [1-1]),mUntyped(),S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident),yyAttrStackPtr [3-1].Tree); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 858:
case 568: /* abbreviation : primtype ID retypes elemental COLON .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 120; {
/* line 455 "/tmp/lalr5400" */
/* line 410 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRetypes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree; 
} break;
case 859:
case 571: /* abbreviation : arrtype ID retypes elemental COLON .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 120; {
/* line 457 "/tmp/lalr5400" */
/* line 412 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRetypes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree;
} break;
case 860:
case 572: /* abbreviation : arrtype ID reshapes elemental COLON .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 120; {
/* line 459 "/tmp/lalr5400" */
/* line 414 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mReshapes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree;
} break;
case 861:
case 534: /* id : ID .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 175; {
/* line 462 "/tmp/lalr5400" */
/* line 417 "occam.lalr" */
 Val(yySynAttribute).Ident = Val(yyAttrStackPtr [1-1]).Ident; OpenScope(); colon_ended=false; 
} break;
case 862: /* pushtok : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 176; {
/* line 465 "/tmp/lalr5400" */
/* line 421 "occam.lalr" */
 OpenScope(); PushTokenColumn(); 
} break;
case 863:
case 540: /* definition : PROTOCOL ID IS seqproto COLON .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 119; {
/* line 468 "/tmp/lalr5400" */
/* line 424 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mDefSeqPro(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),ReverseTree(yyAttrStackPtr [4-1].Tree)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 864:
case 542: /* definition : PROTOCOL ID sep BEGIN CASE sep END COLON .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 119; {
/* line 470 "/tmp/lalr5400" */
/* line 426 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mDefTagPro(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),mNoTagPro()); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 865:
case 541: /* definition : PROTOCOL ID sep BEGIN CASE sep BEGIN tagprotolist sep END END COLON .*/
  yyStateStackPtr -=12; yyAttrStackPtr -=12; yyNonterminal = 119; {
/* line 472 "/tmp/lalr5400" */
/* line 428 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mDefTagPro(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),ReverseTree(yyAttrStackPtr [8-1].Tree)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 866:
case 604: /* definition : PROC id LP O_fparmlist RP sep BEGIN process END COLON .*/
  yyStateStackPtr -=10; yyAttrStackPtr -=10; yyNonterminal = 119; {
/* line 474 "/tmp/lalr5400" */
/* line 430 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mDefProc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree,yyAttrStackPtr [8-1].Tree); SymbolKind(S)=yySynAttribute.Tree; TypeFormals(yyAttrStackPtr [4-1].Tree);
} break;
case 867:
case 583: /* definition : typelist FUNCTION id LP O_fparmlist RP sep BEGIN pushtok valof END COLON .*/
  yyStateStackPtr -=12; yyAttrStackPtr -=12; yyNonterminal = 119; {
/* line 476 "/tmp/lalr5400" */
/* line 432 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mDefFunc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),T=ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [5-1].Tree,yyAttrStackPtr [10-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [5-1].Tree); yyAttrStackPtr [10-1].Tree->Valof.Sym=S; 
} break;
case 868:
case 574: /* definition : typelist FUNCTION id LP O_fparmlist RP IS isexplist COLON .*/
  yyStateStackPtr -=9; yyAttrStackPtr -=9; yyNonterminal = 119; {
/* line 478 "/tmp/lalr5400" */
/* line 434 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mDefIsFunc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),T=ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [5-1].Tree,ReverseTree(yyAttrStackPtr [8-1].Tree)); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [5-1].Tree);
} break;
case 869:
case 598: /* definition : INLINE PROC id LP O_fparmlist RP sep BEGIN process END COLON .*/
  yyStateStackPtr -=11; yyAttrStackPtr -=11; yyNonterminal = 119; {
/* line 480 "/tmp/lalr5400" */
/* line 436 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mInlineDefProc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree,yyAttrStackPtr [9-1].Tree); SymbolKind(S)=yySynAttribute.Tree; TypeFormals(yyAttrStackPtr [5-1].Tree);
} break;
case 870:
case 585: /* definition : typelist INLINE FUNCTION id LP O_fparmlist RP sep BEGIN pushtok valof END COLON .*/
  yyStateStackPtr -=13; yyAttrStackPtr -=13; yyNonterminal = 119; {
/* line 482 "/tmp/lalr5400" */
/* line 438 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mInlineDefFunc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [4-1]).Ident),T=ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [6-1].Tree,yyAttrStackPtr [11-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [6-1].Tree); yyAttrStackPtr [11-1].Tree->Valof.Sym=S; 
} break;
case 871:
case 584: /* definition : typelist INLINE FUNCTION id LP O_fparmlist RP IS isexplist COLON .*/
  yyStateStackPtr -=10; yyAttrStackPtr -=10; yyNonterminal = 119; {
/* line 484 "/tmp/lalr5400" */
/* line 440 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mInlineDefIsFunc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [4-1]).Ident),T=ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [6-1].Tree,ReverseTree(yyAttrStackPtr [9-1].Tree)); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [6-1].Tree);
} break;
case 872:
case 544: /* definition : VAL ID is expr COLON .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 119; {
/* line 486 "/tmp/lalr5400" */
/* line 442 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mVal(Posn(yyAttrStackPtr [1-1]),mUntyped(),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 873:
case 547: /* definition : VAL spectype ID is expr COLON .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 119; {
/* line 488 "/tmp/lalr5400" */
/* line 444 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mVal(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [2-1].Tree;
} break;
case 874:
case 548: /* definition : VAL spectype ID retypes expr COLON .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 119; {
/* line 490 "/tmp/lalr5400" */
/* line 446 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mValRetypes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [2-1].Tree;
} break;
case 875:
case 549: /* definition : VAL spectype ID reshapes expr COLON .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 119; {
/* line 492 "/tmp/lalr5400" */
/* line 448 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mValReshapes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [2-1].Tree;
} break;
case 876:
case 688: /* definition : prototype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 119; {
/* line 494 "/tmp/lalr5400" */
/* line 450 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CHK_Mode(xxPrototype,Posn(yyAttrStackPtr [1-1])); yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 877:
case 689: /* definition : userdatatype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 119; {
/* line 496 "/tmp/lalr5400" */
/* line 452 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 878:
case 555: /* userdatatype : DATA TYPE typeid IS datatype COLON .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 185; {
/* line 500 "/tmp/lalr5400" */
/* line 456 "occam.lalr" */
 
		  CloseScope();
                  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
                  yySynAttribute.Tree = mDeclType(Posn(yyAttrStackPtr [1-1]),TypeUserDataType(yyAttrStackPtr [5-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),Posn(yyAttrStackPtr [1-1]))); 
                  SymbolKind(S)=yySynAttribute.Tree;
                  SymbolType(S)=yySynAttribute.Tree->DeclType.Type; 
                
} break;
case 879:
case 557: /* userdatatype : DATA TYPE typeid sep BEGIN structuredtype END COLON .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 185; {
/* line 510 "/tmp/lalr5400" */
/* line 464 "occam.lalr" */
 
		  CloseScope();
                  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
                  yySynAttribute.Tree = mDeclType(Posn(yyAttrStackPtr [1-1]),mUserRecord(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [6-1].Tree)); 
                  SymbolKind(S)=yySynAttribute.Tree; 
                  SymbolType(S)=yySynAttribute.Tree->DeclType.Type; 
                
} break;
case 880:
case 556: /* userdatatype : DATA TYPE typeid sep BEGIN PACKED structuredtype END COLON .*/
  yyStateStackPtr -=9; yyAttrStackPtr -=9; yyNonterminal = 185; {
/* line 520 "/tmp/lalr5400" */
/* line 472 "occam.lalr" */
 
		  CloseScope();
                  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
                  yySynAttribute.Tree = mDeclType(Posn(yyAttrStackPtr [1-1]),mUserPackedRecord(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [7-1].Tree)); 
                  SymbolKind(S)=yySynAttribute.Tree; 
                  SymbolType(S)=yySynAttribute.Tree->DeclType.Type; 
                
} break;
case 881:
case 533: /* userdatatype : CHAN TYPE typeid sep BEGIN structuredtype END COLON .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 185; {
/* line 530 "/tmp/lalr5400" */
/* line 480 "occam.lalr" */
 
		  CloseScope();
		  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan;
                  yySynAttribute.Tree = mDeclType(Posn(yyAttrStackPtr [1-1]),mUserChanRecord(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [6-1].Tree)); 
                  SymbolKind(S)=yySynAttribute.Tree; 
                  SymbolType(S)=yySynAttribute.Tree->DeclType.Type; 
                
} break;
case 882:
case 532: /* structuredtype : RECORD sep BEGIN fieldlist END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 188; {
/* line 540 "/tmp/lalr5400" */
/* line 490 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = ReverseTree(yyAttrStackPtr [4-1].Tree); 
} break;
case 883: /* structuredtype : RECORD sep .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 188; {
/* line 542 "/tmp/lalr5400" */
/* line 492 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mNoField(); 
} break;
case 884: /* fieldlist : fielddecl COLON sep .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 189; {
/* line 545 "/tmp/lalr5400" */
/* line 496 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 885: /* fieldlist : fieldlist fielddecl COLON sep .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 189; {
/* line 547 "/tmp/lalr5400" */
/* line 498 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = CatFieldList(yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [1-1].Tree); 
} break;
case 886:
case 642: /* fielddecl : spectype name .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 190; {
/* line 551 "/tmp/lalr5400" */
/* line 502 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
                  yySynAttribute.Tree = mAField(mNoField(),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [1-1].Tree); 
                  SymbolKind(S)=yySynAttribute.Tree;
		  SymbolType(S)=yyAttrStackPtr [1-1].Tree;
                
} break;
case 887:
case 643: /* fielddecl : fielddecl DECLCOMMA name .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 190; {
/* line 559 "/tmp/lalr5400" */
/* line 508 "occam.lalr" */

		  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan;
		  yySynAttribute.Tree = mAField(yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [1-1].Tree->AField.Type);
		  SymbolKind(S)=yySynAttribute.Tree;
		  SymbolType(S)=yyAttrStackPtr [1-1].Tree->AField.Type;
		
} break;
case 888:
case 526: /* typeid : ID .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 186; {
/* line 568 "/tmp/lalr5400" */
/* line 516 "occam.lalr" */
yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Ident = Val(yyAttrStackPtr [1-1]).Ident; OpenScope(); 
} break;
case 889:
case 527: /* typeid : TYPEID .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 186; {
/* line 570 "/tmp/lalr5400" */
/* line 517 "occam.lalr" */
yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Ident = Val(yyAttrStackPtr [1-1]).Ident; OpenScope(); 
} break;
case 890:
case 550: /* LANG : EXTERN_OCCAM .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 191; {
/* line 573 "/tmp/lalr5400" */
/* line 522 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxOccam; 
} break;
case 891:
case 552: /* LANG : EXTERN_F90 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 191; {
/* line 575 "/tmp/lalr5400" */
/* line 524 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxF90; ADD_Mode(xxCallF90); 
} break;
case 892:
case 553: /* LANG : EXTERN_F77 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 191; {
/* line 577 "/tmp/lalr5400" */
/* line 526 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxF77; 
} break;
case 893:
case 554: /* LANG : EXTERN_C .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 191; {
/* line 579 "/tmp/lalr5400" */
/* line 528 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxC; 
} break;
case 894:
case 551: /* LANG : EXTERN_ATOMIC .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 191; {
/* line 581 "/tmp/lalr5400" */
/* line 530 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxAtomicOccam; 
} break;
case 895:
case 690: /* prototype : LANG PROC id LP O_fparmlist RP COLON proto_id .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 184; {
/* line 584 "/tmp/lalr5400" */
/* line 535 "occam.lalr" */
 CloseScope(); yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mPrototypeProc(Posn(yyAttrStackPtr [2-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree,Val(yyAttrStackPtr [8-1]).Ident,Val(yyAttrStackPtr [1-1]).Number); SymbolKind(S)=yySynAttribute.Tree; TypeFormals(yyAttrStackPtr [5-1].Tree);
} break;
case 896:
case 699: /* prototype : LANG typelist FUNCTION id LP O_fparmlist RP COLON proto_id .*/
  yyStateStackPtr -=9; yyAttrStackPtr -=9; yyNonterminal = 184; {
/* line 586 "/tmp/lalr5400" */
/* line 537 "occam.lalr" */
 CloseScope(); yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mPrototypeFunc(Posn(yyAttrStackPtr [2-1]),S=AddSymbol(Val(yyAttrStackPtr [4-1]).Ident),T=ReverseTree(yyAttrStackPtr [2-1].Tree),yyAttrStackPtr [6-1].Tree,Val(yyAttrStackPtr [9-1]).Ident,Val(yyAttrStackPtr [1-1]).Number); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [6-1].Tree);
} break;
case 897: /* proto_id : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 192; {
/* line 589 "/tmp/lalr5400" */
/* line 541 "occam.lalr" */
 Val(yySynAttribute).Ident = NoIdent; 
} break;
case 898:
case 576: /* proto_id : ID .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 192; {
/* line 591 "/tmp/lalr5400" */
/* line 543 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 899:
case 624: /* simpleproto : spectype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 193; {
/* line 594 "/tmp/lalr5400" */
/* line 546 "occam.lalr" */
  yySynAttribute.Tree = mSimple(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree); 
} break;
case 900:
case 626: /* simpleproto : numerictype DCOLON LSB RSB spectype .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 193; {
/* line 596 "/tmp/lalr5400" */
/* line 547 "occam.lalr" */
  yySynAttribute.Tree = mCounted(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,mArray(mUnBound(Posn(yyAttrStackPtr [4-1])),yyAttrStackPtr [5-1].Tree)); 
} break;
case 901:
case 474: /* simpleproto : ANY .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 193; {
/* line 598 "/tmp/lalr5400" */
/* line 548 "occam.lalr" */
  yySynAttribute.Tree = mAny(Posn(yyAttrStackPtr [1-1])); 
} break;
case 902:
case 649: /* seqproto : simpleproto .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 177; {
/* line 601 "/tmp/lalr5400" */
/* line 552 "occam.lalr" */
  yySynAttribute.Tree = mASeqPro(mNoSeqPro(),yyAttrStackPtr [1-1].Tree); 
} break;
case 903:
case 648: /* seqproto : seqproto SEMICOLON simpleproto .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 177; {
/* line 603 "/tmp/lalr5400" */
/* line 553 "occam.lalr" */
  yySynAttribute.Tree = mASeqPro(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree); 
} break;
case 904:
case 651: /* tagprotolist : tagproto .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 178; {
/* line 606 "/tmp/lalr5400" */
/* line 557 "occam.lalr" */
  yySynAttribute.Tree->ATagPro.Next = mNoTagPro(); 
} break;
case 905:
case 650: /* tagprotolist : tagprotolist sep tagproto .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 178; {
/* line 608 "/tmp/lalr5400" */
/* line 558 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree ; yySynAttribute.Tree->ATagPro.Next = yyAttrStackPtr [1-1].Tree; 
} break;
case 906: /* tagproto : ID .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 195; {
/* line 611 "/tmp/lalr5400" */
/* line 562 "occam.lalr" */
  yySynAttribute.Tree = mATagPro(NoTree,S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident),mNoSeqPro()); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=mByte(); 
} break;
case 907: /* tagproto : ID SEMICOLON seqproto .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 195; {
/* line 613 "/tmp/lalr5400" */
/* line 563 "occam.lalr" */
  yySynAttribute.Tree = mATagPro(NoTree,S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident),ReverseTree(yyAttrStackPtr [3-1].Tree)); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=mByte(); 
} break;
case 908:
case 473: /* protocol : ID .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 196; {
/* line 616 "/tmp/lalr5400" */
/* line 567 "occam.lalr" */
 yySynAttribute.Tree = mNamed(Posn(yyAttrStackPtr [1-1]),LookupSymbol(yyAttrStackPtr [1-1].Scan)); 
} break;
case 909:
case 625: /* protocol : simpleproto .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 196; {
/* line 618 "/tmp/lalr5400" */
/* line 568 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 910: /* assignment : varlist ASSIGN explist .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 133; {
/* line 621 "/tmp/lalr5400" */
/* line 572 "occam.lalr" */
 yySynAttribute.Tree = mAssign(Posn(yyAttrStackPtr [2-1]),mNoSpec(),ReverseTree(yyAttrStackPtr [1-1].Tree),ReverseTree(yyAttrStackPtr [3-1].Tree)); 
} break;
case 911: /* input : element QUERY ilist .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 134; {
/* line 624 "/tmp/lalr5400" */
/* line 576 "occam.lalr" */
  yySynAttribute.Tree = mInput(Posn(yyAttrStackPtr [2-1]),mNoSpec(),yyAttrStackPtr [1-1].Tree,ReverseTree(yyAttrStackPtr [3-1].Tree)); 
} break;
case 912:
case 701: /* after : element QUERY AFTER expr .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 135; {
/* line 627 "/tmp/lalr5400" */
/* line 579 "occam.lalr" */
  yySynAttribute.Tree = mAfter(Posn(yyAttrStackPtr [2-1]),mNoSpec(),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [4-1].Tree); 
} break;
case 913: /* caseinput : element QUERY case sep .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 129; {
/* line 630 "/tmp/lalr5400" */
/* line 582 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mCaseIn(Posn(yyAttrStackPtr [1-1]),mNoSpec(), yyAttrStackPtr [1-1].Tree,mNoCase()); 
} break;
case 914:
case 582: /* caseinput : element QUERY case sep BEGIN variantlist END .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 129; {
/* line 632 "/tmp/lalr5400" */
/* line 583 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mCaseIn(Posn(yyAttrStackPtr [1-1]),mNoSpec(), yyAttrStackPtr [1-1].Tree,ReverseTree(yyAttrStackPtr [6-1].Tree)); 
} break;
case 915: /* casesingle : element QUERY case ilist sep .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 130; {
/* line 635 "/tmp/lalr5400" */
/* line 586 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mCaseIn(Posn(yyAttrStackPtr [2-1]),mNoSpec(), yyAttrStackPtr [1-1].Tree,mACase(mNoCase(),mNoSpec(),ReverseTree(yyAttrStackPtr [4-1].Tree),mSkip(Posn(yyAttrStackPtr [2-1]),mNoSpec())));
} break;
case 916:
case 590: /* casesingleproc : element QUERY case ilist sep BEGIN process END .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 166; {
/* line 638 "/tmp/lalr5400" */
/* line 589 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mCaseIn(Posn(yyAttrStackPtr [2-1]),mNoSpec(), yyAttrStackPtr [1-1].Tree,mACase(mNoCase(),mNoSpec(),ReverseTree(yyAttrStackPtr [4-1].Tree),yyAttrStackPtr [7-1].Tree));
} break;
case 917:
case 706: /* variantlist : variant .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 200; {
/* line 641 "/tmp/lalr5400" */
/* line 593 "occam.lalr" */
 yySynAttribute.Tree->ACase.Next = mNoCase(); CloseScope(); OpenScope(); 
} break;
case 918:
case 705: /* variantlist : variantlist variant .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 200; {
/* line 643 "/tmp/lalr5400" */
/* line 594 "occam.lalr" */
 yySynAttribute.Scan =yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; yySynAttribute.Tree->ACase.Next = yyAttrStackPtr [1-1].Tree; CloseScope(); OpenScope(); 
} break;
case 919:
case 581: /* variant : ilist sep BEGIN process END .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 201; {
/* line 646 "/tmp/lalr5400" */
/* line 598 "occam.lalr" */
 yySynAttribute.Tree = mACase(NoTree,mNoSpec(),ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [4-1].Tree); 
} break;
case 920:
case 703: /* variant : specification sep variant .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 201; {
/* line 648 "/tmp/lalr5400" */
/* line 599 "occam.lalr" */
  yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->ACase.SpecList,yyAttrStackPtr [1-1].Tree);
} break;
case 921: /* output : element PLING olist .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 136; {
/* line 651 "/tmp/lalr5400" */
/* line 603 "occam.lalr" */
  yySynAttribute.Tree = mOutput(Posn(yyAttrStackPtr [2-1]),mNoSpec(),yyAttrStackPtr [1-1].Tree,ReverseTree(yyAttrStackPtr [3-1].Tree)); 
} break;
case 922:
case 709: /* olist : oitem .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 202; {
/* line 654 "/tmp/lalr5400" */
/* line 607 "occam.lalr" */
  yySynAttribute.Tree = mAnExpr(mNoExpr(), yyAttrStackPtr [1-1].Tree); 
} break;
case 923:
case 708: /* olist : olist SEMICOLON oitem .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 202; {
/* line 656 "/tmp/lalr5400" */
/* line 608 "occam.lalr" */
  yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 924: /* oitem : expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 203; {
/* line 659 "/tmp/lalr5400" */
/* line 611 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 925:
case 707: /* oitem : expr DCOLON expr .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 203; {
/* line 661 "/tmp/lalr5400" */
/* line 612 "occam.lalr" */
  yySynAttribute.Tree = mCountArray(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree); 
} break;
case 926:
case 704: /* ilist : iitem .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 199; {
/* line 664 "/tmp/lalr5400" */
/* line 615 "occam.lalr" */
  yySynAttribute.Tree = mAnExpr(mNoExpr(), yyAttrStackPtr [1-1].Tree); 
} break;
case 927:
case 702: /* ilist : ilist SEMICOLON iitem .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 199; {
/* line 666 "/tmp/lalr5400" */
/* line 616 "occam.lalr" */
  yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 928: /* iitem : element .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 204; {
/* line 669 "/tmp/lalr5400" */
/* line 619 "occam.lalr" */
  yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree); 
} break;
case 929: /* iitem : element DCOLON element .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 204; {
/* line 671 "/tmp/lalr5400" */
/* line 620 "occam.lalr" */
  yySynAttribute.Tree = mCountArray(Posn(yyAttrStackPtr [1-1]),mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree),mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree)); 
} break;
case 930:
case 635: /* explist : expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 138; {
/* line 674 "/tmp/lalr5400" */
/* line 624 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(mNoExpr(), yyAttrStackPtr [1-1].Tree); 
} break;
case 931:
case 630: /* explist : explist COMMA expr .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 138; {
/* line 676 "/tmp/lalr5400" */
/* line 625 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 932:
case 685: /* isexplist : expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 182; {
/* line 679 "/tmp/lalr5400" */
/* line 628 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(mNoExpr(), yyAttrStackPtr [1-1].Tree); 
} break;
case 933:
case 686: /* isexplist : isexplist comma expr .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 182; {
/* line 681 "/tmp/lalr5400" */
/* line 629 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 934: /* varlist : element .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 197; {
/* line 684 "/tmp/lalr5400" */
/* line 633 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(mNoExpr(), mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree)); 
} break;
case 935: /* varlist : varlist comma element .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 197; {
/* line 686 "/tmp/lalr5400" */
/* line 634 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree= mAnExpr(yyAttrStackPtr [1-1].Tree, mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree)); 
} break;
case 936:
case 697: /* typelist : primtype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 180; {
/* line 689 "/tmp/lalr5400" */
/* line 638 "occam.lalr" */
  yySynAttribute.Tree = mAType(mNoType(),yyAttrStackPtr [1-1].Tree); 
} break;
case 937:
case 698: /* typelist : arrtype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 180; {
/* line 691 "/tmp/lalr5400" */
/* line 639 "occam.lalr" */
  yySynAttribute.Tree = mAType(mNoType(),yyAttrStackPtr [1-1].Tree); 
} break;
case 938:
case 700: /* typelist : typelist comma spectype .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 180; {
/* line 693 "/tmp/lalr5400" */
/* line 640 "occam.lalr" */
  yySynAttribute.Tree = mAType(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree); 
} break;
case 939: /* O_fparmlist : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 179; {
/* line 696 "/tmp/lalr5400" */
/* line 644 "occam.lalr" */
 yySynAttribute.Tree = mNoFormals(SymSize+1); /* Identify next symbol to be declared  */ 
} break;
case 940:
case 692: /* O_fparmlist : fparmlist .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 179; {
/* line 698 "/tmp/lalr5400" */
/* line 646 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 941: /* fparmlist : firstparm .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 206; {
/* line 701 "/tmp/lalr5400" */
/* line 649 "occam.lalr" */
 yySynAttribute.Tree=yyAttrStackPtr [1-1].Tree; yySynAttribute.Tree->AFormal.Next = mNoFormal();
} break;
case 942:
case 695: /* fparmlist : firstparm comma fparmrest .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 206; {
/* line 703 "/tmp/lalr5400" */
/* line 650 "occam.lalr" */
 yySynAttribute.Tree=yyAttrStackPtr [1-1].Tree; yySynAttribute.Tree->AFormal.Next = yyAttrStackPtr [3-1].Tree;
} break;
case 943: /* fparmrest : fparm .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 706 "/tmp/lalr5400" */
/* line 654 "occam.lalr" */
 yySynAttribute.Tree=yyAttrStackPtr [1-1].Tree; yySynAttribute.Tree->AFormal.Next = mNoFormal();
} break;
case 944:
case 696: /* fparmrest : fparm comma fparmrest .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 208; {
/* line 708 "/tmp/lalr5400" */
/* line 655 "occam.lalr" */
 yySynAttribute.Tree=yyAttrStackPtr [1-1].Tree; yySynAttribute.Tree->AFormal.Next = yyAttrStackPtr [3-1].Tree;
} break;
case 945:
case 691: /* firstparm : spectype O_id .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 207; {
/* line 711 "/tmp/lalr5400" */
/* line 659 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByRef(),yyAttrStackPtr [1-1].Tree,S=Val(yyAttrStackPtr [2-1]).Symbol); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 946:
case 644: /* firstparm : VAL spectype O_id .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 207; {
/* line 713 "/tmp/lalr5400" */
/* line 660 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByVal(),yyAttrStackPtr [2-1].Tree,S=Val(yyAttrStackPtr [3-1]).Symbol); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 947:
case 694: /* fparm : spectype O_id .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 209; {
/* line 716 "/tmp/lalr5400" */
/* line 664 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByRef(),yyAttrStackPtr [1-1].Tree,S=Val(yyAttrStackPtr [2-1]).Symbol); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 948:
case 693: /* fparm : VAL spectype O_id .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 209; {
/* line 718 "/tmp/lalr5400" */
/* line 665 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByVal(),yyAttrStackPtr [2-1].Tree,S=Val(yyAttrStackPtr [3-1]).Symbol); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 949:
case 577: /* fparm : ID .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 209; {
/* line 720 "/tmp/lalr5400" */
/* line 666 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByUndef(),mUntyped(),S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 950: /* O_id : .*/
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 210; {
/* line 723 "/tmp/lalr5400" */
/* line 669 "occam.lalr" */
 CHK_Mode(xxPrototype,Attribute.Position); Val(yySynAttribute).Symbol=NoSymbol; 
} break;
case 951:
case 535: /* O_id : ID .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 210; {
/* line 725 "/tmp/lalr5400" */
/* line 670 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan;  Val(yySynAttribute).Symbol=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident);
} break;
case 952:
case 580: /* element : ID .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 198; {
/* line 728 "/tmp/lalr5400" */
/* line 673 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mUnmappedIdentifier(Posn(yyAttrStackPtr [1-1]), NoSymbol, CurrentScope(), Val(yyAttrStackPtr [1-1]).Ident); 
} break;
case 953:
case 490: /* element : element LSB subscript RSB .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 198; {
/* line 730 "/tmp/lalr5400" */
/* line 674 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mSubscript(Posn(yyAttrStackPtr [3-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 954:
case 522: /* element : LSB element FROM subscript FOR subscript RSB .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 198; {
/* line 732 "/tmp/lalr5400" */
/* line 675 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [6-1].Tree); 
} break;
case 955:
case 520: /* element : LSB element FOR subscript RSB .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 198; {
/* line 735 "/tmp/lalr5400" */
/* line 676 "occam.lalr" */
 
			yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan;
                        {
                          tValue tmp; tmp.Number = 0;
 			  yySynAttribute.Tree = mRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, mConst(Posn(yyAttrStackPtr [1-1]),tmp,mInt()), yyAttrStackPtr [4-1].Tree); 
                        }
			CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])) ; 
} break;
case 956:
case 521: /* element : LSB element FROM subscript RSB .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 198; {
/* line 745 "/tmp/lalr5400" */
/* line 683 "occam.lalr" */
 
			yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
			yySynAttribute.Tree = mRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree, mBinary(Posn(yyAttrStackPtr [1-1]),mUnary(Posn(yyAttrStackPtr [1-1]),mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree),mSize()),yyAttrStackPtr [4-1].Tree,mSubtract())); 
			CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])) ; 
} break;
case 957: /* elemental : element .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 174; {
/* line 752 "/tmp/lalr5400" */
/* line 689 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 958:
case 641: /* elemental : table_element .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 174; {
/* line 754 "/tmp/lalr5400" */
/* line 690 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 959:
case 631: /* subscript : expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 211; {
/* line 757 "/tmp/lalr5400" */
/* line 693 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 960:
case 496: /* table : LSB expr COMMA explist RSB .*/
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 213; {
/* line 760 "/tmp/lalr5400" */
/* line 696 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTable(Posn(yyAttrStackPtr [1-1]),mAnExpr(ReverseTree(yyAttrStackPtr [4-1].Tree),yyAttrStackPtr [2-1].Tree),Depth,S=AddSymbol(NoIdent)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 961:
case 491: /* table : table LSB subscript RSB .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 213; {
/* line 762 "/tmp/lalr5400" */
/* line 697 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTableSubscript(Posn(yyAttrStackPtr [3-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 962:
case 492: /* table : funccall LSB subscript RSB .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 213; {
/* line 764 "/tmp/lalr5400" */
/* line 698 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTableSubscript(Posn(yyAttrStackPtr [3-1]), TypeTableExpr(yyAttrStackPtr [1-1].Tree), yyAttrStackPtr [3-1].Tree); 
} break;
case 963:
case 523: /* table : LSB table_element FROM subscript FOR subscript RSB .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 213; {
/* line 766 "/tmp/lalr5400" */
/* line 699 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTableRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [6-1].Tree); 
} break;
case 964:
case 607: /* litrecord : LSB expr COMMA explist RSB LP TYPEID RP .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 215; {
/* line 769 "/tmp/lalr5400" */
/* line 702 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),mUserLiteral(Posn(yyAttrStackPtr [1-1]),mAnExpr(ReverseTree(yyAttrStackPtr [4-1].Tree),yyAttrStackPtr [2-1].Tree),Depth,S=AddSymbol(NoIdent),SymbolType(LookupSymbol(yyAttrStackPtr [7-1].Scan)))); 
} break;
case 965:
case 493: /* litrecord : sbexprlist LP TYPEID RP .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 215; {
/* line 771 "/tmp/lalr5400" */
/* line 703 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),mUserLiteral(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,Depth,S=AddSymbol(NoIdent),SymbolType(LookupSymbol(yyAttrStackPtr [3-1].Scan)))); 
} break;
case 966: /* table_element : table .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 212; {
/* line 774 "/tmp/lalr5400" */
/* line 707 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 967: /* table_element : sbexprlist .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 212; {
/* line 776 "/tmp/lalr5400" */
/* line 708 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTableElementFromExprList(yyAttrStackPtr [1-1].Tree,Posn(yyAttrStackPtr [1-1]),Depth); 
} break;
case 968: /* string_element : STR .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 217; {
/* line 779 "/tmp/lalr5400" */
/* line 711 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mString(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [1-1]).String,mUntyped(),Depth,S=AddSymbol(NoIdent)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 969:
case 611: /* string_element : STR LP datatype RP .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 217; {
/* line 781 "/tmp/lalr5400" */
/* line 712 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mString(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [1-1]).String,yyAttrStackPtr [3-1].Tree,Depth,S=AddSymbol(NoIdent)); SymbolKind(S)=yySynAttribute.Tree; CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); 
} break;
case 970:
case 494: /* string_element : string_element LSB subscript RSB .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 217; {
/* line 783 "/tmp/lalr5400" */
/* line 713 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mStringSubscript(Posn(yyAttrStackPtr [3-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 971:
case 608: /* string_element : LSB string_element FROM subscript FOR subscript RSB .*/
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 217; {
/* line 785 "/tmp/lalr5400" */
/* line 714 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mStringRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [6-1].Tree); 
} break;
case 972:
case 634: /* expr : monop operand .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 139; {
/* line 788 "/tmp/lalr5400" */
/* line 717 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mUnary(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree); 
} break;
case 973:
case 734: /* expr : SIZE operand .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 139; {
/* line 790 "/tmp/lalr5400" */
/* line 718 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mUnary(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, mSize()); 
} break;
case 974:
case 733: /* expr : SIZE spectype .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 139; {
/* line 792 "/tmp/lalr5400" */
/* line 719 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mSizeOf(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree); 
} break;
case 975:
case 636: /* expr : operand dyop operand .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 139; {
/* line 794 "/tmp/lalr5400" */
/* line 720 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBinary(Posn(yyAttrStackPtr [2-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 976: /* expr : operand .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 139; {
/* line 796 "/tmp/lalr5400" */
/* line 721 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 977:
case 639: /* expr : conversion .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 139; {
/* line 798 "/tmp/lalr5400" */
/* line 722 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 978: /* expr : boolexpr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 139; {
/* line 800 "/tmp/lalr5400" */
/* line 723 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 979:
case 479: /* lp : LP .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 223; {
/* line 803 "/tmp/lalr5400" */
/* line 726 "occam.lalr" */
 OpenScope(); OpenScope(); PushColumn(Posn(yyAttrStackPtr [1-1]).Column); PushTokenColumn(); 
} break;
case 980:
case 638: /* boolexpr : operand boolop operand .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 222; {
/* line 806 "/tmp/lalr5400" */
/* line 729 "occam.lalr" */
yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBinary(Posn(yyAttrStackPtr [2-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 981:
case 640: /* boolexpr : boolexpr boolop operand .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 222; {
/* line 808 "/tmp/lalr5400" */
/* line 730 "occam.lalr" */
yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBinary(Posn(yyAttrStackPtr [2-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 982:
case 613: /* funccall : ID LP explist RP .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 214; {
/* line 811 "/tmp/lalr5400" */
/* line 733 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = CreateFuncCall(Posn(yyAttrStackPtr [1-1]), LookupSymbol(yyAttrStackPtr [1-1].Scan),ReverseTree(yyAttrStackPtr [3-1].Tree),Depth); 
} break;
case 983:
case 612: /* funccall : ID LP RP .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 214; {
/* line 813 "/tmp/lalr5400" */
/* line 734 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = CreateFuncCall(Posn(yyAttrStackPtr [1-1]), LookupSymbol(yyAttrStackPtr [1-1].Scan),mNoExpr(),Depth); 
} break;
case 984: /* operand : element .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 219; {
/* line 816 "/tmp/lalr5400" */
/* line 737 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree); 
} break;
case 985:
case 632: /* operand : table_element .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 219; {
/* line 818 "/tmp/lalr5400" */
/* line 738 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree); 
} break;
case 986: /* operand : string_element .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 219; {
/* line 820 "/tmp/lalr5400" */
/* line 739 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 987:
case 637: /* operand : intliteral .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 219; {
/* line 822 "/tmp/lalr5400" */
/* line 740 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 988:
case 476: /* operand : RNUMBER LP primtype RP .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 219; {
/* line 825 "/tmp/lalr5400" */
/* line 741 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree); if (!Tree_IsType(yyAttrStackPtr [3-1].Tree,kReal)) Message("Constant of inappropriate type",xxError,Posn(yyAttrStackPtr [1-1])); 
} break;
case 989: /* operand : RNUMBER .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 219; {
/* line 826 "/tmp/lalr5400" */
/* line 742 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [1-1]),mUntypedReal()); 
} break;
case 990:
case 605: /* operand : lp expr RP .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 219; {
/* line 828 "/tmp/lalr5400" */
/* line 743 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; CloseScope(); CloseScope(); PopColumn(); PopColumn(); 
} break;
case 991:
case 606: /* operand : lp valof RP .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 219; {
/* line 830 "/tmp/lalr5400" */
/* line 744 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; CloseScope(); PopColumn(); 
} break;
case 992:
case 629: /* operand : MOSTPOS numerictype .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 219; {
/* line 832 "/tmp/lalr5400" */
/* line 745 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMostPos(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree); 
} break;
case 993:
case 628: /* operand : MOSTNEG numerictype .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 219; {
/* line 834 "/tmp/lalr5400" */
/* line 746 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMostNeg(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree); 
} break;
case 994:
case 633: /* operand : litrecord .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 219; {
/* line 836 "/tmp/lalr5400" */
/* line 747 "occam.lalr" */
 CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); 
} break;
case 995:
case 610: /* operand : BYTESIN LP datatype RP .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 219; {
/* line 838 "/tmp/lalr5400" */
/* line 748 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; yySynAttribute.Tree = mBytesInType(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [3-1].Tree);  CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); 
} break;
case 996:
case 609: /* operand : BYTESIN LP expr RP .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 219; {
/* line 840 "/tmp/lalr5400" */
/* line 749 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; yySynAttribute.Tree = mBytesInExpr(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [3-1].Tree);  CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); 
} break;
case 997:
case 489: /* operand : OFFSETOF LP TYPEID comma ID RP .*/
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 219; {
/* line 842 "/tmp/lalr5400" */
/* line 750 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mOffsetOf(Posn(yyAttrStackPtr [1-1]),SymbolType(LookupSymbol(yyAttrStackPtr [3-1].Scan)),mUnmappedIdentifier(Posn(yyAttrStackPtr [5-1]), NoSymbol, CurrentScope(), Val(yyAttrStackPtr [5-1]).Ident));  CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); 
} break;
case 998: /* operand : funccall .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 219; {
/* line 844 "/tmp/lalr5400" */
/* line 751 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 999:
case 478: /* monop : SUBTRACT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 847 "/tmp/lalr5400" */
/* line 755 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mSubtract(); 
} break;
case 1000:
case 484: /* monop : NOT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 849 "/tmp/lalr5400" */
/* line 756 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mNot(); 
} break;
case 1001:
case 481: /* monop : BITNOT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 851 "/tmp/lalr5400" */
/* line 757 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBitNot(); 
} break;
case 1002:
case 477: /* monop : ADD .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 853 "/tmp/lalr5400" */
/* line 758 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAdd(); 
} break;
case 1003:
case 483: /* monop : MINUS .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 855 "/tmp/lalr5400" */
/* line 759 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMinus(); 
} break;
case 1004:
case 485: /* monop : PLUS .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 857 "/tmp/lalr5400" */
/* line 760 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mPlus(); 
} break;
case 1005:
case 497: /* dyop : LT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 860 "/tmp/lalr5400" */
/* line 763 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mLess(); 
} break;
case 1006:
case 498: /* dyop : GT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 862 "/tmp/lalr5400" */
/* line 764 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mGreater(); 
} break;
case 1007:
case 499: /* dyop : LE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 864 "/tmp/lalr5400" */
/* line 765 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mLessEqual(); 
} break;
case 1008:
case 500: /* dyop : GE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 866 "/tmp/lalr5400" */
/* line 766 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mGreaterEqual(); 
} break;
case 1009:
case 501: /* dyop : EQ .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 868 "/tmp/lalr5400" */
/* line 767 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mEqual(); 
} break;
case 1010:
case 502: /* dyop : NE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 870 "/tmp/lalr5400" */
/* line 768 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mNotEqual(); 
} break;
case 1011:
case 503: /* dyop : ADD .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 872 "/tmp/lalr5400" */
/* line 769 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAdd(); 
} break;
case 1012:
case 504: /* dyop : SUBTRACT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 874 "/tmp/lalr5400" */
/* line 770 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mSubtract(); 
} break;
case 1013:
case 505: /* dyop : MULTIPLY .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 876 "/tmp/lalr5400" */
/* line 771 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMultiply(); 
} break;
case 1014:
case 506: /* dyop : DIVIDE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 878 "/tmp/lalr5400" */
/* line 772 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mDivide(); 
} break;
case 1015:
case 512: /* dyop : BITAND .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 880 "/tmp/lalr5400" */
/* line 773 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBitAnd(); 
} break;
case 1016:
case 513: /* dyop : BITOR .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 882 "/tmp/lalr5400" */
/* line 774 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBitOr(); 
} break;
case 1017:
case 507: /* dyop : BITEOR .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 884 "/tmp/lalr5400" */
/* line 775 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBitEor(); 
} break;
case 1018:
case 508: /* dyop : LSHIFT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 886 "/tmp/lalr5400" */
/* line 776 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mLeftShift(); 
} break;
case 1019:
case 509: /* dyop : RSHIFT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 888 "/tmp/lalr5400" */
/* line 777 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRightShift(); 
} break;
case 1020:
case 517: /* dyop : REM .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 890 "/tmp/lalr5400" */
/* line 778 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRem(); 
} break;
case 1021:
case 514: /* dyop : MINUS .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 892 "/tmp/lalr5400" */
/* line 779 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMinus(); 
} break;
case 1022:
case 516: /* dyop : PLUS .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 894 "/tmp/lalr5400" */
/* line 780 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mPlus(); 
} break;
case 1023:
case 518: /* dyop : TIMES .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 896 "/tmp/lalr5400" */
/* line 781 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTimes(); 
} break;
case 1024:
case 510: /* dyop : AFTER .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 220; {
/* line 898 "/tmp/lalr5400" */
/* line 782 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAfterOp(); 
} break;
case 1025:
case 511: /* boolop : AND .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 224; {
/* line 901 "/tmp/lalr5400" */
/* line 785 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnd(); 
} break;
case 1026:
case 515: /* boolop : OR .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 224; {
/* line 903 "/tmp/lalr5400" */
/* line 786 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mOr(); 
} break;
case 1027:
case 717: /* conversion : primtype operand .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 221; {
/* line 906 "/tmp/lalr5400" */
/* line 789 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConvert(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1028:
case 732: /* conversion : primtype ROUND operand .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 221; {
/* line 908 "/tmp/lalr5400" */
/* line 790 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRound(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1029:
case 716: /* conversion : primtype TRUNC operand .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 221; {
/* line 910 "/tmp/lalr5400" */
/* line 791 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTrunc(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1030: /* intliteral : NUMBER .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 225; {
/* line 913 "/tmp/lalr5400" */
/* line 794 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mUntyped(),Val(yyAttrStackPtr [1-1]).Number,false),mUntypedInt()); 
} break;
case 1031: /* intliteral : HEXNUMBER .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 225; {
/* line 915 "/tmp/lalr5400" */
/* line 795 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mUntyped(),Val(yyAttrStackPtr [1-1]).Number,true),mUntypedHex()); 
} break;
case 1032: /* intliteral : TRUE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 225; {
/* line 917 "/tmp/lalr5400" */
/* line 796 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mBool(),true,false),mBool()); 
} break;
case 1033: /* intliteral : FALSE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 225; {
/* line 919 "/tmp/lalr5400" */
/* line 797 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mBool(),false,false),mBool()); 
} break;
case 1034: /* intliteral : CHCON .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 225; {
/* line 921 "/tmp/lalr5400" */
/* line 798 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mByte(),Val(yyAttrStackPtr [1-1]).Char,true),mUntypedByte()); 
} break;
case 1035:
case 470: /* intliteral : NUMBER LP numerictype RP .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 225; {
/* line 923 "/tmp/lalr5400" */
/* line 799 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,Val(yyAttrStackPtr [1-1]).Number,false),yyAttrStackPtr [3-1].Tree); 
} break;
case 1036:
case 471: /* intliteral : HEXNUMBER LP numerictype RP .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 225; {
/* line 925 "/tmp/lalr5400" */
/* line 800 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,Val(yyAttrStackPtr [1-1]).Number,true),yyAttrStackPtr [3-1].Tree); 
} break;
case 1037:
case 472: /* intliteral : CHCON LP numerictype RP .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 225; {
/* line 927 "/tmp/lalr5400" */
/* line 801 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,Val(yyAttrStackPtr [1-1]).Char,true),yyAttrStackPtr [3-1].Tree); 
} break;
case 1038:
case 486: /* intliteral : TRUE LP numerictype RP .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 225; {
/* line 929 "/tmp/lalr5400" */
/* line 802 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,true,false),yyAttrStackPtr [3-1].Tree); 
} break;
case 1039:
case 482: /* intliteral : FALSE LP numerictype RP .*/
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 225; {
/* line 931 "/tmp/lalr5400" */
/* line 803 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,false,false),yyAttrStackPtr [3-1].Tree); 
} break;
case 1040:
case 575: /* valoftok : VALOF .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 226; {
/* line 934 "/tmp/lalr5400" */
/* line 806 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; OpenScope(); 
} break;
case 1041:
case 578: /* result : RESULT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 227; {
/* line 937 "/tmp/lalr5400" */
/* line 809 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); PopColumn(); 
} break;
case 1042:
case 579: /* valof : valoftok sep BEGIN process result explist sep END .*/
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 181; {
/* line 940 "/tmp/lalr5400" */
/* line 812 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mValof(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [4-1].Tree,ReverseTree(yyAttrStackPtr [6-1].Tree),S=AddSymbol(NoIdent),Depth); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 1043:
case 687: /* valof : specification sep valof .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 181; {
/* line 942 "/tmp/lalr5400" */
/* line 813 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->Valof.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 1044:
case 617: /* spectype : primtype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 183; {
/* line 945 "/tmp/lalr5400" */
/* line 816 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 1045:
case 618: /* spectype : arrtype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 183; {
/* line 947 "/tmp/lalr5400" */
/* line 817 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 1046:
case 653: /* datatype : numerictype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 187; {
/* line 950 "/tmp/lalr5400" */
/* line 820 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 1047:
case 652: /* datatype : arrtype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 187; {
/* line 952 "/tmp/lalr5400" */
/* line 821 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 1048:
case 627: /* primtype : CHAN OF protocol .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 167; {
/* line 955 "/tmp/lalr5400" */
/* line 824 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mChan(yyAttrStackPtr [3-1].Tree); last_type_was_chan=true; 
} break;
case 1049:
case 619: /* primtype : PORT OF spectype .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 167; {
/* line 958 "/tmp/lalr5400" */
/* line 825 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mChan(mSimple(Posn(yyAttrStackPtr [3-1]),yyAttrStackPtr [3-1].Tree)); if (ArePortsSupported==false) Message("PORT not supported",xxError,Posn(yyAttrStackPtr [1-1])); last_type_was_chan=true; 
} break;
case 1050:
case 475: /* primtype : TIMER .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 167; {
/* line 959 "/tmp/lalr5400" */
/* line 826 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTimer(); last_type_was_chan=false; 
} break;
case 1051:
case 620: /* primtype : numerictype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 167; {
/* line 961 "/tmp/lalr5400" */
/* line 827 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; last_type_was_chan=false;
} break;
case 1052:
case 615: /* numerictype : inttype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 194; {
/* line 964 "/tmp/lalr5400" */
/* line 830 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 1053:
case 616: /* numerictype : realtype .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 194; {
/* line 966 "/tmp/lalr5400" */
/* line 831 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 1054:
case 461: /* numerictype : TYPEID .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 194; {
/* line 968 "/tmp/lalr5400" */
/* line 832 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = SymbolType(LookupSymbol(yyAttrStackPtr [1-1].Scan)); CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); 
} break;
case 1055:
case 462: /* inttype : BOOL .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 228; {
/* line 971 "/tmp/lalr5400" */
/* line 835 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBool(); 
} break;
case 1056:
case 463: /* inttype : BYTE .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 228; {
/* line 973 "/tmp/lalr5400" */
/* line 836 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mByte(); 
} break;
case 1057:
case 464: /* inttype : INT .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 228; {
/* line 975 "/tmp/lalr5400" */
/* line 837 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mInt(); 
} break;
case 1058:
case 465: /* inttype : INT16 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 228; {
/* line 977 "/tmp/lalr5400" */
/* line 838 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mInt16(); 
} break;
case 1059:
case 466: /* inttype : INT32 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 228; {
/* line 979 "/tmp/lalr5400" */
/* line 839 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mInt32(); 
} break;
case 1060:
case 467: /* inttype : INT64 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 228; {
/* line 982 "/tmp/lalr5400" */
/* line 840 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; if (IS_Mode(xxSupportINT64)) yySynAttribute.Tree = mInt64(); else { Message("No INT64 support therefore converting to INT32",xxWarning,Posn(yyAttrStackPtr [1-1])); yySynAttribute.Tree = mInt32(); } 
} break;
case 1061:
case 468: /* realtype : REAL32 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 229; {
/* line 985 "/tmp/lalr5400" */
/* line 843 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mReal32(); if (AreRealsSupported==false) Message("REAL32 not supported",xxError,Posn(yyAttrStackPtr [1-1])); 
} break;
case 1062:
case 469: /* realtype : REAL64 .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 229; {
/* line 987 "/tmp/lalr5400" */
/* line 844 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mReal64(); if (AreRealsSupported==false) Message("REAL64 not supported",xxError,Posn(yyAttrStackPtr [1-1])); 
} break;
case 1063:
case 621: /* arrtype : sbexprlist primtype .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 169; {
/* line 989 "/tmp/lalr5400" */
/* line 847 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mArrayFromExprList(ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [2-1].Tree); 
} break;
case 1064:
case 480: /* sbexpr : LSB RSB .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 230; {
/* line 992 "/tmp/lalr5400" */
/* line 850 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mUnBound(Posn(yyAttrStackPtr [1-1])); 
} break;
case 1065:
case 519: /* sbexpr : LSB expr RSB .*/
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 230; {
/* line 994 "/tmp/lalr5400" */
/* line 851 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree ; 
} break;
case 1066:
case 623: /* sbexprlist : sbexpr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 216; {
/* line 997 "/tmp/lalr5400" */
/* line 854 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(mNoExpr(),yyAttrStackPtr [1-1].Tree) ; 
} break;
case 1067:
case 622: /* sbexprlist : sbexprlist sbexpr .*/
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 216; {
/* line 999 "/tmp/lalr5400" */
/* line 855 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [2-1].Tree); 
} break;
case 1068:
case 677: /* boolean : expr .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 163; {
/* line 1002 "/tmp/lalr5400" */
/* line 858 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
} break;
case 1069:
case 488: /* comma : COMMA .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 205; {

} break;
case 1070:
case 487: /* comma : DECLCOMMA .*/
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 205; {

} break;
}

	       /* SPEC State = Next (Top (), Nonterminal); nonterminal transition */
	       yyState = * (yyNBasePtr [* yyStateStackPtr ++] + yyNonterminal);
	       * yyAttrStackPtr ++ = yySynAttribute;
	       if (yyState < yyFirstFinalState) goto ParseLoop; /* read nonterminal reduce ? */
	    } 

	 } else {					/* read */
	    yyStateStackPtr ++;
	    yyGetAttribute (yyAttrStackPtr ++, Attribute);
	    yyTerminal = GetToken ();
	    yyIsRepairing = false;
	 }
      }
   }

static void yyErrorRecovery
# if defined __STDC__ | defined __cplusplus
   (yySymbolRange * yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr)
# else
   (yyTerminal, yyStateStack, yyStackSize, yyStackPtr)
   yySymbolRange *	yyTerminal	;
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
# endif
   {
      bool	yyTokensSkipped	;
      tSet	yyContinueSet	;
      tSet	yyRestartSet	;
      int	yyLength = 0	;
      char	yyContinueString [256];

   /* 1. report an error */
      ErrorMessage (xxSyntaxError, xxError, Attribute.Position);

   /* 2. report the set of expected terminal symbols */
      MakeSet (& yyContinueSet, (short) yyLastTerminal);
      yyComputeContinuation (yyStateStack, yyStackSize, yyStackPtr, & yyContinueSet);
      yyContinueString [0] = '\0';
      while (! IsEmpty (& yyContinueSet)) {
	 char * yyTokenString = Parser_TokenName [Extract (& yyContinueSet)];
	 if ((yyLength += strlen (yyTokenString) + 1) >= 256) break;
	 (void) strcat (yyContinueString, yyTokenString);
	 (void) strcat (yyContinueString, " ");
      }
      ErrorMessageI (xxExpectedTokens, xxInformation, Attribute.Position,
	 xxString, yyContinueString);
      ReleaseSet (& yyContinueSet);

   /* 3. compute the set of terminal symbols for restart of the parse */
      MakeSet (& yyRestartSet, (short) yyLastTerminal);
      yyComputeRestartPoints (yyStateStack, yyStackSize, yyStackPtr, & yyRestartSet);

   /* 4. skip terminal symbols until a restart point is reached */
      yyTokensSkipped = false;
      while (! IsElement (* yyTerminal, & yyRestartSet)) {
	 * yyTerminal = GetToken ();
	 yyTokensSkipped = true;
      }
      ReleaseSet (& yyRestartSet);

   /* 5. report the restart point */
      if (yyTokensSkipped) {
	 ErrorMessage (xxRestartPoint, xxInformation, Attribute.Position);
      }
   }

/*
   compute the set of terminal symbols that can be accepted (read)
   in a given stack configuration (eventually after reduce actions)
*/

static void yyComputeContinuation
# if defined __STDC__ | defined __cplusplus
   (yyStateRange * yyStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyContinueSet)
# else
   (yyStack, yyStackSize, yyStackPtr, yyContinueSet)
   yyStateRange *	yyStack		;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
   tSet *		yyContinueSet	;
# endif
   {
      register yySymbolRange	yyTerminal;
      register yyStateRange	yyState = yyStack [yyStackPtr];

      AssignEmpty (yyContinueSet);
      for (yyTerminal = yyFirstTerminal; yyTerminal <= yyLastTerminal; yyTerminal ++) {
	 if (yyNext (yyState, yyTerminal) != yyNoState &&
	    yyIsContinuation (yyTerminal, yyStack, yyStackSize, yyStackPtr)) {
	    Include (yyContinueSet, (short) yyTerminal);
	 }
      }
   }

/*
   check whether a given terminal symbol can be accepted (read)
   in a certain stack configuration (eventually after reduce actions)
*/

static bool yyIsContinuation
# if defined __STDC__ | defined __cplusplus
   (yySymbolRange yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr)
# else
   (yyTerminal, yyStateStack, yyStackSize, yyStackPtr)
   yySymbolRange	yyTerminal	;
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
# endif
   {
      register yyStateRange	yState		;
      register yySymbolRange	yyNonterminal	;
	       yyStateRange *	yyStack		;
   
      MakeArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));	/* pass Stack by value */
# ifdef BCOPY
      bcopy ((char *) yyStateStack, (char *) yyStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# else
      (void) memcpy ((char *) yyStack, (char *) yyStateStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# endif

      yState = yyStack [yyStackPtr];
      for (;;) {
	 yyStack [yyStackPtr] = yState;
	 yState = yyNext (yState, yyTerminal);
	 if (yState == yyNoState) {
	    ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    return false;
	 }
	 if (yState <= yyLastReadTermState) {		/* read or read terminal reduce ? */
	    ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    return true;
	 }

	 for (;;) {					/* reduce */
	    if (yState == yyStopState) {
	       ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	       return true;
	    } else { 
	       yyStackPtr -= yyLength [yState - yyFirstReduceState];
	       yyNonterminal = yyLeftHandSide [yState - yyFirstReduceState];
	    }

	    yState = yyNext (yyStack [yyStackPtr], yyNonterminal);
	    if (yyStackPtr >= yyStackSize) {
	       ExtendArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    }
	    yyStackPtr ++;
	    if (yState < yyFirstFinalState) break;	/* read nonterminal ? */
	    yState = yyFinalToProd [yState - yyFirstReadTermState];	/* read nonterminal reduce */
	 }
      }
   }

/*
   compute a set of terminal symbols that can be used to restart
   parsing in a given stack configuration. we simulate parsing until
   end of file using a suffix program synthesized by the function
   Continuation. All symbols acceptable in the states reached during
   the simulation can be used to restart parsing.
*/

static void yyComputeRestartPoints
# if defined __STDC__ | defined __cplusplus
   (yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyRestartSet)
# else
   (yyStateStack, yyStackSize, yyStackPtr, yyRestartSet)
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
   tSet *		yyRestartSet	;
# endif
   {
      register yyStateRange	yState		;
      register yySymbolRange	yyNonterminal	;
	       yyStateRange *	yyStack		;
	       tSet		yyContinueSet	;
   
      MakeArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange)); /* pass Stack by value */
# ifdef BCOPY
      bcopy ((char *) yyStateStack, (char *) yyStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# else
      (void) memcpy ((char *) yyStack, (char *) yyStateStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# endif

      MakeSet (& yyContinueSet, (short) yyLastTerminal);
      AssignEmpty (yyRestartSet);
      yState = yyStack [yyStackPtr];

      for (;;) {
	 if (yyStackPtr >= yyStackSize) {
	    ExtendArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	 }
	 yyStack [yyStackPtr] = yState;
	 yyComputeContinuation (yyStack, yyStackSize, yyStackPtr, & yyContinueSet);
	 Union (yyRestartSet, & yyContinueSet);
	 yState = yyNext (yState, yyContinuation [yState]);

	 if (yState >= yyFirstFinalState) {		/* final state ? */
	    if (yState <= yyLastReadTermState) {	/* read terminal reduce ? */
	       yyStackPtr ++;
	       yState = yyFinalToProd [yState - yyFirstReadTermState];
	    }

	    for (;;) {					/* reduce */
	       if (yState == yyStopState) {
		  ReleaseSet (& yyContinueSet);
		  ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
		  return;
	       } else { 
		  yyStackPtr -= yyLength [yState - yyFirstReduceState];
		  yyNonterminal = yyLeftHandSide [yState - yyFirstReduceState];
	       }

	       yState = yyNext (yyStack [yyStackPtr], yyNonterminal);
	       yyStackPtr ++;
	       if (yState < yyFirstFinalState) break;	/* read nonterminal ? */
	       yState = yyFinalToProd [yState - yyFirstReadTermState]; /* read nonterminal reduce */
	    }
	 } else {					/* read */
	    yyStackPtr ++;
	 }
      }
   }

/* access the parse table:   Next : State x Symbol -> Action */

static yyStateRange yyNext
# if defined __STDC__ | defined __cplusplus
   (yyStateRange yyState, yySymbolRange yySymbol)
# else
   (yyState, yySymbol) yyStateRange yyState; yySymbolRange yySymbol;
# endif
   {
      register yyTCombType * yyTCombPtr;

      if (yySymbol <= yyLastTerminal) {
	 for (;;) {
	    yyTCombPtr = yyTBasePtr [yyState] + yySymbol;
	    if (yyTCombPtr->Check != yyState) {
	       if ((yyState = yyDefault [yyState]) == yyNoState) return yyNoState;
	    } else {
	       return yyTCombPtr->Next;
	    }
	 }
      } else {
	return * (yyNBasePtr [yyState] + yySymbol);
      }
   }

static void BeginParser ()
   {
/* line 47 "/tmp/lalr5400" */
/* line 62 "occam.lalr" */

  OpenScope();
  Vtrue.Number = true;
  Vfalse.Number = false;

   }

void CloseParser ()
   {
/* line 55 "/tmp/lalr5400" */
/* line 70 "occam.lalr" */

  CloseScope();

   }
