# include "TypeChk.h"
# include "yyTypeChk.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"

# define yyInline
# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

/* line 65 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */


  #include "Positions.h"
  #include <stdlib.h>
  #include <math.h>

  #undef MAX
  #define MAX(a,b) ((a > b) ? a : b)
  /*{{{  void RetypeConst(int ss,tConstArray src, int ds, tConstArray dest)*/
  /* Retype a ConstArray section -
  
     ConstArray values are stored in compiler-endianness, to allow direct
     casting for constant folding/output
  
     To retype, is the endianness of the compiler/target architectures differ,
     we must perform two stages.
  
     1. Copy source to temporary, performing source type endianness swap
	This leaves temporary in target machine endianness
     2. Copy temporary to destination, performing destination type endianness swap
	This converts temporary into correct types, in compiler endianness
  */
  
  void RetypeConst(int ss,tConstArray src, int ds, tConstArray dest)
  {
    int sz = (ds > ss) ? ds : ss;
    int i;
    int val = 1;
    bool Compiler_is_LittleEndian = (((char *)&val)[0]) == 1;
    unsigned char tmp[8];
  
    if ((!IS_Mode(xxLittleEndian) && Compiler_is_LittleEndian)
	||(IS_Mode(xxLittleEndian) && !Compiler_is_LittleEndian))
    {
      for(i = 0; i < sz; ++i) tmp[i] = src[i ^ (ss-1)]; 
      for(i = 0; i < sz; ++i) dest[i] = tmp[i ^ (ds-1)]; 
    }
    else
    {
      for(i = 0; i < sz; ++i) dest[i] = src[i];
    }
  }
  
  /*}}}*/
  tSymbol FirstFormal,FirstActual,FunctionInlining;


static void yyExit () { Exit (1); }

void (* TypeChk_Exit) () = yyExit;

extern FILE *yyf;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module TypeChk, routine %s failed\n", yyFunction);
 TypeChk_Exit ();
}

tTree TypeUserDataType ARGS((tTree yyP3, tSymbol yyP2, tPosition yyP1));
void TypeFormals ARGS((tTree yyP4));
void TypeDecl ARGS((tTree yyP6, tTree yyP5));
tTree TypeAbbrev ARGS((tTree yyP9, tTree yyP8, tPosition yyP7));
tTree TypeSubscript ARGS((tTree yyP13, tTree yyP12, tTree yyP11, tPosition yyP10));
tTree TypeRange ARGS((tTree yyP17, tTree yyP16, tTree yyP15, tPosition yyP14));
tTree TypeBinary ARGS((tTree yyP21, tTree yyP20, tTree yyP19, tPosition yyP18));
tTree TypeUnary ARGS((tTree yyP24, tTree yyP23, tPosition yyP22));
static tTree TypeExprSubList ARGS((tTree yyP25));
tTree TypeExprList ARGS((tTree yyP26));
tTree TypeTable ARGS((tTree yyP29, tTree yyP28, tTree yyP27));
tTree TypeTableExpr ARGS((tTree yyP30));
tTree TypeString ARGS((int yyP33, tTree yyP32, tPosition yyP31));
tTree StripTypeList ARGS((tTree yyP34));
tTree SynthDefType ARGS((tTree yyP37, tTree yyP36, tTree yyP35));
tTree SynthDefTableType ARGS((tTree yyP38));
tTree SynthDefSubscriptType ARGS((tTree yyP40, tTree yyP39));
tTree DefaultType ARGS((tTree yyP41));
tTree InheritLhsType ARGS((tTree yyP43, tTree yyP42));
void InheritFromFormals ARGS((tTree yyP45, tTree yyP44));
static void InheritFromSimpleProtocol ARGS((tTree yyP47, tTree yyP46));
void InheritFromProtocol ARGS((tTree yyP49, tTree yyP48));
static void InheritFromFieldList ARGS((tTree yyP51, tTree yyP50));
void InheritFromTable ARGS((tTree yyP53, tTree yyP52));
void InheritFromType ARGS((tTree yyP55, tTree yyP54));
static void InheritAttributes ARGS((tTree yyP57, tTree yyP56));
tTree TransformUserLiterals ARGS((tTree yyP59, tTree yyP58));
void TypeCheckAssign ARGS((tTree yyP62, tTree yyP61, tPosition yyP60));
static void TypeCheckAssignList ARGS((tTree yyP65, tTree yyP64, tPosition yyP63));
static void TypeCheckAssignFn ARGS((tTree yyP68, tTree yyP67, tPosition yyP66));
void TypeCheckResults ARGS((tTree yyP71, tTree yyP70, tPosition yyP69));
void TypeCheckParameters ARGS((tTree yyP75, tTree yyP74, tPosition yyP73, int yyP72));
void UpdateElementalUsage ARGS((tTree yyP77, tUsage yyP76));
void TypeCheckIfList ARGS((tTree yyP78));
void TypeCheckTimerInput ARGS((tTree yyP80, tPosition yyP79));
void TypeCheckInputProtocol ARGS((tTree yyP83, tTree yyP82, tPosition yyP81));
static void TypeCheckSimpleProtocol ARGS((tTree yyP85, tTree yyP84));
void TypeCheckOutputProtocol ARGS((tTree yyP88, tTree yyP87, tPosition yyP86));
void TypeCheckCaseInputs ARGS((tTree yyP91, tTree yyP90, tPosition yyP89));
static void TypeCheckCaseOutput ARGS((tTree yyP94, tTree yyP93, tPosition yyP92));
static void TypeCheckInputSeqProtocol ARGS((tTree yyP97, tTree yyP96, tPosition yyP95));
static void TypeCheckOutputSeqProtocol ARGS((tTree yyP100, tTree yyP99, tPosition yyP98));
void TypeCheckCaseList ARGS((tTree yyP103, tTree yyP102, bool yyP101));
void TypeCheckRetypes ARGS((tTree yyP107, tTree yyP106, tTree yyP105, tPosition yyP104));
static void DoTypeCheckRetypes ARGS((int yyP112, tTree yyP111, int yyP110, tTree yyP109, tPosition yyP108));
bool IsUserDataType ARGS((tTree yyP113));
static tSymbol WhichUserDataType ARGS((tTree yyP114));
bool IsComputableType ARGS((tTree yyP115));
bool CheckPragmaTrack ARGS((tTree yyP118, int yyP117, int yyP116));
bool SameBaseType ARGS((tTree yyP120, tTree yyP119));
bool SameUnderlyingType ARGS((tTree yyP122, tTree yyP121));
static bool SameType ARGS((tTree yyP124, tTree yyP123));
static bool CheckValidTag ARGS((tTree yyP126, tSymbol yyP125));
static bool SameProtocol ARGS((tTree yyP128, tTree yyP127));
bool CheckWritable ARGS((tTree yyP129));
bool CheckWritableExprList ARGS((tTree yyP130));
bool CheckForVals ARGS((tTree yyP131));
bool CheckValofScope ARGS((tTree yyP133, int yyP132));
bool IsChanOrTimerType ARGS((tTree yyP134));
static bool IsDataType ARGS((tTree yyP135));
bool IsChanType ARGS((tTree yyP136));
bool IsTimerType ARGS((tTree yyP137));
bool IsArrayType ARGS((tTree yyP138));
bool IsScalarType ARGS((tTree yyP139));
static bool CheckChoicesDiffer ARGS((tTree yyP141, tTree yyP140));
static bool CheckExprDiffers ARGS((tTree yyP144, tTree yyP143, tTree yyP142));
bool CheckValidDeclType ARGS((tTree yyP145));
bool CheckFuncType ARGS((tTree yyP146));
bool CheckEvalBiOp ARGS((tTree yyP148, tTree yyP147));
static bool CheckEvalBiIntOp ARGS((tTree yyP149));
static bool CheckEvalBiRealOp ARGS((tTree yyP150));
bool CheckEvalUniOp ARGS((tTree yyP153, tTree yyP152, tTree yyP151));
tValue EvalBiExpr ARGS((tPosition yyP158, tTree yyP157, tValue yyP156, tTree yyP155, tValue yyP154));
static tInt EvalBiIntOp ARGS((tPosition yyP163, tTree yyP162, tInt yyP161, tTree yyP160, tInt yyP159));
static int EvalBiBoolOp ARGS((tPosition yyP168, tTree yyP167, tInt yyP166, tTree yyP165, tInt yyP164));
static double EvalBiRealMathsOp ARGS((tPosition yyP173, tTree yyP172, double yyP171, tTree yyP170, double yyP169));
static int EvalBiRealRelOp ARGS((tPosition yyP178, tTree yyP177, double yyP176, tTree yyP175, double yyP174));
tValue EvalUniExpr ARGS((tTree yyP181, tTree yyP180, tTree yyP179));
bool CheckConstConvert ARGS((tTree yyP182));
tValue EvalConstConvert ARGS((tPosition yyP185, tTree yyP184, tTree yyP183));
tValue CheckConst ARGS((tPosition yyP189, tTree yyP188, tInt yyP187, bool yyP186));
bool CheckConstRoundTrunc ARGS((tTree yyP191, tTree yyP190));
tValue EvalConstTrunc ARGS((tPosition yyP195, tTree yyP194, tTree yyP193, tValue yyP192));
tValue EvalConstRound ARGS((tPosition yyP199, tTree yyP198, tTree yyP197, tValue yyP196));
bool CheckConstId ARGS((tTree yyP200));
tValue EvalConstId ARGS((tTree yyP201));
tInt TestIntOVF ARGS((tPosition yyP204, tTree yyP203, tInt yyP202));
tInt SignExtendInt ARGS((tTree yyP206, tInt yyP205));
static int CountTags ARGS((tSymbol yyP207));
static int CountFields ARGS((tSymbol yyP208));
static tInt EvalIntBits ARGS((tTree yyP209));
tInt EvalMostPos ARGS((tTree yyP210));
tInt EvalMostNeg ARGS((tTree yyP211));
static tInt EvalIntMask ARGS((tTree yyP212));
tValue EvalConstSubscript ARGS((tTree yyP215, int yyP214, tConstArray yyP213));
tConstArray ConstArrayFromString ARGS((tTree yyP217, tStringRef yyP216));
tConstArray ConstArrayFromExprList ARGS((tTree yyP219, tTree yyP218));
tConstArray ConstArrayFromDecl ARGS((tTree yyP221, tTree yyP220));
static void FillConstArray ARGS((tTree yyP224, tTree yyP223, tConstArray yyP222));
static void FillConstFields ARGS((tTree yyP228, tTree yyP227, tTree yyP226, tConstArray yyP225));
tConstArray RangeConstArray ARGS((tTree yyP231, tConstArray yyP230, int yyP229));
tConstArray SubscriptConstArray ARGS((tTree yyP235, tConstArray yyP234, tTree yyP233, tTree yyP232));
static tConstArray GetConstArray ARGS((tTree EX));
tValue ReadConstArray ARGS((tTree yyP237, tConstArray yyP236));
void WriteConstArray ARGS((tTree yyP240, tValue yyP239, tConstArray yyP238));
static tConstArray NewConstArray ARGS((int yyP241));
static void RangeCheckSubscript ARGS((tTree yyP243, tTree yyP242));
static void RangeCheckSlice ARGS((tTree yyP246, tTree yyP245, tTree yyP244));
tTree MakeConstInt ARGS((int yyP248, tPosition yyP247));
static tTree MakeAddExpr ARGS((tTree yyP250, tTree yyP249));
static int CountList ARGS((tTree yyP252, tTree yyP251));
int CountExprs ARGS((tTree yyP253));
static int SizeType ARGS((tTree yyP256, tPosition yyP255, bool yyP254, tTree * yyP257));
static int AlignToNext ARGS((int yyP259, int yyP258));
static int CalcRecordSize ARGS((tTree yyP261, int yyP260));
static int CalcPackedRecordSize ARGS((tTree yyP263, int yyP262));
static int CalcRecordOffset ARGS((tTree yyP266, tTree yyP265, int yyP264));
static int CalcPackedRecordOffset ARGS((tTree yyP269, tTree yyP268, int yyP267));
int CalcOffset ARGS((tTree yyP271, tTree yyP270));
int CalcTypeSize ARGS((tTree yyP272));
tTree ReduceElement ARGS((tTree yyP274, tTree yyP273));
tTree ReduceElemental ARGS((tTree yyP275));
static tTree SplatSymbolTableFormals ARGS((tPosition yyP280, tTree yyP279, tSymbol yyP278, int yyP277, tTree yyP276));
static tTree AppendSpecList ARGS((tTree yyP282, tTree yyP281));
static void UpdateFuncSymbol ARGS((tTree yyP283));
static tTree CopyFuncBody ARGS((tTree yyP287, tTree yyP286, int yyP285, tSymbol yyP284));
static bool WithinScope ARGS((tSymbol yyP289, tSymbol yyP288));
tTree CreateFuncCall ARGS((tPosition yyP293, tSymbol yyP292, tTree yyP291, tInt yyP290));
tTree CreateProcCall ARGS((tPosition yyP298, tTree yyP297, tSymbol yyP296, tTree yyP295, tSymbol yyP294));
bool CheckValidUserType ARGS((tTree yyP299));
static bool CheckAllDataFields ARGS((tTree yyP300));
static bool CheckAllChanFields ARGS((tTree yyP301));
tTree GetTagProtocol ARGS((tTree yyP302));
void LookupProtocolTag ARGS((tIdent yyP305, tPosition yyP304, tTree yyP303, tSymbol * yyP306));
tTree LookupField ARGS((tIdent yyP309, tPosition yyP308, tTree yyP307, tSymbol * yyP310));
tTree GetFieldList ARGS((tTree yyP311));
tTree ArrayPrimType ARGS((tTree yyP312));
void MarkNonAtomicIf ARGS((tTree IF));
static void MarkNonAtomicIfList ARGS((tTree IF));

tTree TypeUserDataType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP3, tSymbol yyP2, register tPosition yyP1)
# else
(yyP3, yyP2, yyP1)
 register tTree yyP3;
 tSymbol yyP2;
 register tPosition yyP1;
# endif
{

  switch (yyP3->Kind) {
  case kArray:
  case kUserArray:
/* line 152 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kUserArray)
    yyV1->UserArray.Expr = yyP3->Array.Expr;
    yyV1->UserArray.Type = yyP3->Array.Type;
    yyV1->UserArray.Pos = yyP1;
    yyV1->UserArray.Sym = yyP2;
   return yyV1;
  }
 }

  case kInt:
  case kUserInt:
/* line 153 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kUserInt)
    yyV1->UserInt.Pos = yyP1;
    yyV1->UserInt.Sym = yyP2;
   return yyV1;
  }
 }

  case kInt16:
  case kUserInt16:
/* line 154 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kUserInt16)
    yyV1->UserInt16.Pos = yyP1;
    yyV1->UserInt16.Sym = yyP2;
   return yyV1;
  }
 }

  case kInt32:
  case kUserInt32:
/* line 155 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kUserInt32)
    yyV1->UserInt32.Pos = yyP1;
    yyV1->UserInt32.Sym = yyP2;
   return yyV1;
  }
 }

  case kInt64:
  case kUserInt64:
/* line 156 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kUserInt64)
    yyV1->UserInt64.Pos = yyP1;
    yyV1->UserInt64.Sym = yyP2;
   return yyV1;
  }
 }

  case kReal32:
  case kUserReal32:
/* line 157 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kUserReal32)
    yyV1->UserReal32.Pos = yyP1;
    yyV1->UserReal32.Sym = yyP2;
   return yyV1;
  }
 }

  case kReal64:
  case kUserReal64:
/* line 158 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kUserReal64)
    yyV1->UserReal64.Pos = yyP1;
    yyV1->UserReal64.Sym = yyP2;
   return yyV1;
  }
 }

  case kByte:
  case kUserByte:
/* line 159 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kUserByte)
    yyV1->UserByte.Pos = yyP1;
    yyV1->UserByte.Sym = yyP2;
   return yyV1;
  }
 }

  case kBool:
  case kUserBool:
/* line 160 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kUserBool)
    yyV1->UserBool.Pos = yyP1;
    yyV1->UserBool.Sym = yyP2;
   return yyV1;
  }
 }

  }

/* line 161 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 161 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Not a valid user data type", xxError, yyP1);
  }
   return yyP3;

}

void TypeFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP4)
# else
(yyP4)
 register tTree yyP4;
# endif
{
/* line 166 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 static tTree by=NULL; static tTree type=NULL; 
  if (Tree_IsType (yyP4, kNoFormal)) {
/* line 167 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
  if (yyP4->Kind == kAFormal) {
  if (yyP4->AFormal.By->Kind == kByUndef) {
  if (Tree_IsType (yyP4->AFormal.Type, kUntyped)) {
/* line 168 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 168 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP4->AFormal.By = by;
/* line 168 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP4->AFormal.Type = type;
/* line 168 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolType (yyP4->AFormal.Sym) = type;
/* line 168 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeFormals (yyP4->AFormal.Next);
  }
   return;

  }
  }
/* line 169 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 169 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   by = yyP4->AFormal.By;
/* line 169 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   type = yyP4->AFormal.Type;
/* line 169 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolType (yyP4->AFormal.Sym) = yyP4->AFormal.Type;
/* line 169 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeFormals (yyP4->AFormal.Next);
  }
   return;

  }
;
}

void TypeDecl
# if defined __STDC__ | defined __cplusplus
(register tTree yyP6, register tTree yyP5)
# else
(yyP6, yyP5)
 register tTree yyP6;
 register tTree yyP5;
# endif
{
  if (yyP5->Kind == kNoId) {
/* line 173 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
  if (yyP5->Kind == kAnId) {
/* line 174 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 174 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolType (yyP5->AnId.Sym) = yyP6;
/* line 174 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeDecl (yyP6, yyP5->AnId.Next);
  }
   return;

  }
;
}

tTree TypeAbbrev
# if defined __STDC__ | defined __cplusplus
(register tTree yyP9, register tTree yyP8, register tPosition yyP7)
# else
(yyP9, yyP8, yyP7)
 register tTree yyP9;
 register tTree yyP8;
 register tPosition yyP7;
# endif
{
  if (Tree_IsType (yyP9, kUntyped)) {
/* line 178 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP8;

  }
/* line 179 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 179 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsUserDataType (yyP9)))) goto yyL2;
  {
/* line 179 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsUserDataType (yyP8)))) goto yyL2;
  {
/* line 179 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((WhichUserDataType (yyP9) == WhichUserDataType (yyP8)))) goto yyL2;
  }
  }
  }
   return yyP9;
yyL2:;

/* line 180 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 180 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsUserDataType (yyP8)))) goto yyL3;
  {
/* line 180 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsUserDataType (yyP8)))) goto yyL3;
  {
/* line 180 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("User type mismatch in abbreviation", xxError, yyP7);
  }
  }
  }
   return yyP9;
yyL3:;

  if (Tree_IsType (yyP9, kPrimitive)) {
  if (Tree_IsType (yyP8, kPrimitive)) {
/* line 181 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 181 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((SameType (yyP9, yyP8)))) goto yyL4;
  }
   return yyP9;
yyL4:;

  }
  }
  if (yyP9->Kind == kTimer) {
  if (yyP8->Kind == kTimer) {
/* line 182 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP9;

  }
  }
  if (yyP9->Kind == kChan) {
  if (yyP8->Kind == kChan) {
/* line 183 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 183 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameProtocol (yyP9->Chan.Protocol, yyP8->Chan.Protocol))) goto yyL6;
  }
   return yyP9;
yyL6:;

  }
  }
  if (Tree_IsType (yyP9, kArray)) {
  if (yyP9->Array.Expr->Kind == kUnBound) {
  if (Tree_IsType (yyP8, kArray)) {
  if (yyP8->Array.Expr->Kind == kUnBound) {
/* line 184 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 184 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP9->Array.Type = TypeAbbrev (yyP9->Array.Type, yyP8->Array.Type, yyP7);
  }
   return yyP9;

  }
  }
  }
  if (Tree_IsType (yyP8, kArray)) {
/* line 185 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 185 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (yyP9->Array.Expr, kUnBound)))) goto yyL8;
  {
/* line 185 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP9->Array.Expr = yyP8->Array.Expr;
/* line 185 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP9->Array.Type = TypeAbbrev (yyP9->Array.Type, yyP8->Array.Type, yyP7);
  }
  }
   return yyP9;
yyL8:;

/* line 186 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 186 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP9->Array.Expr)))) goto yyL9;
  {
/* line 186 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP8->Array.Expr)))) goto yyL9;
  {
/* line 186 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP9->Array.Expr) == ValConstInt (yyP8->Array.Expr)))) goto yyL9;
  {
/* line 186 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP9->Array.Type = TypeAbbrev (yyP9->Array.Type, yyP8->Array.Type, yyP7);
  }
  }
  }
  }
   return yyP9;
yyL9:;

/* line 187 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 187 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP9->Array.Expr)))) goto yyL10;
  {
/* line 187 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP8->Array.Expr)))) goto yyL10;
  {
/* line 187 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Array size mismatch in abbreviation", xxError, yyP7);
/* line 187 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP9->Array.Type = TypeAbbrev (yyP9->Array.Type, yyP8->Array.Type, yyP7);
  }
  }
  }
   return yyP9;
yyL10:;

/* line 188 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 188 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP9->Array.Type = TypeAbbrev (yyP9->Array.Type, yyP8->Array.Type, yyP7);
  }
   return yyP9;

  }
  }
/* line 189 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 189 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Type mismatch in abbreviation", xxError, yyP7);
  }
   return yyP9;

}

tTree TypeSubscript
# if defined __STDC__ | defined __cplusplus
(register tTree yyP13, register tTree yyP12, register tTree yyP11, register tPosition yyP10)
# else
(yyP13, yyP12, yyP11, yyP10)
 register tTree yyP13;
 register tTree yyP12;
 register tTree yyP11;
 register tPosition yyP10;
# endif
{
  if (Tree_IsType (yyP12, kArray)) {
  if (yyP11 == NULL) {
/* line 194 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 194 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! Tree_IsType (ExprType (yyP13), kInt)))) goto yyL1;
  {
/* line 195 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Subscript not of type INT", xxError, yyP10);
  }
  }
   return yyP12->Array.Type;
yyL1:;

/* line 197 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 197 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   RangeCheckSubscript (yyP13, yyP12->Array.Expr);
  }
   return yyP12->Array.Type;

  }
  }
  if (Tree_IsType (yyP12, kUserStructTypes)) {
  if (yyP11 == NULL) {
/* line 198 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 198 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Expected field name not an expression", xxError, yyP10);
  }
   return yyP12;

  }
  }
  if (yyP11 == NULL) {
/* line 199 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 199 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Subscripted non-array type", xxError, yyP10);
  }
   return yyP12;

  }
  if (yyP11->Kind == kNoField) {
/* line 200 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 200 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Invalid field name for this user type", xxError, yyP10);
  }
   return yyP12;

  }
  if (yyP11->Kind == kAField) {
/* line 201 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP11->AField.Type;

  }
 yyAbort ("TypeSubscript");
}

tTree TypeRange
# if defined __STDC__ | defined __cplusplus
(register tTree yyP17, register tTree yyP16, register tTree yyP15, register tPosition yyP14)
# else
(yyP17, yyP16, yyP15, yyP14)
 register tTree yyP17;
 register tTree yyP16;
 register tTree yyP15;
 register tPosition yyP14;
# endif
{
  if (Tree_IsType (yyP15, kArray)) {
/* line 205 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
/* line 205 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   RangeCheckSlice (yyP17, yyP16, yyP15->Array.Expr);
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kArray)
    yyV1->Array.Expr = yyP16;
    yyV1->Array.Type = yyP15->Array.Type;
   return yyV1;
  }
 }

  }
/* line 206 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 206 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Took slice of non-array type", xxError, yyP14);
  }
   return yyP15;

}

tTree TypeBinary
# if defined __STDC__ | defined __cplusplus
(register tTree yyP21, register tTree yyP20, register tTree yyP19, register tPosition yyP18)
# else
(yyP21, yyP20, yyP19, yyP18)
 register tTree yyP21;
 register tTree yyP20;
 register tTree yyP19;
 register tPosition yyP18;
# endif
{
  if (Tree_IsType (yyP21, kBool)) {
  if (Tree_IsType (yyP20, kLogOp)) {
  if (Tree_IsType (yyP19, kBool)) {
/* line 210 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 210 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP21, yyP19))) goto yyL1;
  }
   return yyP21;
yyL1:;

  }
  }
  if (Tree_IsType (yyP20, kRelOp)) {
  if (Tree_IsType (yyP19, kBool)) {
/* line 211 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 211 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP21, yyP19))) goto yyL2;
  }
   return yyP21;
yyL2:;

  }
  }
  }
  if (Tree_IsType (yyP21, kByte)) {
  if (Tree_IsType (yyP20, kRelOp)) {
  if (Tree_IsType (yyP19, kByte)) {
/* line 212 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
/* line 212 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP21, yyP19))) goto yyL3;
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }
yyL3:;

  }
  }
  }
  if (Tree_IsType (yyP21, kReal)) {
  if (Tree_IsType (yyP20, kMathsOp)) {
  if (Tree_IsType (yyP19, kReal)) {
/* line 213 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 213 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP21, yyP19))) goto yyL4;
  }
   return yyP21;
yyL4:;

  }
  }
  }
  if (yyP20->Kind == kAfterOp) {
/* line 214 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
/* line 214 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (IsComputableType (yyP21))) goto yyL5;
  {
/* line 214 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP21, yyP19))) goto yyL5;
  }
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }
yyL5:;

  }
  if (Tree_IsType (yyP21, kNumeric)) {
  if (Tree_IsType (yyP20, kRelOp)) {
  if (Tree_IsType (yyP19, kNumeric)) {
/* line 215 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
/* line 215 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP21, yyP19))) goto yyL6;
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }
yyL6:;

  }
  }
  }
  if (Tree_IsType (yyP20, kMathsOp)) {
/* line 216 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 216 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (IsComputableType (yyP21))) goto yyL7;
  {
/* line 216 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP21, yyP19))) goto yyL7;
  }
  }
   return yyP21;
yyL7:;

  }
  if (Tree_IsType (yyP20, kBitOp)) {
/* line 217 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 217 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (IsComputableType (yyP21))) goto yyL8;
  {
/* line 217 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP21, yyP19))) goto yyL8;
  }
  }
   return yyP21;
yyL8:;

  }
  if (Tree_IsType (yyP20, kClockOp)) {
/* line 218 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 218 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (IsComputableType (yyP21))) goto yyL9;
  {
/* line 218 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP21, yyP19))) goto yyL9;
  }
  }
   return yyP21;
yyL9:;

  }
  if (Tree_IsType (yyP20, kShiftOp)) {
  if (Tree_IsType (yyP19, kInt)) {
/* line 219 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 219 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (IsComputableType (yyP21))) goto yyL10;
  }
   return yyP21;
yyL10:;

  }
  }
/* line 221 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 221 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Type mismatch in binary operation", xxError, yyP18);
  }
   return yyP21;

}

tTree TypeUnary
# if defined __STDC__ | defined __cplusplus
(register tTree yyP24, register tTree yyP23, register tPosition yyP22)
# else
(yyP24, yyP23, yyP22)
 register tTree yyP24;
 register tTree yyP23;
 register tPosition yyP22;
# endif
{

  switch (yyP24->Kind) {
  case kSubtract:
  if (Tree_IsType (yyP23, kNumeric)) {
/* line 225 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP23;

  }
  break;
  case kMinus:
/* line 226 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 226 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (IsComputableType (yyP23))) goto yyL2;
  }
   return yyP23;
yyL2:;

  break;
  case kAdd:
  if (Tree_IsType (yyP23, kNumeric)) {
/* line 227 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP23;

  }
  break;
  case kPlus:
/* line 228 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 228 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (IsComputableType (yyP23))) goto yyL4;
  }
   return yyP23;
yyL4:;

  break;
  case kNot:
  if (Tree_IsType (yyP23, kBool)) {
/* line 229 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP23;

  }
  break;
  case kSize:
  if (Tree_IsType (yyP23, kArray)) {
/* line 230 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kInt)
   return yyV1;
  }
 }

  }
  break;
  case kBitNot:
/* line 231 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 231 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (IsComputableType (yyP23))) goto yyL7;
  }
   return yyP23;
yyL7:;

  break;
  }

/* line 233 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 233 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Type mismatch in unary operation", xxError, yyP22);
  }
   return yyP23;

}

static tTree TypeExprSubList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP25)
# else
(yyP25)
 register tTree yyP25;
# endif
{
  if (yyP25->Kind == kNoExpr) {
/* line 237 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kNoType)
   return yyV1;
  }
 }

  }
  if (yyP25->Kind == kAnExpr) {
/* line 238 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAType)
    yyV1->AType.Next = TypeExprSubList (yyP25->AnExpr.Next);
    yyV1->AType.Type = ExprType (yyP25->AnExpr.Expr);
   return yyV1;
  }
 }

  }
 yyAbort ("TypeExprSubList");
}

tTree TypeExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP26)
# else
(yyP26)
 register tTree yyP26;
# endif
{
  if (yyP26->Kind == kNoExpr) {
/* line 242 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kNoType)
   return yyV1;
  }
 }

  }
  if (yyP26->Kind == kAnExpr) {
  if (yyP26->AnExpr.Next->Kind == kNoExpr) {
/* line 243 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return ExprType (yyP26->AnExpr.Expr);

  }
/* line 244 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAType)
    yyV1->AType.Next = TypeExprSubList (yyP26->AnExpr.Next);
    yyV1->AType.Type = ExprType (yyP26->AnExpr.Expr);
   return yyV1;
  }
 }

  }
 yyAbort ("TypeExprList");
}

tTree TypeTable
# if defined __STDC__ | defined __cplusplus
(register tTree yyP29, register tTree yyP28, register tTree yyP27)
# else
(yyP29, yyP28, yyP27)
 register tTree yyP29;
 register tTree yyP28;
 register tTree yyP27;
# endif
{
  if (yyP29->Kind == kAnExpr) {
  if (yyP27 == NULL) {
/* line 248 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kArray)
    yyV1->Array.Expr = MakeConstInt (CountList (yyP29->AnExpr.Next, yyP28), yyP29->AnExpr.Expr->Expr.Pos);
    yyV1->Array.Type = yyP28;
   return yyV1;
  }
 }

  }
  if (yyP27->Kind == kUserArray) {
/* line 250 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 251 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP27->UserArray.Expr)))) goto yyL2;
  {
/* line 252 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP27->UserArray.Expr) == CountList (yyP29->AnExpr.Next, yyP27->UserArray.Type)))) goto yyL2;
  }
  }
   return yyP27;
yyL2:;

  }
/* line 254 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kArray)
    yyV1->Array.Expr = MakeConstInt (CountList (yyP29->AnExpr.Next, yyP28), yyP29->AnExpr.Expr->Expr.Pos);
    yyV1->Array.Type = yyP28;
   return yyV1;
  }
 }

  }
 yyAbort ("TypeTable");
}

tTree TypeTableExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP30)
# else
(yyP30)
 register tTree yyP30;
# endif
{
  if (yyP30->Kind == kElementalExpr) {
  if (yyP30->ElementalExpr.Elemental->Kind == kTableExpr) {
/* line 259 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP30->ElementalExpr.Elemental;

  }
  }
/* line 260 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kTableExpr)
    yyV1->TableExpr.Pos = yyP30->Expr.Pos;
    yyV1->TableExpr.Expr = yyP30;
    yyV1->TableExpr.Sym = AddSymbol (NoIdent);
   return yyV1;
  }
 }

}

tTree TypeString
# if defined __STDC__ | defined __cplusplus
(register int yyP33, register tTree yyP32, register tPosition yyP31)
# else
(yyP33, yyP32, yyP31)
 register int yyP33;
 register tTree yyP32;
 register tPosition yyP31;
# endif
{
  if (yyP32->Kind == kUserArray) {
  if (Tree_IsType (yyP32->UserArray.Type, kByte)) {
/* line 264 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 265 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP32->UserArray.Expr)))) goto yyL1;
  {
/* line 266 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP33 == ValConstInt (yyP32->UserArray.Expr)))) goto yyL1;
  }
  }
   return yyP32;
yyL1:;

  }
  }
/* line 268 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kArray)
    yyV1->Array.Expr = MakeConstInt (yyP33, yyP31);
    yyV1->Array.Type = mByte ();
   return yyV1;
  }
 }

}

tTree StripTypeList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP34)
# else
(yyP34)
 register tTree yyP34;
# endif
{
  if (yyP34->Kind == kAType) {
  if (yyP34->AType.Next->Kind == kNoType) {
/* line 273 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP34->AType.Type;

  }
  }
/* line 274 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP34;

}

tTree SynthDefType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP37, register tTree yyP36, register tTree yyP35)
# else
(yyP37, yyP36, yyP35)
 register tTree yyP37;
 register tTree yyP36;
 register tTree yyP35;
# endif
{
  if (Tree_IsType (yyP35, kShiftOp)) {
/* line 281 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP37;

  }
  if (yyP37 == NULL) {
/* line 282 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP36;

  }
  if (yyP36 == NULL) {
/* line 283 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP37;

  }
  if (Tree_IsType (yyP37, kUntyped)) {
/* line 284 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP36;

  }
  if (Tree_IsType (yyP36, kUntyped)) {
/* line 285 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP37;

  }
/* line 286 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP37;

}

tTree SynthDefTableType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP38)
# else
(yyP38)
 register tTree yyP38;
# endif
{
  if (yyP38 == NULL) {
/* line 290 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP38;

  }
  if (Tree_IsType (yyP38, kUntyped)) {
/* line 291 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP38;

  }
/* line 292 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kArray)
   {register tTree yyW1;
    yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyW1,kUnBound)
    yyV1->Array.Expr = yyW1;
    yyW1->UnBound.Pos = NoPosition;
   }
    yyV1->Array.Type = yyP38;
   return yyV1;
  }
 }

}

tTree SynthDefSubscriptType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP40, register tTree yyP39)
# else
(yyP40, yyP39)
 register tTree yyP40;
 register tTree yyP39;
# endif
{
  if (yyP40 == NULL) {
/* line 296 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP40;

  }
  if (Tree_IsType (yyP40, kUntyped)) {
/* line 297 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP40;

  }
  if (Tree_IsType (yyP40, kArray)) {
/* line 298 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP40->Array.Type;

  }
  if (yyP39 == NULL) {
/* line 299 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP40;

  }
  if (yyP39->Kind == kAField) {
/* line 300 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP39->AField.Type;

  }
/* line 301 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return NULL;

}

tTree DefaultType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP41)
# else
(yyP41)
 register tTree yyP41;
# endif
{
/* line 305 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
/* line 305 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! IS_Mode (xxUserDataTypes)))) goto yyL1;
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kInt)
   return yyV1;
  }
 }
yyL1:;

/* line 306 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
/* line 306 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP41 -> Expr . DefType == NoTree))) goto yyL2;
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kInt)
   return yyV1;
  }
 }
yyL2:;

/* line 307 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
/* line 307 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (yyP41 -> Expr . DefType, kUntyped)))) goto yyL3;
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kInt)
   return yyV1;
  }
 }
yyL3:;

/* line 308 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP41 -> Expr . DefType;

}

tTree InheritLhsType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP43, register tTree yyP42)
# else
(yyP43, yyP42)
 register tTree yyP43;
 register tTree yyP42;
# endif
{
  if (yyP43 == NULL) {
/* line 314 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 314 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xxUserDataTypes)))) goto yyL1;
  }
   return yyP42;
yyL1:;

/* line 316 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kInt)
   return yyV1;
  }
 }

  }
  if (Tree_IsType (yyP43, kUntyped)) {
/* line 315 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 315 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xxUserDataTypes)))) goto yyL2;
  }
   return yyP42;
yyL2:;

  }
  if (yyP43->Kind == kUntypedByte) {
/* line 317 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kByte)
   return yyV1;
  }
 }

  }
  if (Tree_IsType (yyP43, kUntyped)) {
/* line 318 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kInt)
   return yyV1;
  }
 }

  }
/* line 319 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP43;

}

void InheritFromFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP45, register tTree yyP44)
# else
(yyP45, yyP44)
 register tTree yyP45;
 register tTree yyP44;
# endif
{
  if (Tree_IsType (yyP45, kDefAProc)) {
/* line 323 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 323 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromFormals (yyP45->DefAProc.Formals, yyP44);
  }
   return;

  }
  if (Tree_IsType (yyP45, kDefAFunc)) {
/* line 324 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 324 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromFormals (yyP45->DefAFunc.Formals, yyP44);
  }
   return;

  }
  if (Tree_IsType (yyP45, kNoFormal)) {
  if (yyP44->Kind == kNoExpr) {
/* line 325 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
  }
  if (Tree_IsType (yyP45, kFormals)) {
  if (yyP44->Kind == kNoExpr) {
/* line 326 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
  }
  if (yyP45->Kind == kAFormal) {
  if (yyP44->Kind == kAnExpr) {
/* line 327 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 327 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP44->AnExpr.Expr -> Expr . InhType = yyP45->AFormal.Type;
/* line 327 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromFormals (yyP45->AFormal.Next, yyP44->AnExpr.Next);
  }
   return;

  }
  }
  if (Tree_IsType (yyP45, kNoFormal)) {
  if (yyP44->Kind == kAnExpr) {
/* line 328 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 328 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP44->AnExpr.Expr -> Expr . InhType = NoTree;
/* line 328 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromFormals (yyP45, yyP44->AnExpr.Next);
  }
   return;

  }
  }
;
}

static void InheritFromSimpleProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP47, register tTree yyP46)
# else
(yyP47, yyP46)
 register tTree yyP47;
 register tTree yyP46;
# endif
{
  if (yyP47->Kind == kSimple) {
/* line 332 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 332 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP46 -> Expr . InhType = yyP47->Simple.Type;
  }
   return;

  }
  if (yyP47->Kind == kCounted) {
  if (yyP46->Kind == kCountArray) {
/* line 333 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 334 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP46 -> CountArray . InhType = yyP47->Counted.Type;
/* line 335 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP46 -> CountArray . Length -> Expr . InhType = yyP47->Counted.Length;
  }
   return;

  }
/* line 337 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 338 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP46 -> Expr . InhType = yyP47->Counted.Type;
  }
   return;

  }
;
}

void InheritFromProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP49, register tTree yyP48)
# else
(yyP49, yyP48)
 register tTree yyP49;
 register tTree yyP48;
# endif
{
  if (yyP48->Kind == kNoExpr) {
/* line 343 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
  if (yyP49->Kind == kChan) {
/* line 344 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 344 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromProtocol (yyP49->Chan.Protocol, yyP48);
  }
   return;

  }
  if (yyP49->Kind == kNamed) {
/* line 345 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 345 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP49->Named.Sym), kDefSeqPro)))) goto yyL3;
  {
/* line 346 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromProtocol (SymbolKind (yyP49->Named.Sym) -> DefSeqPro . SeqProList, yyP48);
  }
  }
   return;
yyL3:;

/* line 348 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 348 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP49->Named.Sym), kDefTagPro)))) goto yyL4;
  {
/* line 349 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromProtocol (SymbolKind (yyP49->Named.Sym) -> DefTagPro . TagProList, yyP48);
  }
  }
   return;
yyL4:;

  }
  if (yyP49->Kind == kATagPro) {
  if (yyP48->Kind == kAnExpr) {
  if (yyP48->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP48->AnExpr.Expr->ElementalExpr.Elemental, kIdentifier)) {
/* line 351 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 351 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((CheckValidTag (yyP49, yyP48->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym)))) goto yyL5;
  {
/* line 352 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP48->AnExpr.Expr -> Expr . InhType = mInt ();
/* line 353 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromProtocol (SymbolKind (yyP48->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym) -> ATagPro . SeqProList, yyP48->AnExpr.Next);
  }
  }
   return;
yyL5:;

  }
  }
  }
  }
  if (yyP49->Kind == kASeqPro) {
  if (yyP48->Kind == kAnExpr) {
/* line 355 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 356 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromSimpleProtocol (yyP49->ASeqPro.Protocol, yyP48->AnExpr.Expr);
/* line 357 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromProtocol (yyP49->ASeqPro.Next, yyP48->AnExpr.Next);
  }
   return;

  }
  }
  if (yyP49->Kind == kSimple) {
  if (yyP48->Kind == kAnExpr) {
/* line 359 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 360 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromSimpleProtocol (yyP49, yyP48->AnExpr.Expr);
/* line 361 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromProtocol (yyP49, yyP48->AnExpr.Next);
  }
   return;

  }
  }
  if (yyP49->Kind == kCounted) {
  if (yyP48->Kind == kAnExpr) {
/* line 363 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 364 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromSimpleProtocol (yyP49, yyP48->AnExpr.Expr);
/* line 365 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromProtocol (yyP49, yyP48->AnExpr.Next);
  }
   return;

  }
  }
  if (yyP48->Kind == kAnExpr) {
/* line 367 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 368 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP48->AnExpr.Expr -> Expr . InhType = mInt ();
/* line 369 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromProtocol (yyP49, yyP48->AnExpr.Next);
  }
   return;

  }
;
}

static void InheritFromFieldList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP51, register tTree yyP50)
# else
(yyP51, yyP50)
 register tTree yyP51;
 register tTree yyP50;
# endif
{
  if (yyP51->Kind == kAField) {
  if (yyP50->Kind == kAnExpr) {
/* line 374 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 374 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP50->AnExpr.Expr -> Expr . InhType = yyP51->AField.Type;
/* line 374 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromFieldList (yyP51->AField.Next, yyP50->AnExpr.Next);
  }
   return;

  }
  }
  if (yyP51->Kind == kNoField) {
  if (yyP50->Kind == kAnExpr) {
/* line 375 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 375 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP50->AnExpr.Expr -> Expr . InhType = NoTree;
/* line 375 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromFieldList (yyP51, yyP50->AnExpr.Next);
  }
   return;

  }
  }
/* line 376 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

;
}

void InheritFromTable
# if defined __STDC__ | defined __cplusplus
(register tTree yyP53, register tTree yyP52)
# else
(yyP53, yyP52)
 register tTree yyP53;
 register tTree yyP52;
# endif
{
  if (Tree_IsType (yyP53, kArray)) {
/* line 380 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 380 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromType (yyP53->Array.Type, yyP52);
  }
   return;

  }
  if (Tree_IsType (yyP53, kUserDataTypes)) {
/* line 381 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 381 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromFieldList (yyP53->UserDataTypes.FieldList, yyP52);
  }
   return;

  }
/* line 382 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 382 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromType (yyP53, yyP52);
  }
   return;

;
}

void InheritFromType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP55, register tTree yyP54)
# else
(yyP55, yyP54)
 register tTree yyP55;
 register tTree yyP54;
# endif
{
  if (yyP54->Kind == kNoExpr) {
/* line 386 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
  if (yyP55 == NULL) {
  if (yyP54->Kind == kAnExpr) {
/* line 387 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 387 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP54->AnExpr.Expr -> Expr . InhType = NULL;
/* line 387 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromType (NULL, yyP54->AnExpr.Next);
  }
   return;

  }
  }
  if (yyP55->Kind == kAType) {
  if (yyP54->Kind == kAnExpr) {
  if (yyP54->AnExpr.Expr->Kind == kValof) {
/* line 388 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 388 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP54->AnExpr.Expr -> Expr . InhType = yyP55;
  }
   return;

  }
/* line 389 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 389 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP54->AnExpr.Expr -> Expr . InhType = yyP55->AType.Type;
/* line 389 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromType (yyP55->AType.Next, yyP54->AnExpr.Next);
  }
   return;

  }
  }
  if (yyP55->Kind == kNoType) {
  if (yyP54->Kind == kAnExpr) {
/* line 390 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 390 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP54->AnExpr.Expr -> Expr . InhType = NoTree;
/* line 390 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromType (yyP55, yyP54->AnExpr.Next);
  }
   return;

  }
  }
  if (yyP54->Kind == kAnExpr) {
/* line 391 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 391 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP54->AnExpr.Expr -> Expr . InhType = yyP55;
/* line 391 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritFromType (yyP55, yyP54->AnExpr.Next);
  }
   return;

  }
;
}

static void InheritAttributes
# if defined __STDC__ | defined __cplusplus
(register tTree yyP57, register tTree yyP56)
# else
(yyP57, yyP56)
 register tTree yyP57;
 register tTree yyP56;
# endif
{
/* line 395 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Tree_tKind K; 
/* line 396 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 396 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (yyP56, yyP57 -> Kind)))) goto yyL1;
  {
/* line 397 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   K = yyP56 -> Kind;
/* line 398 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   memcpy (yyP56, yyP57, Tree_NodeSize [yyP57 -> Kind]);
/* line 399 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP56 -> Kind = K;
  }
  }
   return;
yyL1:;

/* line 401 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 401 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Attempt to inherit attributes from non-parental node", xxError, NoPosition);
  }
   return;

;
}

tTree TransformUserLiterals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP59, register tTree yyP58)
# else
(yyP59, yyP58)
 register tTree yyP59;
 register tTree yyP58;
# endif
{
/* line 405 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tTree NEW; 
  if (Tree_IsType (yyP59, kUserDataTypes)) {
  if (Tree_IsType (yyP58, kTable)) {
/* line 406 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 406 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   InheritAttributes (yyP58, NEW = MakeTree (kUserLiteral));
/* line 406 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   NEW -> UserLiteral . Type = CopyTree (yyP59);
  }
   return NEW;

  }
  }
/* line 407 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP58;

}

void TypeCheckAssign
# if defined __STDC__ | defined __cplusplus
(register tTree yyP62, register tTree yyP61, register tPosition yyP60)
# else
(yyP62, yyP61, yyP60)
 register tTree yyP62;
 register tTree yyP61;
 register tPosition yyP60;
# endif
{
  if (yyP62->Kind == kAnExpr) {
  if (yyP62->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP61->Kind == kAnExpr) {
/* line 415 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 415 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (ExprType (yyP61->AnExpr.Expr), kAType)))) goto yyL1;
  {
/* line 416 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckAssignFn (yyP62, ExprType (yyP61->AnExpr.Expr), yyP62->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL1:;

  }
  }
  }
/* line 417 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 417 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP62, yyP61, yyP60);
  }
   return;

;
}

static void TypeCheckAssignList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP65, register tTree yyP64, register tPosition yyP63)
# else
(yyP65, yyP64, yyP63)
 register tTree yyP65;
 register tTree yyP64;
 register tPosition yyP63;
# endif
{
  if (yyP65->Kind == kNoExpr) {
  if (yyP64->Kind == kNoExpr) {
/* line 421 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
/* line 422 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 422 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too many expressions on assignment RHS", xxError, yyP63);
  }
   return;

  }
  if (yyP64->Kind == kNoExpr) {
/* line 423 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 423 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too few expressions on assignment RHS", xxError, yyP63);
  }
   return;

  }
  if (yyP65->Kind == kAnExpr) {
  if (yyP65->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP64->Kind == kAnExpr) {
/* line 424 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 424 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsChanOrTimerType (ElementType (yyP65->AnExpr.Expr))))) goto yyL4;
  {
/* line 425 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Cannot assign to channel or timer", xxError, yyP65->AnExpr.Expr->ElementalExpr.Pos);
/* line 426 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP65->AnExpr.Next, yyP64->AnExpr.Next, yyP65->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL4:;

/* line 427 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 427 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP65->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL5;
  {
/* line 427 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((SameType (ExprType (yyP65->AnExpr.Expr), ExprType (yyP64->AnExpr.Expr))))) goto yyL5;
  {
/* line 428 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP65->AnExpr.Next, yyP64->AnExpr.Next, yyP65->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
  }
   return;
yyL5:;

/* line 429 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 429 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP65->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL6;
  {
/* line 430 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Type mismatch during assignment", xxError, yyP65->AnExpr.Expr->ElementalExpr.Pos);
/* line 431 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP65->AnExpr.Next, yyP64->AnExpr.Next, yyP65->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL6:;

/* line 432 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 433 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Cannot make assignment to variable", xxError, yyP65->AnExpr.Expr->ElementalExpr.Pos);
/* line 434 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP65->AnExpr.Next, yyP64->AnExpr.Next, yyP65->AnExpr.Expr->ElementalExpr.Pos);
  }
   return;

  }
  }
  if (yyP64->Kind == kAnExpr) {
/* line 435 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 436 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("LHS must be an assignable variable", xxError, yyP63);
/* line 437 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP65->AnExpr.Next, yyP64->AnExpr.Next, yyP63);
  }
   return;

  }
  }
;
}

static void TypeCheckAssignFn
# if defined __STDC__ | defined __cplusplus
(register tTree yyP68, register tTree yyP67, register tPosition yyP66)
# else
(yyP68, yyP67, yyP66)
 register tTree yyP68;
 register tTree yyP67;
 register tPosition yyP66;
# endif
{
  if (yyP68->Kind == kNoExpr) {
  if (yyP67->Kind == kNoType) {
/* line 441 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
/* line 442 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 442 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too few variables to assign to from function", xxError, yyP66);
  }
   return;

  }
  if (yyP67->Kind == kNoType) {
/* line 443 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 443 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too many variables to assign to from function", xxError, yyP66);
  }
   return;

  }
  if (yyP68->Kind == kAnExpr) {
  if (yyP68->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP67->Kind == kAType) {
/* line 444 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 444 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP68->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 444 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (ExprType (yyP68->AnExpr.Expr), yyP67->AType.Type))) goto yyL4;
  {
/* line 445 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckAssignFn (yyP68->AnExpr.Next, yyP67->AType.Next, yyP68->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
  }
   return;
yyL4:;

/* line 446 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 446 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP68->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL5;
  {
/* line 447 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Type mismatch during function assignment", xxError, yyP68->AnExpr.Expr->ElementalExpr.Pos);
/* line 448 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckAssignFn (yyP68->AnExpr.Next, yyP67->AType.Next, yyP68->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL5:;

/* line 449 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 450 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Cannot make assignment to variable", xxError, yyP68->AnExpr.Expr->ElementalExpr.Pos);
/* line 451 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckAssignFn (yyP68->AnExpr.Next, yyP67->AType.Next, yyP68->AnExpr.Expr->ElementalExpr.Pos);
  }
   return;

  }
  }
  }
;
}

void TypeCheckResults
# if defined __STDC__ | defined __cplusplus
(register tTree yyP71, register tTree yyP70, register tPosition yyP69)
# else
(yyP71, yyP70, yyP69)
 register tTree yyP71;
 register tTree yyP70;
 register tPosition yyP69;
# endif
{
  if (yyP71->Kind == kNoType) {
  if (yyP70->Kind == kNoExpr) {
/* line 455 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
/* line 456 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 456 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too many expressions in result list", xxError, yyP69);
  }
   return;

  }
  if (yyP70->Kind == kNoExpr) {
/* line 457 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 457 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too few expressions in result list", xxError, yyP69);
  }
   return;

  }
  if (yyP71->Kind == kAType) {
  if (yyP70->Kind == kAnExpr) {
/* line 458 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 458 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((SameType (yyP71->AType.Type, ExprType (yyP70->AnExpr.Expr))))) goto yyL4;
  {
/* line 458 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckResults (yyP71->AType.Next, yyP70->AnExpr.Next, yyP70->AnExpr.Expr->Expr.Pos);
  }
  }
   return;
yyL4:;

/* line 459 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 459 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Type mismatch in result list", xxError, yyP70->AnExpr.Expr->Expr.Pos);
/* line 459 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckResults (yyP71->AType.Next, yyP70->AnExpr.Next, yyP70->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
;
}

void TypeCheckParameters
# if defined __STDC__ | defined __cplusplus
(register tTree yyP75, register tTree yyP74, register tPosition yyP73, register int yyP72)
# else
(yyP75, yyP74, yyP73, yyP72)
 register tTree yyP75;
 register tTree yyP74;
 register tPosition yyP73;
 register int yyP72;
# endif
{
  if (Tree_IsType (yyP75, kNoFormal)) {
  if (yyP74->Kind == kNoExpr) {
/* line 463 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
/* line 464 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 464 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too many parameters", xxError, yyP73);
  }
   return;

  }
  if (yyP74->Kind == kNoExpr) {
/* line 465 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 465 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too few parameters", xxError, yyP73);
  }
   return;

  }
  if (yyP75->Kind == kAFormal) {
  if (yyP75->AFormal.By->Kind == kByRef) {
  if (yyP74->Kind == kAnExpr) {
  if (yyP74->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP74->AnExpr.Expr->ElementalExpr.Elemental, kTable)) {
/* line 466 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 466 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP74->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 466 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP75->AFormal.Type, ExprType (yyP74->AnExpr.Expr)))) goto yyL4;
  {
/* line 467 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP74->AnExpr.Expr->ElementalExpr.Elemental, yyP75 -> AFormal . U);
/* line 468 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP75->AFormal.Next, yyP74->AnExpr.Next, yyP73, yyP72);
  }
  }
  }
   return;
yyL4:;

  }
  if (Tree_IsType (yyP74->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 470 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 470 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP74->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL5;
  {
/* line 470 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP75->AFormal.Type, ExprType (yyP74->AnExpr.Expr)))) goto yyL5;
  {
/* line 471 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 if (!CheckValofScope(yyP74->AnExpr.Expr->ElementalExpr.Elemental,yyP72)) Message("Attempted to pass free variable by reference within VALOF",xxError,yyP73); 
/* line 472 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP74->AnExpr.Expr->ElementalExpr.Elemental, yyP75 -> AFormal . U);
/* line 473 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP75->AFormal.Next, yyP74->AnExpr.Next, yyP73, yyP72);
  }
  }
  }
   return;
yyL5:;

  }
  }
/* line 478 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 478 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP75->AFormal.Type, ExprType (yyP74->AnExpr.Expr)))) goto yyL7;
  {
/* line 479 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Actual parameter cannot be passed by reference", xxError, yyP73);
/* line 480 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP75->AFormal.Next, yyP74->AnExpr.Next, yyP73, yyP72);
  }
  }
   return;
yyL7:;

  }
  }
  if (yyP75->AFormal.By->Kind == kByVal) {
  if (yyP74->Kind == kAnExpr) {
/* line 475 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 475 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP75->AFormal.Type, ExprType (yyP74->AnExpr.Expr)))) goto yyL6;
  {
/* line 476 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP75->AFormal.Next, yyP74->AnExpr.Next, yyP73, yyP72);
  }
  }
   return;
yyL6:;

  }
  }
  if (yyP74->Kind == kAnExpr) {
/* line 482 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 483 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Actual parameter does not match formal description", xxError, yyP74->AnExpr.Expr->Expr.Pos);
/* line 484 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP75->AFormal.Next, yyP74->AnExpr.Next, yyP73, yyP72);
  }
   return;

  }
  }
;
}

void UpdateElementalUsage
# if defined __STDC__ | defined __cplusplus
(register tTree yyP77, tUsage yyP76)
# else
(yyP77, yyP76)
 register tTree yyP77;
 tUsage yyP76;
# endif
{
/* line 489 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tUsage tmp; 

  switch (yyP77->Kind) {
  case kIdentifier:
  case kUnmappedIdentifier:
/* line 490 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 490 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP77->Identifier.Sym), kAFormal)))) goto yyL1;
  {
/* line 491 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP77 -> Identifier . U = yyP76;
/* line 492 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP77->Identifier.Sym) -> AFormal . U = UpdateUsage (SymbolKind (yyP77->Identifier.Sym) -> AFormal . U, yyP76);
/* line 493 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 if (SymbolKind(yyP77->Identifier.Sym)->AFormal.U==xxInOut) Message("Passed channel used for both input and output",xxError,yyP77->Identifier.Pos); 
  }
  }
   return;
yyL1:;

/* line 495 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 495 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP77->Identifier.Sym), kIs)))) goto yyL2;
  {
/* line 496 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP77 -> Identifier . U = yyP76;
/* line 497 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP77->Identifier.Sym) -> Is . U = UpdateUsage (SymbolKind (yyP77->Identifier.Sym) -> Is . U, yyP76);
/* line 498 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   tmp = SymbolKind (yyP77->Identifier.Sym) -> Is . U;
/* line 499 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 if (tmp==xxInput||tmp==xxOutput||tmp==xxInOut) UpdateElementalUsage(SymbolKind(yyP77->Identifier.Sym)->Is.Elemental,yyP76);
/* line 500 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 if (SymbolKind(yyP77->Identifier.Sym)->Is.U==xxInOut) Message("Abbreviated channel used for both input and output",(IS_Mode(xxUsageWarnings))?xxWarning:xxError,yyP77->Identifier.Pos); 
  }
  }
   return;
yyL2:;

/* line 502 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 502 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP77->Identifier.Sym), kAnId)))) goto yyL3;
  {
/* line 503 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP77 -> Identifier . U = yyP76;
/* line 504 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP77->Identifier.Sym) -> AnId . U = UpdateUsage (SymbolKind (yyP77->Identifier.Sym) -> AnId . U, yyP76);
  }
  }
   return;
yyL3:;

  break;
  case kRange:
/* line 506 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 506 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP77 -> Range . U = yyP76;
/* line 506 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP77->Range.Next, yyP76);
  }
   return;

  case kSubscript:
/* line 507 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 507 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP77 -> Subscript . U = yyP76;
/* line 507 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP77->Subscript.Next, yyP76);
  }
   return;

  case kTableRange:
/* line 508 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 508 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP77 -> TableRange . U = yyP76;
/* line 508 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP77->TableRange.Next, yyP76);
  }
   return;

  case kTableSubscript:
/* line 509 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 509 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP77 -> TableSubscript . U = yyP76;
/* line 509 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP77->TableSubscript.Next, yyP76);
  }
   return;

  case kTable:
  case kUserLiteral:
/* line 510 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 510 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP77 -> Table . U = yyP76;
/* line 510 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP77->Table.ExprList, yyP76);
  }
   return;

  case kAnExpr:
  if (yyP77->AnExpr.Expr->Kind == kElementalExpr) {
/* line 511 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 511 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP77->AnExpr.Expr->ElementalExpr.Elemental, yyP76);
/* line 511 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP77->AnExpr.Next, yyP76);
  }
   return;

  }
/* line 512 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 512 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP77->AnExpr.Next, yyP76);
  }
   return;

  }

;
}

void TypeCheckIfList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP78)
# else
(yyP78)
 register tTree yyP78;
# endif
{
  if (yyP78->Kind == kNoChoice) {
/* line 516 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
  if (yyP78->Kind == kAChoice) {
  if (yyP78->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP78->AChoice.ExprList->AnExpr.Next->Kind == kNoExpr) {
/* line 517 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 517 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (ExprType (yyP78->AChoice.ExprList->AnExpr.Expr), kBool)))) goto yyL2;
  {
/* line 517 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP78->AChoice.Next);
  }
  }
   return;
yyL2:;

/* line 518 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 518 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Conditional not of type BOOL", xxError, yyP78->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
/* line 518 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP78->AChoice.Next);
  }
   return;

  }
  }
  }
  if (yyP78->Kind == kANewIf) {
  if (yyP78->ANewIf.IfType->Kind == kIf) {
/* line 519 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 519 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP78->ANewIf.IfType->If.ChoiceList);
/* line 519 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP78->ANewIf.Next);
  }
   return;

  }
  if (yyP78->ANewIf.IfType->Kind == kIfRep) {
/* line 520 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 520 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP78->ANewIf.IfType->IfRep.ChoiceList);
/* line 520 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP78->ANewIf.Next);
  }
   return;

  }
  }
;
}

void TypeCheckTimerInput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP80, register tPosition yyP79)
# else
(yyP80, yyP79)
 register tTree yyP80;
 register tPosition yyP79;
# endif
{
  if (yyP80->Kind == kAnExpr) {
  if (yyP80->AnExpr.Next->Kind == kNoExpr) {
  if (yyP80->AnExpr.Expr->Kind == kElementalExpr) {
/* line 524 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 524 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP80->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL1;
  {
/* line 524 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (ExprType (yyP80->AnExpr.Expr), kInt)))) goto yyL1;
  }
  }
   return;
yyL1:;

  }
/* line 525 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 525 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Timer input not to writable INT variable", xxError, yyP80->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
/* line 526 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 526 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Only single input allowed from TIMER", xxError, yyP79);
  }
   return;

  }
  if (yyP80->Kind == kNoExpr) {
/* line 527 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 527 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Missing variable for timer input", xxError, yyP79);
  }
   return;

  }
;
}

void TypeCheckInputProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP83, register tTree yyP82, register tPosition yyP81)
# else
(yyP83, yyP82, yyP81)
 register tTree yyP83;
 register tTree yyP82;
 register tPosition yyP81;
# endif
{
  if (yyP83->Kind == kAny) {
  if (yyP82->Kind == kAnExpr) {
  if (yyP82->AnExpr.Next->Kind == kNoExpr) {
  if (yyP82->AnExpr.Expr->Kind == kElementalExpr) {
/* line 531 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 531 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP82->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL1;
  }
   return;
yyL1:;

  }
  if (yyP82->AnExpr.Expr->Kind == kCountArray) {
  if (yyP82->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP82->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
/* line 533 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 534 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP82->AnExpr.Expr->CountArray.Length->ElementalExpr.Elemental)))) goto yyL3;
  {
/* line 534 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP82->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental)))) goto yyL3;
  {
/* line 534 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (yyP82->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental -> Element . SynType, kArray)))) goto yyL3;
  }
  }
  }
   return;
yyL3:;

  }
  }
  }
/* line 537 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 537 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Input variable not writable", xxError, yyP82->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  if (yyP82->AnExpr.Expr->Kind == kElementalExpr) {
/* line 532 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 532 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP82->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL2;
  {
/* line 532 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckInputProtocol (yyP83, yyP82->AnExpr.Next, yyP82->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL2:;

  }
  if (yyP82->AnExpr.Expr->Kind == kCountArray) {
  if (yyP82->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP82->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
/* line 535 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 536 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP82->AnExpr.Expr->CountArray.Length->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 536 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP82->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 536 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (yyP82->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental -> Element . SynType, kArray)))) goto yyL4;
  {
/* line 536 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckInputProtocol (yyP83, yyP82->AnExpr.Next, yyP82->AnExpr.Expr->CountArray.Pos);
  }
  }
  }
  }
   return;
yyL4:;

  }
  }
  }
/* line 538 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 538 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Input variable not writable", xxError, yyP82->AnExpr.Expr->Expr.Pos);
/* line 538 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckInputProtocol (yyP83, yyP82->AnExpr.Next, yyP82->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
  if (yyP82->Kind == kNoExpr) {
/* line 540 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 540 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("No expression list present for channel input", xxError, yyP81);
  }
   return;

  }
  if (yyP83->Kind == kNamed) {
/* line 542 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 542 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP83->Named.Sym), kDefSeqPro)))) goto yyL8;
  {
/* line 542 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (SymbolKind (yyP83->Named.Sym) -> DefSeqPro . SeqProList, yyP82, yyP81);
  }
  }
   return;
yyL8:;

/* line 543 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 543 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Invalid form of variant protocol input", xxError, yyP81);
  }
   return;

  }
  if (yyP82->Kind == kAnExpr) {
  if (yyP82->AnExpr.Next->Kind == kNoExpr) {
  if (yyP82->AnExpr.Expr->Kind == kElementalExpr) {
/* line 544 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 544 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP82->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL10;
  {
/* line 544 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP83, yyP82->AnExpr.Expr);
  }
  }
   return;
yyL10:;

  }
  if (yyP82->AnExpr.Expr->Kind == kCountArray) {
  if (yyP82->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP82->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
/* line 545 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 545 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP82->AnExpr.Expr->CountArray.Length->ElementalExpr.Elemental)))) goto yyL11;
  {
/* line 545 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP82->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental)))) goto yyL11;
  {
/* line 545 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP83, yyP82->AnExpr.Expr);
  }
  }
  }
   return;
yyL11:;

  }
  }
  }
/* line 546 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 546 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Input item not assignable", xxError, yyP82->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
/* line 547 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 547 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too many inputs for a channel with a simple protocol", xxError, yyP82->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
;
}

static void TypeCheckSimpleProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP85, register tTree yyP84)
# else
(yyP85, yyP84)
 register tTree yyP85;
 register tTree yyP84;
# endif
{
  if (yyP85->Kind == kSimple) {
  if (yyP84->Kind == kCountArray) {
/* line 552 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 552 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Protocol does not expect a counted array", xxError, yyP84->CountArray.Pos);
  }
   return;

  }
/* line 553 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 553 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP85->Simple.Type, ExprType (yyP84)))) goto yyL2;
  }
   return;
yyL2:;

/* line 554 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 554 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Variable is not of correct type for protocol", xxError, yyP84->Expr.Pos);
  }
   return;

  }
  if (yyP85->Kind == kCounted) {
  if (yyP84->Kind == kCountArray) {
/* line 555 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 555 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((SameType (yyP85->Counted.Length, ExprType (yyP84->CountArray.Length))))) goto yyL4;
  {
/* line 555 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((SameType (yyP85->Counted.Type, ExprType (yyP84->CountArray.Expr))))) goto yyL4;
  }
  }
   return;
yyL4:;

/* line 556 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 556 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Counted array expression types do not match protocol", xxError, yyP84->CountArray.Pos);
  }
   return;

  }
/* line 557 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 557 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((SameType (yyP85->Counted.Type, ExprType (yyP84))))) goto yyL6;
  }
   return;
yyL6:;

/* line 558 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 558 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Output expression does not match protocol", xxError, yyP84->Expr.Pos);
  }
   return;

  }
;
}

void TypeCheckOutputProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP88, register tTree yyP87, register tPosition yyP86)
# else
(yyP88, yyP87, yyP86)
 register tTree yyP88;
 register tTree yyP87;
 register tPosition yyP86;
# endif
{
  if (yyP88->Kind == kAny) {
  if (yyP87->Kind == kAnExpr) {
  if (yyP87->AnExpr.Next->Kind == kNoExpr) {
/* line 565 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
/* line 566 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 567 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckOutputProtocol (yyP88, yyP87->AnExpr.Next, yyP87->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
  if (yyP87->Kind == kNoExpr) {
/* line 569 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 570 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("No expression list present for channel output", xxError, yyP86);
  }
   return;

  }
  if (yyP88->Kind == kNamed) {
/* line 572 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 572 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP88->Named.Sym), kDefSeqPro)))) goto yyL4;
  {
/* line 573 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckOutputSeqProtocol (SymbolKind (yyP88->Named.Sym) -> DefSeqPro . SeqProList, yyP87, yyP86);
  }
  }
   return;
yyL4:;

/* line 575 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 575 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP88->Named.Sym), kDefTagPro)))) goto yyL5;
  {
/* line 576 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckCaseOutput (SymbolKind (yyP88->Named.Sym) -> DefTagPro . TagProList, yyP87, yyP86);
  }
  }
   return;
yyL5:;

/* line 578 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 579 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Not a valid named", xxError, yyP86);
  }
   return;

  }
  if (yyP87->Kind == kAnExpr) {
  if (yyP87->AnExpr.Next->Kind == kNoExpr) {
/* line 581 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 582 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP88, yyP87->AnExpr.Expr);
  }
   return;

  }
/* line 584 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 585 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too many outputs for a channel with a simple protocol", xxError, yyP87->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
;
}

void TypeCheckCaseInputs
# if defined __STDC__ | defined __cplusplus
(register tTree yyP91, register tTree yyP90, register tPosition yyP89)
# else
(yyP91, yyP90, yyP89)
 register tTree yyP91;
 register tTree yyP90;
 register tPosition yyP89;
# endif
{
  if (yyP90->Kind == kNoCase) {
/* line 590 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
  if (yyP90->Kind == kACase) {
  if (yyP90->ACase.ExprList->Kind == kAnExpr) {
  if (yyP90->ACase.ExprList->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP90->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental, kIdentifier)) {
/* line 591 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 591 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((CheckValidTag (yyP91, yyP90->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym)))) goto yyL2;
  {
/* line 591 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (SymbolKind (yyP90->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym) -> ATagPro . SeqProList, yyP90->ACase.ExprList->AnExpr.Next, yyP89);
/* line 591 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckCaseInputs (yyP91, yyP90->ACase.Next, yyP89);
  }
  }
   return;
yyL2:;

  }
  }
/* line 592 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 592 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Variant tag is not valid for this protocol", xxError, yyP90->ACase.ExprList->AnExpr.Expr->Expr.Pos);
/* line 592 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckCaseInputs (yyP91, yyP90->ACase.Next, yyP89);
  }
   return;

  }
  if (yyP90->ACase.ExprList->Kind == kNoExpr) {
/* line 593 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 593 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Cased input missing variant protocol", xxError, yyP89);
/* line 593 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckCaseInputs (yyP91, yyP90->ACase.Next, yyP89);
  }
   return;

  }
  }
;
}

static void TypeCheckCaseOutput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP94, register tTree yyP93, register tPosition yyP92)
# else
(yyP94, yyP93, yyP92)
 register tTree yyP94;
 register tTree yyP93;
 register tPosition yyP92;
# endif
{
  if (yyP93->Kind == kAnExpr) {
  if (yyP93->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP93->AnExpr.Expr->ElementalExpr.Elemental, kIdentifier)) {
/* line 597 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 597 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((CheckValidTag (yyP94, yyP93->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym)))) goto yyL1;
  {
/* line 598 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckOutputSeqProtocol (SymbolKind (yyP93->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym) -> ATagPro . SeqProList, yyP93->AnExpr.Next, yyP92);
  }
  }
   return;
yyL1:;

  }
  }
/* line 600 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 601 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Variant tag is not valid for this protocol", xxError, yyP93->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  if (yyP93->Kind == kNoExpr) {
/* line 603 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 604 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Cased output missing variant protocol", xxError, yyP92);
  }
   return;

  }
;
}

static void TypeCheckInputSeqProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP97, register tTree yyP96, register tPosition yyP95)
# else
(yyP97, yyP96, yyP95)
 register tTree yyP97;
 register tTree yyP96;
 register tPosition yyP95;
# endif
{
  if (yyP97->Kind == kNoSeqPro) {
  if (yyP96->Kind == kNoExpr) {
/* line 609 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
  if (yyP96->Kind == kAnExpr) {
/* line 610 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 610 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too many input expressions for channel protocol", xxError, yyP96->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
  if (yyP96->Kind == kNoExpr) {
/* line 611 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 611 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too few input expressions for channel protocol", xxError, yyP95);
  }
   return;

  }
  if (yyP97->Kind == kASeqPro) {
  if (yyP96->Kind == kAnExpr) {
  if (yyP96->AnExpr.Expr->Kind == kElementalExpr) {
/* line 612 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 612 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Writable (yyP96->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 612 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP97->ASeqPro.Protocol, yyP96->AnExpr.Expr);
/* line 612 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (yyP97->ASeqPro.Next, yyP96->AnExpr.Next, yyP96->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL4:;

  }
  if (yyP96->AnExpr.Expr->Kind == kCountArray) {
/* line 613 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 613 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP97->ASeqPro.Protocol, yyP96->AnExpr.Expr);
/* line 613 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (yyP97->ASeqPro.Next, yyP96->AnExpr.Next, yyP96->AnExpr.Expr->CountArray.Pos);
  }
   return;

  }
/* line 614 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 614 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Not an assignable expression", xxError, yyP96->AnExpr.Expr->Expr.Pos);
/* line 614 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (yyP97->ASeqPro.Next, yyP96->AnExpr.Next, yyP96->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
;
}

static void TypeCheckOutputSeqProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP100, register tTree yyP99, register tPosition yyP98)
# else
(yyP100, yyP99, yyP98)
 register tTree yyP100;
 register tTree yyP99;
 register tPosition yyP98;
# endif
{
  if (yyP100->Kind == kNoSeqPro) {
  if (yyP99->Kind == kNoExpr) {
/* line 618 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
  if (yyP99->Kind == kAnExpr) {
/* line 619 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 619 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too many output expressions for channel protocol", xxError, yyP99->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
  if (yyP99->Kind == kNoExpr) {
/* line 620 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 620 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too few output expressions for channel protocol", xxError, yyP98);
  }
   return;

  }
  if (yyP100->Kind == kASeqPro) {
  if (yyP99->Kind == kAnExpr) {
/* line 621 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 621 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP100->ASeqPro.Protocol, yyP99->AnExpr.Expr);
/* line 621 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckOutputSeqProtocol (yyP100->ASeqPro.Next, yyP99->AnExpr.Next, yyP99->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
;
}

void TypeCheckCaseList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP103, register tTree yyP102, register bool yyP101)
# else
(yyP103, yyP102, yyP101)
 register tTree yyP103;
 register tTree yyP102;
 register bool yyP101;
# endif
{
  if (yyP102->Kind == kNoChoice) {
/* line 625 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
  if (yyP102->Kind == kAChoice) {
  if (yyP102->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP102->AChoice.ExprList->AnExpr.Next->Kind == kNoExpr) {
  if (yyP102->AChoice.ExprList->AnExpr.Expr->Kind == kDefault) {
  if (equalbool (yyP101, false)) {
/* line 626 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 626 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckCaseList (yyP103, yyP102->AChoice.Next, true);
  }
   return;

  }
/* line 627 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 627 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Multiple ELSE options in selection", xxError, yyP102->AChoice.ExprList->AnExpr.Expr->Default.Pos);
  }
   return;

  }
  }
/* line 628 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 629 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 CountList(yyP102->AChoice.ExprList,yyP103);
/* line 630 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TypeCheckCaseList (yyP103, yyP102->AChoice.Next, yyP101);
/* line 631 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 if (!ConstFlag(yyP102->AChoice.ExprList->ExprList))
	Message("CASE options must be constant",xxError,yyP102->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
      if (!(Tree_IsType(ExprListType(yyP102->AChoice.ExprList),kInteger)||Tree_IsType(ExprListType(yyP102->AChoice.ExprList),kByte)||Tree_IsType(ExprListType(yyP102->AChoice.ExprList),kBool)))
	Message("CASE options must be integer or BYTE (or BOOL)",xxError,yyP102->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
      else 
	if (!CheckChoicesDiffer(yyP102->AChoice.ExprList,yyP102->AChoice.Next)) Message("CASE options must be distinct",xxError,yyP102->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
;
}

void TypeCheckRetypes
# if defined __STDC__ | defined __cplusplus
(register tTree yyP107, register tTree yyP106, register tTree yyP105, register tPosition yyP104)
# else
(yyP107, yyP106, yyP105, yyP104)
 register tTree yyP107;
 register tTree yyP106;
 register tTree yyP105;
 register tPosition yyP104;
# endif
{
/* line 640 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 int LS,RS; 
  if (yyP107->Kind == kReshapes) {
/* line 641 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  tTree yyV1;
  tTree yyV2;
  {
/* line 642 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   LS = SizeType (yyP106, yyP104, true, & yyV1);
/* line 643 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   RS = SizeType (yyP105, yyP104, false, & yyV2);
/* line 644 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((LS >= 0))) goto yyL1;
  {
/* line 645 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   DoTypeCheckRetypes (LS, yyV1, RS, yyV2, yyP104);
  }
  }
   return;
 }
yyL1:;

/* line 646 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
/* line 648 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  tTree yyV1;
  tTree yyV2;
  {
/* line 649 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   LS = SizeType (yyP106, yyP104, true, & yyV1);
/* line 650 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   RS = SizeType (yyP105, yyP104, false, & yyV2);
/* line 651 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   DoTypeCheckRetypes (LS, yyV1, RS, yyV2, yyP104);
  }
   return;
 }

;
}

static void DoTypeCheckRetypes
# if defined __STDC__ | defined __cplusplus
(register int yyP112, register tTree yyP111, register int yyP110, register tTree yyP109, register tPosition yyP108)
# else
(yyP112, yyP111, yyP110, yyP109, yyP108)
 register int yyP112;
 register tTree yyP111;
 register int yyP110;
 register tTree yyP109;
 register tPosition yyP108;
# endif
{
  if (equalint (yyP110, - 1)) {
/* line 654 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
/* line 655 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 655 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP109 != NoTree))) goto yyL2;
  }
   return;
yyL2:;

  if (yyP111 == NULL) {
  if (yyP109 == NULL) {
/* line 656 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 656 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP112 == yyP110))) goto yyL3;
  }
   return;
yyL3:;

/* line 657 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 657 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Size of retype does not match expression size", xxError, yyP108);
  }
   return;

  }
  }
  if (yyP109 == NULL) {
/* line 658 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 658 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (((yyP110 % yyP112) == 0))) goto yyL5;
  {
/* line 658 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP111 -> Array . Expr = MakeConstInt (yyP110 / yyP112, yyP108);
  }
  }
   return;
yyL5:;

/* line 659 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 659 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Size of retype cannot match expression size", xxError, yyP108);
  }
   return;

  }
;
}

bool IsUserDataType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP113)
# else
(yyP113)
 register tTree yyP113;
# endif
{
  if (yyP113 == NULL) {
/* line 666 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 666 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;
  }

  }

  switch (yyP113->Kind) {
  case kUserStructTypes:
  case kUserDataTypes:
  case kUserRecord:
  case kUserPackedRecord:
  case kUserUnion:
  case kUserChanRecord:
/* line 667 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  case kUserArray:
/* line 668 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  case kUserInt:
/* line 669 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  case kUserInt16:
/* line 670 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  case kUserInt32:
/* line 671 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  case kUserInt64:
/* line 672 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  case kUserReal32:
/* line 673 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  case kUserReal64:
/* line 674 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  case kUserByte:
/* line 675 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  case kUserBool:
/* line 676 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }

  return false;
}

static tSymbol WhichUserDataType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP114)
# else
(yyP114)
 register tTree yyP114;
# endif
{
  if (yyP114 == NULL) {
/* line 680 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return NoSymbol;

  }

  switch (yyP114->Kind) {
  case kUserStructTypes:
  case kUserDataTypes:
  case kUserRecord:
  case kUserPackedRecord:
  case kUserUnion:
  case kUserChanRecord:
/* line 681 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP114->UserStructTypes.Sym;

  case kUserArray:
/* line 682 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP114->UserArray.Sym;

  case kUserInt:
/* line 683 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP114->UserInt.Sym;

  case kUserInt16:
/* line 684 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP114->UserInt16.Sym;

  case kUserInt32:
/* line 685 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP114->UserInt32.Sym;

  case kUserInt64:
/* line 686 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP114->UserInt64.Sym;

  case kUserReal32:
/* line 687 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP114->UserReal32.Sym;

  case kUserReal64:
/* line 688 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP114->UserReal64.Sym;

  case kUserByte:
/* line 689 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP114->UserByte.Sym;

  case kUserBool:
/* line 690 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP114->UserBool.Sym;

  }

/* line 691 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return NoSymbol;

}

bool IsComputableType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP115)
# else
(yyP115)
 register tTree yyP115;
# endif
{
  if (Tree_IsType (yyP115, kInteger)) {
/* line 695 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP115, kByte)) {
/* line 696 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 696 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xxUserDataTypes)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  return false;
}

bool CheckPragmaTrack
# if defined __STDC__ | defined __cplusplus
(register tTree yyP118, register int yyP117, register int yyP116)
# else
(yyP118, yyP117, yyP116)
 register tTree yyP118;
 register int yyP117;
 register int yyP116;
# endif
{
  if (Tree_IsType (yyP118, kBool)) {
  if (equalint (yyP117, 0)) {
  if (equalint (yyP116, 1)) {
/* line 700 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  }
  }
/* line 701 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 701 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsComputableType (yyP118)))) goto yyL2;
  }
   return true;
yyL2:;

  return false;
}

bool SameBaseType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP120, register tTree yyP119)
# else
(yyP120, yyP119)
 register tTree yyP120;
 register tTree yyP119;
# endif
{
  if (Tree_IsType (yyP120, kArray)) {
/* line 705 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 705 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameBaseType (yyP120->Array.Type, yyP119))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (Tree_IsType (yyP119, kArray)) {
/* line 706 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 706 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameBaseType (yyP120, yyP119->Array.Type))) goto yyL2;
  }
   return true;
yyL2:;

  }
/* line 707 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 707 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP120, yyP119))) goto yyL3;
  }
   return true;
yyL3:;

  return false;
}

bool SameUnderlyingType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP122, register tTree yyP121)
# else
(yyP122, yyP121)
 register tTree yyP122;
 register tTree yyP121;
# endif
{

  switch (yyP122->Kind) {
  case kInt16:
  case kUserInt16:
  if (Tree_IsType (yyP121, kInt16)) {
/* line 711 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kInt32:
  case kUserInt32:
  if (Tree_IsType (yyP121, kInt32)) {
/* line 712 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kInt64:
  case kUserInt64:
  if (Tree_IsType (yyP121, kInt64)) {
/* line 713 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kInt:
  case kUserInt:
  if (Tree_IsType (yyP121, kInt)) {
/* line 714 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kBool:
  case kUserBool:
  if (Tree_IsType (yyP121, kBool)) {
/* line 715 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kReal32:
  case kUserReal32:
  if (Tree_IsType (yyP121, kReal32)) {
/* line 716 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kReal64:
  case kUserReal64:
  if (Tree_IsType (yyP121, kReal64)) {
/* line 717 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kByte:
  case kUserByte:
  if (Tree_IsType (yyP121, kByte)) {
/* line 718 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kTimer:
  if (yyP121->Kind == kTimer) {
/* line 719 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kChan:
  if (yyP121->Kind == kChan) {
/* line 720 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 720 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameProtocol (yyP122->Chan.Protocol, yyP121->Chan.Protocol))) goto yyL10;
  }
   return true;
yyL10:;

  }
  break;
  case kArray:
  case kUserArray:
  if (yyP122->Array.Expr->Kind == kUnBound) {
  if (Tree_IsType (yyP121, kArray)) {
/* line 721 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 721 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP122->Array.Type, yyP121->Array.Type))) goto yyL11;
  }
   return true;
yyL11:;

/* line 722 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 722 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;
  }

  }
  }
  if (Tree_IsType (yyP121, kArray)) {
/* line 723 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 723 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP122->Array.Expr)))) goto yyL13;
  {
/* line 723 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP121->Array.Expr)))) goto yyL13;
  {
/* line 723 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP122->Array.Expr) == ValConstInt (yyP121->Array.Expr)))) goto yyL13;
  {
/* line 723 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP122->Array.Type, yyP121->Array.Type))) goto yyL13;
  }
  }
  }
  }
   return true;
yyL13:;

/* line 724 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 724 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP121->Array.Expr)))) goto yyL14;
  {
/* line 724 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP122->Array.Type, yyP121->Array.Type))) goto yyL14;
  }
  }
   return true;
yyL14:;

/* line 725 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 725 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP122->Array.Expr)))) goto yyL15;
  {
/* line 725 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP122->Array.Type, yyP121->Array.Type))) goto yyL15;
  }
  }
   return true;
yyL15:;

  }
  break;
  }

  return false;
}

static bool SameType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP124, register tTree yyP123)
# else
(yyP124, yyP123)
 register tTree yyP124;
 register tTree yyP123;
# endif
{
/* line 729 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tSymbol S1=NoSymbol,S2=NoSymbol; 
/* line 730 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 730 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (((S1 = WhichUserDataType (yyP124)) != NoSymbol))) goto yyL1;
  {
/* line 730 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (((S2 = WhichUserDataType (yyP123)) != NoSymbol))) goto yyL1;
  {
/* line 730 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((S1 == S2))) goto yyL1;
  }
  }
  }
   return true;
yyL1:;

/* line 731 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 731 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((S1 != NoSymbol))) goto yyL2;
  {
/* line 731 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;
  }
  }
yyL2:;

/* line 732 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 732 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((S2 != NoSymbol))) goto yyL3;
  {
/* line 732 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;
  }
  }
yyL3:;

/* line 733 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 733 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameUnderlyingType (yyP124, yyP123))) goto yyL4;
  }
   return true;
yyL4:;

  return false;
}

static bool CheckValidTag
# if defined __STDC__ | defined __cplusplus
(register tTree yyP126, tSymbol yyP125)
# else
(yyP126, yyP125)
 register tTree yyP126;
 tSymbol yyP125;
# endif
{
  if (yyP126->Kind == kATagPro) {
/* line 737 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 737 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP126->ATagPro.Sym == yyP125))) goto yyL1;
  }
   return true;
yyL1:;

/* line 738 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 738 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckValidTag (yyP126->ATagPro.Next, yyP125))) goto yyL2;
  }
   return true;
yyL2:;

  }
  return false;
}

static bool SameProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP128, register tTree yyP127)
# else
(yyP128, yyP127)
 register tTree yyP128;
 register tTree yyP127;
# endif
{
  if (yyP128->Kind == kAny) {
/* line 742 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP127->Kind == kAny) {
/* line 743 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP128->Kind == kNamed) {
  if (yyP127->Kind == kNamed) {
/* line 744 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 744 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP128->Named.Sym == yyP127->Named.Sym))) goto yyL3;
  }
   return true;
yyL3:;

  }
  }
  if (yyP128->Kind == kSimple) {
  if (yyP127->Kind == kSimple) {
/* line 745 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 745 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP128->Simple.Type, yyP127->Simple.Type))) goto yyL4;
  }
   return true;
yyL4:;

  }
  }
  if (yyP128->Kind == kCounted) {
  if (yyP127->Kind == kCounted) {
/* line 746 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 746 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP128->Counted.Length, yyP127->Counted.Length))) goto yyL5;
  {
/* line 746 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP128->Counted.Type, yyP127->Counted.Type))) goto yyL5;
  }
  }
   return true;
yyL5:;

  }
  }
  return false;
}

bool CheckWritable
# if defined __STDC__ | defined __cplusplus
(register tTree yyP129)
# else
(yyP129)
 register tTree yyP129;
# endif
{
  if (yyP129->Kind == kAnId) {
/* line 750 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP129->Kind == kAFormal) {
  if (yyP129->AFormal.By->Kind == kByRef) {
/* line 751 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  }
  if (yyP129->Kind == kIs) {
/* line 752 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP129, kRetypes)) {
/* line 753 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool CheckWritableExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP130)
# else
(yyP130)
 register tTree yyP130;
# endif
{
  if (yyP130->Kind == kNoExpr) {
/* line 758 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP130->Kind == kAnExpr) {
  if (yyP130->AnExpr.Expr->Kind == kElementalExpr) {
/* line 759 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return CheckWritableExprList (yyP130->AnExpr.Next) && Writable (yyP130->AnExpr.Expr->ElementalExpr.Elemental);

  }
/* line 760 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;

  }
 yyAbort ("CheckWritableExprList");
}

bool CheckForVals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP131)
# else
(yyP131)
 register tTree yyP131;
# endif
{
  if (Tree_IsType (yyP131, kNoFormal)) {
/* line 764 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP131->Kind == kAFormal) {
  if (yyP131->AFormal.By->Kind == kByVal) {
/* line 765 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 765 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckForVals (yyP131->AFormal.Next))) goto yyL2;
  }
   return true;
yyL2:;

  }
  }
  return false;
}

bool CheckValofScope
# if defined __STDC__ | defined __cplusplus
(register tTree yyP133, register int yyP132)
# else
(yyP133, yyP132)
 register tTree yyP133;
 register int yyP132;
# endif
{
  if (yyP133->Kind == kNoExpr) {
/* line 769 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP133->Kind == kAnExpr) {
  if (yyP133->AnExpr.Expr->Kind == kElementalExpr) {
/* line 770 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 770 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP133->AnExpr.Expr->ElementalExpr.Elemental, yyP132))) goto yyL2;
  {
/* line 770 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP133->AnExpr.Next, yyP132))) goto yyL2;
  }
  }
   return true;
yyL2:;

/* line 771 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 771 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;
  }

  }
  if (yyP133->AnExpr.Expr->Kind == kCountArray) {
  if (yyP133->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP133->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
/* line 772 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 772 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP133->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental, yyP132))) goto yyL4;
  {
/* line 772 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP133->AnExpr.Next, yyP132))) goto yyL4;
  }
  }
   return true;
yyL4:;

/* line 773 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 773 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;
  }

  }
  }
  }
/* line 774 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 774 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP133->AnExpr.Next, yyP132))) goto yyL6;
  }
   return true;
yyL6:;

  }
  if (yyP133->Kind == kRange) {
/* line 775 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 775 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP133->Range.Next, yyP132))) goto yyL7;
  }
   return true;
yyL7:;

  }
  if (yyP133->Kind == kSubscript) {
/* line 776 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 776 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP133->Subscript.Next, yyP132))) goto yyL8;
  }
   return true;
yyL8:;

  }
  if (Tree_IsType (yyP133, kIdentifier)) {
/* line 777 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 777 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Symbol (yyP133->Identifier.Sym) . Depth >= yyP132))) goto yyL9;
  }
   return true;
yyL9:;

  }
  return false;
}

bool IsChanOrTimerType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP134)
# else
(yyP134)
 register tTree yyP134;
# endif
{
  if (Tree_IsType (yyP134, kArray)) {
/* line 781 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 781 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsChanOrTimerType (yyP134->Array.Type)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP134->Kind == kUserChanRecord) {
/* line 782 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP134->Kind == kChan) {
/* line 783 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP134->Kind == kTimer) {
/* line 784 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

static bool IsDataType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP135)
# else
(yyP135)
 register tTree yyP135;
# endif
{
  if (Tree_IsType (yyP135, kArray)) {
/* line 788 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 788 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsDataType (yyP135->Array.Type)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (Tree_IsType (yyP135, kPrimitive)) {
/* line 789 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP135, kUserDataTypes)) {
/* line 790 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool IsChanType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP136)
# else
(yyP136)
 register tTree yyP136;
# endif
{
  if (Tree_IsType (yyP136, kArray)) {
/* line 794 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 794 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsChanType (yyP136->Array.Type)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP136->Kind == kUserChanRecord) {
/* line 795 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP136->Kind == kChan) {
/* line 796 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool IsTimerType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP137)
# else
(yyP137)
 register tTree yyP137;
# endif
{
  if (Tree_IsType (yyP137, kArray)) {
/* line 800 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 800 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsTimerType (yyP137->Array.Type)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP137->Kind == kTimer) {
/* line 802 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool IsArrayType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP138)
# else
(yyP138)
 register tTree yyP138;
# endif
{
  if (Tree_IsType (yyP138, kArray)) {
/* line 808 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool IsScalarType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP139)
# else
(yyP139)
 register tTree yyP139;
# endif
{
  if (Tree_IsType (yyP139, kArray)) {
/* line 813 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;

  }
  if (Tree_IsType (yyP139, kUserStructTypes)) {
/* line 814 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;

  }
/* line 815 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

}

static bool CheckChoicesDiffer
# if defined __STDC__ | defined __cplusplus
(register tTree yyP141, register tTree yyP140)
# else
(yyP141, yyP140)
 register tTree yyP141;
 register tTree yyP140;
# endif
{
  if (yyP141->Kind == kNoExpr) {
/* line 819 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP141->Kind == kAnExpr) {
/* line 820 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 820 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckExprDiffers (yyP141->AnExpr.Expr, yyP141->AnExpr.Next, yyP140))) goto yyL2;
  {
/* line 820 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckChoicesDiffer (yyP141->AnExpr.Next, yyP140))) goto yyL2;
  }
  }
   return true;
yyL2:;

  }
  return false;
}

static bool CheckExprDiffers
# if defined __STDC__ | defined __cplusplus
(register tTree yyP144, register tTree yyP143, register tTree yyP142)
# else
(yyP144, yyP143, yyP142)
 register tTree yyP144;
 register tTree yyP143;
 register tTree yyP142;
# endif
{
  if (yyP143->Kind == kNoExpr) {
  if (yyP142->Kind == kNoChoice) {
/* line 824 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP142->Kind == kAChoice) {
/* line 825 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 825 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckExprDiffers (yyP144, yyP142->AChoice.ExprList, yyP142->AChoice.Next))) goto yyL2;
  }
   return true;
yyL2:;

  }
  }
  if (yyP143->Kind == kAnExpr) {
/* line 826 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 826 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP144)))) goto yyL3;
  }
   return true;
yyL3:;

/* line 827 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 827 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP143->AnExpr.Expr)))) goto yyL4;
  {
/* line 827 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckExprDiffers (yyP144, yyP143->AnExpr.Next, yyP142))) goto yyL4;
  }
  }
   return true;
yyL4:;

/* line 828 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 828 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP144) != ValConstInt (yyP143->AnExpr.Expr)))) goto yyL5;
  {
/* line 828 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckExprDiffers (yyP144, yyP143->AnExpr.Next, yyP142))) goto yyL5;
  }
  }
   return true;
yyL5:;

  }
  return false;
}

bool CheckValidDeclType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP145)
# else
(yyP145)
 register tTree yyP145;
# endif
{
  if (Tree_IsType (yyP145, kArray)) {
/* line 832 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 832 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP145->Array.Expr)))) goto yyL1;
  {
/* line 832 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP145->Array.Expr) > 0))) goto yyL1;
  {
/* line 832 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckValidDeclType (yyP145->Array.Type))) goto yyL1;
  }
  }
  }
   return true;
yyL1:;

/* line 833 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 833 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;
  }

  }
/* line 834 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

}

bool CheckFuncType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP146)
# else
(yyP146)
 register tTree yyP146;
# endif
{
  if (yyP146->Kind == kAType) {
/* line 838 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 838 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xxUserDataTypes)))) goto yyL1;
  {
/* line 839 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((CheckValidDeclType (yyP146->AType.Type)))) goto yyL1;
  {
/* line 840 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsDataType (yyP146->AType.Type)))) goto yyL1;
  {
/* line 841 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((CheckFuncType (yyP146->AType.Next)))) goto yyL1;
  }
  }
  }
  }
   return true;
yyL1:;

  if (Tree_IsType (yyP146->AType.Type, kArray)) {
/* line 843 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 843 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! IS_Mode (xxUserDataTypes)))) goto yyL2;
  {
/* line 844 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;
  }
  }
yyL2:;

  }
/* line 846 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP146->Kind == kNoType) {
/* line 847 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool CheckEvalBiOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP148, register tTree yyP147)
# else
(yyP148, yyP147)
 register tTree yyP148;
 register tTree yyP147;
# endif
{
  if (Tree_IsType (yyP147, kInteger)) {
/* line 853 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 853 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckEvalBiIntOp (yyP148))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (Tree_IsType (yyP147, kReal)) {
/* line 855 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 855 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckEvalBiRealOp (yyP148))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (Tree_IsType (yyP147, kByte)) {
/* line 857 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 857 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckEvalBiIntOp (yyP148))) goto yyL3;
  }
   return true;
yyL3:;

  }
  if (Tree_IsType (yyP148, kLogOp)) {
  if (Tree_IsType (yyP147, kBool)) {
/* line 859 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  }
  if (Tree_IsType (yyP148, kRelOp)) {
  if (Tree_IsType (yyP147, kBool)) {
/* line 860 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  }
  if (yyP148->Kind == kAfterOp) {
  if (Tree_IsType (yyP147, kBool)) {
/* line 861 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  }
  return false;
}

static bool CheckEvalBiIntOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP149)
# else
(yyP149)
 register tTree yyP149;
# endif
{
  if (Tree_IsType (yyP149, kMathsOp)) {
/* line 864 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP149, kClockOp)) {
/* line 865 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP149, kRelOp)) {
/* line 866 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP149, kBitOp)) {
/* line 867 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP149, kShiftOp)) {
/* line 868 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP149->Kind == kAfterOp) {
/* line 869 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

static bool CheckEvalBiRealOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP150)
# else
(yyP150)
 register tTree yyP150;
# endif
{
  if (Tree_IsType (yyP150, kMathsOp)) {
/* line 872 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP150, kRelOp)) {
/* line 873 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool CheckEvalUniOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP153, register tTree yyP152, register tTree yyP151)
# else
(yyP153, yyP152, yyP151)
 register tTree yyP153;
 register tTree yyP152;
 register tTree yyP151;
# endif
{
  if (Tree_IsType (yyP153, kInteger)) {
  if (yyP152->Kind == kBitNot) {
/* line 879 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 879 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP151)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP152->Kind == kSubtract) {
/* line 881 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 881 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP151)))) goto yyL3;
  }
   return true;
yyL3:;

  }
  if (yyP152->Kind == kMinus) {
/* line 882 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 882 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP151)))) goto yyL4;
  }
   return true;
yyL4:;

  }
  if (yyP152->Kind == kPlus) {
/* line 883 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 883 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP151)))) goto yyL5;
  }
   return true;
yyL5:;

  }
  if (yyP152->Kind == kAdd) {
/* line 884 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 884 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP151)))) goto yyL6;
  }
   return true;
yyL6:;

  }
  }
  if (Tree_IsType (yyP153, kBool)) {
  if (yyP152->Kind == kNot) {
/* line 880 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 880 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP151)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  }
  if (Tree_IsType (yyP153, kReal)) {
  if (yyP152->Kind == kSubtract) {
/* line 885 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 885 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP151)))) goto yyL7;
  }
   return true;
yyL7:;

  }
  if (yyP152->Kind == kAdd) {
/* line 886 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 886 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP151)))) goto yyL8;
  }
   return true;
yyL8:;

  }
  }
  if (Tree_IsType (yyP153, kArray)) {
  if (yyP152->Kind == kSize) {
/* line 887 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 887 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP153->Array.Expr)))) goto yyL9;
  }
   return true;
yyL9:;

  }
  }
  return false;
}

tValue EvalBiExpr
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP158, register tTree yyP157, tValue yyP156, register tTree yyP155, tValue yyP154)
# else
(yyP158, yyP157, yyP156, yyP155, yyP154)
 register tPosition yyP158;
 register tTree yyP157;
 tValue yyP156;
 register tTree yyP155;
 tValue yyP154;
# endif
{
/* line 892 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP157, kInteger)) {
/* line 894 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 894 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = EvalBiIntOp (yyP158, yyP157, yyP156 . Number, yyP155, yyP154 . Number);
  }
   return Res;

  }
  if (Tree_IsType (yyP157, kByte)) {
/* line 895 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 895 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = EvalBiIntOp (yyP158, yyP157, yyP156 . Number, yyP155, yyP154 . Number);
  }
   return Res;

  }
  if (Tree_IsType (yyP157, kBool)) {
/* line 896 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 896 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = EvalBiBoolOp (yyP158, yyP157, yyP156 . Number, yyP155, yyP154 . Number);
  }
   return Res;

  }
  if (Tree_IsType (yyP157, kReal)) {
  if (Tree_IsType (yyP155, kMathsOp)) {
/* line 897 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 897 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . RNumber . n = EvalBiRealMathsOp (yyP158, yyP157, yyP156 . RNumber . n, yyP155, yyP154 . RNumber . n);
/* line 897 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . RNumber . p = MAX (yyP156 . RNumber . p, yyP154 . RNumber . p);
  }
   return Res;

  }
  if (Tree_IsType (yyP155, kRelOp)) {
/* line 898 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 898 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = EvalBiRealRelOp (yyP158, yyP157, yyP156 . RNumber . n, yyP155, yyP154 . RNumber . n);
  }
   return Res;

  }
  }
 yyAbort ("EvalBiExpr");
}

static tInt EvalBiIntOp
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP163, register tTree yyP162, tInt yyP161, register tTree yyP160, tInt yyP159)
# else
(yyP163, yyP162, yyP161, yyP160, yyP159)
 register tPosition yyP163;
 register tTree yyP162;
 tInt yyP161;
 register tTree yyP160;
 tInt yyP159;
# endif
{
/* line 902 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tInt res; 

  switch (yyP160->Kind) {
  case kAdd:
/* line 904 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return TestIntOVF (yyP163, yyP162, yyP161 + yyP159);

  case kSubtract:
/* line 905 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return TestIntOVF (yyP163, yyP162, yyP161 - yyP159);

  case kMultiply:
/* line 906 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return TestIntOVF (yyP163, yyP162, yyP161 * yyP159);

  case kDivide:
/* line 908 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 908 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP159 != 0))) goto yyL4;
  }
   return TestIntOVF (yyP163, yyP162, yyP161 / yyP159);
yyL4:;

/* line 909 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return TestIntOVF (yyP163, mUntyped (), 1);

  case kRem:
/* line 910 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 910 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP159 != 0))) goto yyL6;
  }
   return TestIntOVF (yyP163, yyP162, yyP161 % yyP159);
yyL6:;

/* line 911 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return TestIntOVF (yyP163, mUntyped (), 1);

  case kEqual:
/* line 913 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP161 == yyP159;

  case kNotEqual:
/* line 914 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP161 != yyP159;

  case kLess:
/* line 915 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP161 < yyP159;

  case kGreater:
/* line 916 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP161 > yyP159;

  case kLessEqual:
/* line 917 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP161 <= yyP159;

  case kGreaterEqual:
/* line 918 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP161 >= yyP159;

  case kBitAnd:
/* line 920 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP161 & yyP159;

  case kBitOr:
/* line 921 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP161 | yyP159;

  case kBitEor:
/* line 922 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 922 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 res = yyP161^yyP159;
  }
   return res;

  case kShiftOp:
  case kLeftShift:
  case kRightShift:
/* line 924 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 924 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP159 == 0))) goto yyL17;
  }
   return yyP161;
yyL17:;

/* line 925 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 925 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP159 > EvalIntBits (yyP162)))) goto yyL18;
  {
/* line 925 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Shift by invalid value for Integer size. Result is always zero", xxWarning, yyP163);
  }
  }
   return 0;
yyL18:;

/* line 926 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 926 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP159 < 0))) goto yyL19;
  {
/* line 926 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Shift by invalid (negative) value", xxError, yyP163);
  }
  }
   return 0;
yyL19:;

  break;
  }

  if (yyP160->Kind == kLeftShift) {
/* line 928 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 928 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 res = SignExtendInt(yyP162,yyP161<<yyP159); 
  }
   return res;

  }
  if (yyP160->Kind == kRightShift) {
/* line 929 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 929 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 res = SignExtendInt(yyP162,(tInt)(((tUInt)(EvalIntMask(yyP162)&yyP161)) >> yyP159)); 
  }
   return res;

  }
  if (yyP160->Kind == kPlus) {
/* line 931 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return SignExtendInt (yyP162, yyP161 + yyP159);

  }
  if (yyP160->Kind == kMinus) {
/* line 932 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return SignExtendInt (yyP162, yyP161 - yyP159);

  }
  if (yyP160->Kind == kTimes) {
/* line 933 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return SignExtendInt (yyP162, yyP161 * yyP159);

  }
  if (yyP160->Kind == kAfterOp) {
/* line 935 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 935 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 res = ((tUInt)yyP161 > (tUInt)yyP159); 
  }
   return res;

  }
 yyAbort ("EvalBiIntOp");
}

static int EvalBiBoolOp
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP168, register tTree yyP167, tInt yyP166, register tTree yyP165, tInt yyP164)
# else
(yyP168, yyP167, yyP166, yyP165, yyP164)
 register tPosition yyP168;
 register tTree yyP167;
 tInt yyP166;
 register tTree yyP165;
 tInt yyP164;
# endif
{

  switch (yyP165->Kind) {
  case kEqual:
/* line 942 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP166 == yyP164;

  case kNotEqual:
/* line 943 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP166 != yyP164;

  case kLess:
/* line 944 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP166 < yyP164;

  case kGreater:
/* line 945 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP166 > yyP164;

  case kLessEqual:
/* line 946 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP166 <= yyP164;

  case kGreaterEqual:
/* line 947 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP166 >= yyP164;

  case kAnd:
/* line 949 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP166 && yyP164;

  case kOr:
/* line 950 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP166 || yyP164;

  }

 yyAbort ("EvalBiBoolOp");
}

static double EvalBiRealMathsOp
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP173, register tTree yyP172, register double yyP171, register tTree yyP170, register double yyP169)
# else
(yyP173, yyP172, yyP171, yyP170, yyP169)
 register tPosition yyP173;
 register tTree yyP172;
 register double yyP171;
 register tTree yyP170;
 register double yyP169;
# endif
{
/* line 955 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 double Res = 0; 
  if (yyP170->Kind == kAdd) {
/* line 957 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP171 + yyP169;

  }
  if (yyP170->Kind == kSubtract) {
/* line 958 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP171 - yyP169;

  }
  if (yyP170->Kind == kMultiply) {
/* line 959 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP171 * yyP169;

  }
  if (yyP170->Kind == kDivide) {
/* line 960 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 960 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP169 != 0))) goto yyL4;
  }
   return yyP171 / yyP169;
yyL4:;

/* line 961 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 961 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 TestIntOVF(yyP173,mUntyped(),1); 
  }
   return Res;

  }
  if (yyP170->Kind == kRem) {
/* line 962 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 962 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP169 != 0))) goto yyL6;
  {
/* line 962 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res = yyP171-(yyP169*(int)(yyP171/yyP169)); 
  }
  }
   return Res;
yyL6:;

/* line 963 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 963 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 TestIntOVF(yyP173,mUntyped(),1); 
  }
   return Res;

  }
 yyAbort ("EvalBiRealMathsOp");
}

static int EvalBiRealRelOp
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP178, register tTree yyP177, register double yyP176, register tTree yyP175, register double yyP174)
# else
(yyP178, yyP177, yyP176, yyP175, yyP174)
 register tPosition yyP178;
 register tTree yyP177;
 register double yyP176;
 register tTree yyP175;
 register double yyP174;
# endif
{
  if (yyP175->Kind == kEqual) {
/* line 969 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP176 == yyP174;

  }
  if (yyP175->Kind == kNotEqual) {
/* line 970 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP176 != yyP174;

  }
  if (yyP175->Kind == kLess) {
/* line 971 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP176 < yyP174;

  }
  if (yyP175->Kind == kGreater) {
/* line 972 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP176 > yyP174;

  }
  if (yyP175->Kind == kLessEqual) {
/* line 973 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP176 <= yyP174;

  }
  if (yyP175->Kind == kGreaterEqual) {
/* line 974 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP176 >= yyP174;

  }
 yyAbort ("EvalBiRealRelOp");
}

tValue EvalUniExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP181, register tTree yyP180, register tTree yyP179)
# else
(yyP181, yyP180, yyP179)
 register tTree yyP181;
 register tTree yyP180;
 register tTree yyP179;
# endif
{
/* line 981 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP181, kInteger)) {
  if (yyP180->Kind == kBitNot) {
/* line 983 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 983 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = ~ ValConstInt (yyP179);
  }
   return Res;

  }
  if (yyP180->Kind == kSubtract) {
/* line 984 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 984 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = - ValConstInt (yyP179);
  }
   return Res;

  }
  if (yyP180->Kind == kMinus) {
/* line 985 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 985 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = - ValConstInt (yyP179);
  }
   return Res;

  }
  if (yyP180->Kind == kPlus) {
/* line 986 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 986 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = ValConstInt (yyP179);
  }
   return Res;

  }
  if (yyP180->Kind == kAdd) {
/* line 987 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 987 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = ValConstInt (yyP179);
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP181, kBool)) {
  if (yyP180->Kind == kNot) {
/* line 989 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 989 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = ! (ValConstInt (yyP179));
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP181, kReal)) {
  if (yyP180->Kind == kSubtract) {
/* line 990 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 990 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . RNumber . n = - ValConstExpr (yyP179) . RNumber . n;
/* line 990 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . RNumber . p = ValConstExpr (yyP179) . RNumber . p;
  }
   return Res;

  }
  if (yyP180->Kind == kAdd) {
/* line 991 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 991 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . RNumber . n = - ValConstExpr (yyP179) . RNumber . n;
/* line 991 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . RNumber . p = ValConstExpr (yyP179) . RNumber . p;
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP181, kArray)) {
  if (yyP180->Kind == kSize) {
/* line 993 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 993 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = ValConstInt (yyP181->Array.Expr);
  }
   return Res;

  }
  }
 yyAbort ("EvalUniExpr");
}

bool CheckConstConvert
# if defined __STDC__ | defined __cplusplus
(register tTree yyP182)
# else
(yyP182)
 register tTree yyP182;
# endif
{
  if (Tree_IsType (yyP182, kInteger)) {
/* line 999 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP182, kBool)) {
/* line 1000 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP182, kByte)) {
/* line 1001 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

tValue EvalConstConvert
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP185, register tTree yyP184, register tTree yyP183)
# else
(yyP185, yyP184, yyP183)
 register tPosition yyP185;
 register tTree yyP184;
 register tTree yyP183;
# endif
{
/* line 1005 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tValue Res; 
/* line 1007 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1007 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = TestIntOVF (yyP185, yyP184, ValConstInt (yyP183));
  }
   return Res;

}

tValue CheckConst
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP189, register tTree yyP188, tInt yyP187, register bool yyP186)
# else
(yyP189, yyP188, yyP187, yyP186)
 register tPosition yyP189;
 register tTree yyP188;
 tInt yyP187;
 register bool yyP186;
# endif
{
/* line 1011 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP188, kUntyped)) {
/* line 1012 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1012 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.Number = yyP187; 
  }
   return Res;

  }
/* line 1013 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1013 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP186 == false))) goto yyL2;
  {
/* line 1013 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.Number = TestIntOVF(yyP189,yyP188,yyP187); 
  }
  }
   return Res;
yyL2:;

/* line 1014 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1014 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.Number = SignExtendInt(yyP188,yyP187); 
  }
   return Res;

}

bool CheckConstRoundTrunc
# if defined __STDC__ | defined __cplusplus
(register tTree yyP191, register tTree yyP190)
# else
(yyP191, yyP190)
 register tTree yyP191;
 register tTree yyP190;
# endif
{
  if (Tree_IsType (yyP191, kReal)) {
/* line 1020 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP190, kReal)) {
/* line 1021 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

tValue EvalConstTrunc
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP195, register tTree yyP194, register tTree yyP193, tValue yyP192)
# else
(yyP195, yyP194, yyP193, yyP192)
 register tPosition yyP195;
 register tTree yyP194;
 register tTree yyP193;
 tValue yyP192;
# endif
{
/* line 1040 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP194, kReal)) {
  if (Tree_IsType (yyP193, kReal)) {
/* line 1042 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1042 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.RNumber.n = floor(yyP192.RNumber.n); Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n)); 
  }
   return Res;

  }
  if (Tree_IsType (yyP193, kInteger)) {
/* line 1045 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1045 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.RNumber.n = (double)yyP192.Number; Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n)); 
  }
   return Res;

  }
  if (Tree_IsType (yyP193, kByte)) {
/* line 1046 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1046 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.RNumber.n = (double)yyP192.Number; Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n)); 
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP194, kInteger)) {
  if (Tree_IsType (yyP193, kReal)) {
/* line 1043 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1043 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.Number = TestIntOVF(yyP195,yyP194,(tInt)yyP192.RNumber.n); 
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP194, kByte)) {
  if (Tree_IsType (yyP193, kReal)) {
/* line 1044 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1044 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.Number = TestIntOVF(yyP195,yyP194,(tInt)yyP192.RNumber.n); 
  }
   return Res;

  }
  }
 yyAbort ("EvalConstTrunc");
}

tValue EvalConstRound
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP199, register tTree yyP198, register tTree yyP197, tValue yyP196)
# else
(yyP199, yyP198, yyP197, yyP196)
 register tPosition yyP199;
 register tTree yyP198;
 register tTree yyP197;
 tValue yyP196;
# endif
{
/* line 1066 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP198, kReal)) {
  if (Tree_IsType (yyP197, kReal)) {
/* line 1068 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1068 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.RNumber.n = floor(yyP196.RNumber.n + 0.5); Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n));; 
  }
   return Res;

  }
  if (Tree_IsType (yyP197, kInteger)) {
/* line 1071 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1071 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.RNumber.n = (double)yyP196.Number; Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n));; 
  }
   return Res;

  }
  if (Tree_IsType (yyP197, kByte)) {
/* line 1072 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1072 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.RNumber.n = (double)yyP196.Number; Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n));; 
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP198, kInteger)) {
  if (Tree_IsType (yyP197, kReal)) {
/* line 1069 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1069 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.Number = TestIntOVF(yyP199,yyP198,(tInt)(yyP196.RNumber.n + 0.5)); 
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP198, kByte)) {
  if (Tree_IsType (yyP197, kReal)) {
/* line 1070 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1070 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 Res.Number = TestIntOVF(yyP199,yyP198,(tInt)(yyP196.RNumber.n + 0.5)); 
  }
   return Res;

  }
  }
 yyAbort ("EvalConstRound");
}

bool CheckConstId
# if defined __STDC__ | defined __cplusplus
(register tTree yyP200)
# else
(yyP200)
 register tTree yyP200;
# endif
{
  if (yyP200 == NULL) {
/* line 1079 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1079 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;
  }

  }
  if (Tree_IsType (yyP200, kAVal)) {
/* line 1080 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1080 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP200->AVal.Expr)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (yyP200->Kind == kATagPro) {
/* line 1081 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP200->Kind == kAField) {
/* line 1082 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

tValue EvalConstId
# if defined __STDC__ | defined __cplusplus
(register tTree yyP201)
# else
(yyP201)
 register tTree yyP201;
# endif
{
/* line 1086 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tValue Res; 
  if (yyP201->Kind == kVal) {
/* line 1087 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return ValConstExpr (yyP201->Val.Expr);

  }
  if (Tree_IsType (yyP201, kValRetypes)) {
/* line 1089 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1089 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsArrayType (yyP201->ValRetypes.Type)))) goto yyL2;
  }
   return ValConstExpr (yyP201->ValRetypes.Expr);
yyL2:;

/* line 1091 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1091 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (yyP201->ValRetypes.Expr))))) goto yyL3;
  {
/* line 1092 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 
    unsigned char tmp[8];
    tConstArray D = (tConstArray)tmp;
    int SS = CalcTypeSize(ArrayPrimType(ExprType(yyP201->ValRetypes.Expr)));
    int DS = CalcTypeSize(yyP201->ValRetypes.Type);

    RetypeConst(SS,GetConstArray(yyP201->ValRetypes.Expr),DS,D);
    Res = ReadConstArray(yyP201->ValRetypes.Type,D);
  
  }
  }
   return Res;
yyL3:;

/* line 1102 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1103 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 
    unsigned char tmp1[8],tmp2[8];
    tConstArray D = (tConstArray)tmp1;
    tConstArray S = (tConstArray)tmp2;
    int SS = CalcTypeSize(ArrayPrimType(ExprType(yyP201->ValRetypes.Expr)));
    int DS = CalcTypeSize(yyP201->ValRetypes.Type);

    WriteConstArray(ExprType(yyP201->ValRetypes.Expr),ValConstExpr(yyP201->ValRetypes.Expr),S);
    RetypeConst(SS,S,DS,D);
    Res = ReadConstArray(yyP201->ValRetypes.Type,D);
  
  }
   return Res;

  }
  if (yyP201->Kind == kATagPro) {
/* line 1116 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1116 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = CountTags (yyP201->ATagPro.Sym);
  }
   return Res;

  }
  if (yyP201->Kind == kAField) {
/* line 1120 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1120 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . Number = CountFields (yyP201->AField.Sym);
  }
   return Res;

  }
 yyAbort ("EvalConstId");
}

tInt TestIntOVF
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP204, register tTree yyP203, tInt yyP202)
# else
(yyP204, yyP203, yyP202)
 register tPosition yyP204;
 register tTree yyP203;
 tInt yyP202;
# endif
{
  if (Tree_IsType (yyP203, kInt64)) {
/* line 1128 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP202;

  }
  if (Tree_IsType (yyP203, kInt)) {
/* line 1129 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1129 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP202 >= MOSTNEGINT && yyP202 <= MOSTPOSINT))) goto yyL2;
  }
   return yyP202;
yyL2:;

  }
  if (Tree_IsType (yyP203, kInt32)) {
/* line 1130 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1130 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP202 >= MOSTNEGINT32 && yyP202 <= MOSTPOSINT32))) goto yyL3;
  }
   return yyP202;
yyL3:;

  }
  if (Tree_IsType (yyP203, kInt16)) {
/* line 1131 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1131 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP202 >= MOSTNEGINT16 && yyP202 <= MOSTPOSINT16))) goto yyL4;
  }
   return yyP202;
yyL4:;

  }
  if (Tree_IsType (yyP203, kByte)) {
/* line 1132 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1132 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP202 & (~ BYTEMASK)) == 0)) goto yyL5;
  }
   return yyP202;
yyL5:;

  }
  if (Tree_IsType (yyP203, kBool)) {
/* line 1133 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1133 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP202 & (~ BOOLMASK)) == 0)) goto yyL6;
  }
   return yyP202;
yyL6:;

  }
/* line 1135 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1135 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP202 = 0;
/* line 1135 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Overflow when evaluating constant expression", xxError, yyP204);
  }
   return yyP202;

}

tInt SignExtendInt
# if defined __STDC__ | defined __cplusplus
(register tTree yyP206, tInt yyP205)
# else
(yyP206, yyP205)
 register tTree yyP206;
 tInt yyP205;
# endif
{
  if (Tree_IsType (yyP206, kInt64)) {
/* line 1140 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP205;

  }
  if (Tree_IsType (yyP206, kInt)) {
/* line 1141 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1141 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xx16bitINT)))) goto yyL2;
  {
/* line 1141 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 yyP205 = (tInt)((short)yyP205); 
  }
  }
   return yyP205;
yyL2:;

/* line 1142 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1142 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 yyP205 = ((int)yyP205); 
  }
   return yyP205;

  }
  if (Tree_IsType (yyP206, kInt32)) {
/* line 1143 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1143 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 yyP205 = ((int)yyP205); 
  }
   return yyP205;

  }
  if (Tree_IsType (yyP206, kInt16)) {
/* line 1144 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1144 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 yyP205 = ((short)yyP205); 
  }
   return yyP205;

  }
  if (Tree_IsType (yyP206, kByte)) {
/* line 1145 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP205;

  }
  if (Tree_IsType (yyP206, kBool)) {
/* line 1146 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP205;

  }
/* line 1148 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP205;

}

static int CountTags
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP207)
# else
(yyP207)
 tSymbol yyP207;
# endif
{
/* line 1153 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1153 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! Tree_IsType (SymbolKind (yyP207 - 1), kATagPro)))) goto yyL1;
  }
   return 0;
yyL1:;

/* line 1154 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 1 + CountTags (yyP207 - 1);

}

static int CountFields
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP208)
# else
(yyP208)
 tSymbol yyP208;
# endif
{
/* line 1158 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1158 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! Tree_IsType (SymbolKind (yyP208 - 1), kAField)))) goto yyL1;
  }
   return 0;
yyL1:;

/* line 1159 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 1 + CountFields (yyP208 - 1);

}

static tInt EvalIntBits
# if defined __STDC__ | defined __cplusplus
(register tTree yyP209)
# else
(yyP209)
 register tTree yyP209;
# endif
{
  if (Tree_IsType (yyP209, kInt)) {
/* line 1164 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 32;

  }
  if (Tree_IsType (yyP209, kByte)) {
/* line 1165 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 8;

  }
  if (Tree_IsType (yyP209, kInt16)) {
/* line 1166 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 16;

  }
  if (Tree_IsType (yyP209, kInt32)) {
/* line 1167 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 32;

  }
  if (Tree_IsType (yyP209, kInt64)) {
/* line 1168 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 64;

  }
 yyAbort ("EvalIntBits");
}

tInt EvalMostPos
# if defined __STDC__ | defined __cplusplus
(register tTree yyP210)
# else
(yyP210)
 register tTree yyP210;
# endif
{
  if (Tree_IsType (yyP210, kByte)) {
/* line 1172 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return MOSTPOSBYTE;

  }
  if (Tree_IsType (yyP210, kInt)) {
/* line 1173 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return MOSTPOSINT;

  }
  if (Tree_IsType (yyP210, kInt16)) {
/* line 1174 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return MOSTPOSINT16;

  }
  if (Tree_IsType (yyP210, kInt32)) {
/* line 1175 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return MOSTPOSINT32;

  }
  if (Tree_IsType (yyP210, kInt64)) {
/* line 1176 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return MOSTPOSINT64;

  }
 yyAbort ("EvalMostPos");
}

tInt EvalMostNeg
# if defined __STDC__ | defined __cplusplus
(register tTree yyP211)
# else
(yyP211)
 register tTree yyP211;
# endif
{
  if (Tree_IsType (yyP211, kByte)) {
/* line 1180 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return MOSTNEGBYTE;

  }
  if (Tree_IsType (yyP211, kInt)) {
/* line 1181 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return MOSTNEGINT;

  }
  if (Tree_IsType (yyP211, kInt16)) {
/* line 1182 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return MOSTNEGINT16;

  }
  if (Tree_IsType (yyP211, kInt32)) {
/* line 1183 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return MOSTNEGINT32;

  }
  if (Tree_IsType (yyP211, kInt64)) {
/* line 1184 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return MOSTNEGINT64;

  }
 yyAbort ("EvalMostNeg");
}

static tInt EvalIntMask
# if defined __STDC__ | defined __cplusplus
(register tTree yyP212)
# else
(yyP212)
 register tTree yyP212;
# endif
{
  if (Tree_IsType (yyP212, kByte)) {
/* line 1188 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return BYTEMASK;

  }
  if (Tree_IsType (yyP212, kInt)) {
/* line 1189 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return INTMASK;

  }
  if (Tree_IsType (yyP212, kInt16)) {
/* line 1190 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return INT16MASK;

  }
  if (Tree_IsType (yyP212, kInt32)) {
/* line 1191 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return INT32MASK;

  }
  if (Tree_IsType (yyP212, kInt64)) {
/* line 1192 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return INT64MASK;

  }
 yyAbort ("EvalIntMask");
}

tValue EvalConstSubscript
# if defined __STDC__ | defined __cplusplus
(register tTree yyP215, register int yyP214, tConstArray yyP213)
# else
(yyP215, yyP214, yyP213)
 register tTree yyP215;
 register int yyP214;
 tConstArray yyP213;
# endif
{
/* line 1197 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tValue Res; tTree E; 
  if (Tree_IsType (yyP215, kReal32)) {
/* line 1199 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1199 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . RNumber . n =  ((float *)yyP213)[yyP214] ;
/* line 1199 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . RNumber . p = 0;
  }
   return Res;

  }
  if (Tree_IsType (yyP215, kReal64)) {
/* line 1200 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1200 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . RNumber . n =  ((double *)yyP213)[yyP214] ;
/* line 1200 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Res . RNumber . p = 0;
  }
   return Res;

  }
  if (Tree_IsType (yyP215, kPrimitive)) {
/* line 1201 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1202 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

      switch(CalcTypeSize(yyP215))
      {
	case 1:  Res.Number = ((unsigned char *)yyP213)[yyP214]; break;
	case 2:  Res.Number = ((short *)yyP213)[yyP214]; break;
	case 4:  Res.Number = ((int *)yyP213)[yyP214]; break;
	case 8:  Res.Number = ((tInt *)yyP213)[yyP214]; break;
      }
    
  }
   return Res;

  }
 yyAbort ("EvalConstSubscript");
}

tConstArray ConstArrayFromString
# if defined __STDC__ | defined __cplusplus
(register tTree yyP217, register tStringRef yyP216)
# else
(yyP217, yyP216)
 register tTree yyP217;
 register tStringRef yyP216;
# endif
{
/* line 1216 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tConstArray CA; 
/* line 1218 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1218 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   CA = NewConstArray (LengthSt (yyP216));
/* line 1219 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 StGetString(yyP216,CA); 
  }
   return CA;

}

tConstArray ConstArrayFromExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP219, register tTree yyP218)
# else
(yyP219, yyP218)
 register tTree yyP219;
 register tTree yyP218;
# endif
{
/* line 1223 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tConstArray CA; 
  if (Tree_IsType (yyP219, kArray)) {
/* line 1224 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1224 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   CA = NewConstArray (CalcTypeSize (yyP219));
/* line 1224 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   FillConstArray (yyP219->Array.Type, yyP218, CA);
  }
   return CA;

  }
  if (Tree_IsType (yyP219, kUserDataTypes)) {
/* line 1225 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1225 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   CA = NewConstArray (CalcTypeSize (yyP219));
/* line 1225 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   FillConstFields (yyP219, yyP219->UserDataTypes.FieldList, yyP218, CA);
  }
   return CA;

  }
 yyAbort ("ConstArrayFromExprList");
}

tConstArray ConstArrayFromDecl
# if defined __STDC__ | defined __cplusplus
(register tTree yyP221, register tTree yyP220)
# else
(yyP221, yyP220)
 register tTree yyP221;
 register tTree yyP220;
# endif
{
/* line 1230 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tConstArray CA; 
  if (yyP220->Kind == kAField) {
/* line 1231 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return NoConstArray;

  }
  if (yyP220->Kind == kVal) {
  if (yyP220->Val.Expr->Kind == kElementalExpr) {
/* line 1232 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1232 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! IsScalarType (ExprType (yyP220->Val.Expr))))) goto yyL2;
  }
   return  yyP220->Val.Expr->ElementalExpr.Elemental->Elemental.CA ;
yyL2:;

  }
  if (Tree_IsType (yyP220->Val.Expr, kStringElement)) {
/* line 1233 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1233 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (yyP220->Val.Expr))))) goto yyL3;
  }
   return  yyP220->Val.Expr->StringElement.CA ;
yyL3:;

  }
  if (yyP220->Val.Expr->Kind == kValof) {
/* line 1234 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1234 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! IsScalarType (ExprType (yyP220->Val.Expr))))) goto yyL4;
  }
   return ConstArrayFromDecl (yyP221, yyP220->Val.Expr);
yyL4:;

  }
  }
  if (yyP220->Kind == kValof) {
  if (yyP220->Valof.ExprList->Kind == kAnExpr) {
  if (yyP220->Valof.ExprList->AnExpr.Expr->Kind == kValof) {
/* line 1235 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1235 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! IsScalarType (ExprType (yyP220->Valof.ExprList->AnExpr.Expr))))) goto yyL5;
  }
   return ConstArrayFromDecl (yyP221, yyP220->Valof.ExprList->AnExpr.Expr);
yyL5:;

  }
  if (yyP220->Valof.ExprList->AnExpr.Expr->Kind == kElementalExpr) {
/* line 1236 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1236 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! IsScalarType (ExprType (yyP220->Valof.ExprList->AnExpr.Expr))))) goto yyL6;
  }
   return  yyP220->Valof.ExprList->AnExpr.Expr->ElementalExpr.Elemental->Elemental.CA ;
yyL6:;

  }
  if (Tree_IsType (yyP220->Valof.ExprList->AnExpr.Expr, kStringElement)) {
/* line 1237 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1237 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! IsScalarType (ExprType (yyP220->Valof.ExprList->AnExpr.Expr))))) goto yyL7;
  }
   return  yyP220->Valof.ExprList->AnExpr.Expr->StringElement.CA ;
yyL7:;

  }
  }
  }
  if (Tree_IsType (yyP221, kArray)) {
  if (Tree_IsType (yyP220, kValRetypes)) {
  if (yyP220->ValRetypes.Expr->Kind == kElementalExpr) {
/* line 1239 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1239 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (yyP220->ValRetypes.Expr))))) goto yyL8;
  {
/* line 1240 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

      { tConstArray S,D;
	int SS = CalcTypeSize(ArrayPrimType(ExprType(yyP220->ValRetypes.Expr)));
	int DS = CalcTypeSize(ArrayPrimType(yyP221));
	int sz = CalcTypeSize(yyP221);
	int psz = CalcTypeSize(ArrayPrimType(yyP221));
	int count = sz/psz;

	CA = NewConstArray(sz);
	S = GetConstArray(yyP220->ValRetypes.Expr);
	D = CA;

	while(count-- > 0)
	{
	  RetypeConst(SS,S,DS,D);
	  D += DS; S += DS;
	}
      }
    
  }
  }
   return CA;
yyL8:;

  }
/* line 1261 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1262 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

      { tConstArray S,D;
	int SS = CalcTypeSize(ExprType(yyP220->ValRetypes.Expr));
	int DS = CalcTypeSize(ArrayPrimType(yyP221));

	CA = NewConstArray(CalcTypeSize(yyP221));
	S = CA; D = CA;
	WriteConstArray(ExprType(yyP220->ValRetypes.Expr),ValConstExpr(yyP220->ValRetypes.Expr),CA);
	RetypeConst(SS,S,DS,D);
      }
    
  }
   return CA;

  }
  }
  if (Tree_IsType (yyP220, kSpec)) {
/* line 1275 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1275 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Implementation restriction: Construct Not Supported", xxError, yyP220->Spec.Pos);
  }
   return NoConstArray;

  }
/* line 1276 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1276 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyWrite ("ConstArrayFromDecl-");
/* line 1276 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   WriteTreeNode (yyf, yyP220);
  }
   return NoConstArray;

}

static void FillConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP224, register tTree yyP223, tConstArray yyP222)
# else
(yyP224, yyP223, yyP222)
 register tTree yyP224;
 register tTree yyP223;
 tConstArray yyP222;
# endif
{
  if (Tree_IsType (yyP224, kUserDataTypes)) {
  if (yyP223->Kind == kAnExpr) {
  if (yyP223->AnExpr.Expr->Kind == kElementalExpr) {
/* line 1281 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1282 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

      int sz=CalcTypeSize(yyP224);
      memcpy(yyP222,yyP223->AnExpr.Expr->ElementalExpr.Elemental->Elemental.CA,sz);
      FillConstArray(yyP224,yyP223->AnExpr.Next,yyP222+sz);
    
  }
   return;

  }
  }
  }
  if (Tree_IsType (yyP224, kArray)) {
  if (yyP223->Kind == kAnExpr) {
  if (yyP223->AnExpr.Expr->Kind == kElementalExpr) {
/* line 1288 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1289 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

      int sz=CalcTypeSize(yyP224);
      memcpy(yyP222,yyP223->AnExpr.Expr->ElementalExpr.Elemental->Elemental.CA,sz);
      FillConstArray(yyP224,yyP223->AnExpr.Next,yyP222+sz);
    
  }
   return;

  }
  if (Tree_IsType (yyP223->AnExpr.Expr, kStringElement)) {
/* line 1295 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1296 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

      int sz=CalcTypeSize(yyP224);
      memcpy(yyP222,yyP223->AnExpr.Expr->StringElement.CA,sz);
      FillConstArray(yyP224,yyP223->AnExpr.Next,yyP222+sz);
    
  }
   return;

  }
  }
  }
  if (Tree_IsType (yyP224, kPrimitive)) {
  if (yyP223->Kind == kAnExpr) {
/* line 1303 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1304 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

      WriteConstArray(yyP224,ValConstExpr(yyP223->AnExpr.Expr),yyP222);
      FillConstArray(yyP224,yyP223->AnExpr.Next,yyP222+CalcTypeSize(yyP224));
    
  }
   return;

  }
  }
;
}

static void FillConstFields
# if defined __STDC__ | defined __cplusplus
(register tTree yyP228, register tTree yyP227, register tTree yyP226, tConstArray yyP225)
# else
(yyP228, yyP227, yyP226, yyP225)
 register tTree yyP228;
 register tTree yyP227;
 register tTree yyP226;
 tConstArray yyP225;
# endif
{
  if (yyP227->Kind == kAField) {
  if (Tree_IsType (yyP227->AField.Type, kUserDataTypes)) {
  if (yyP226->Kind == kAnExpr) {
  if (yyP226->AnExpr.Expr->Kind == kElementalExpr) {
/* line 1312 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1313 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

      memcpy(yyP225+CalcOffset(yyP228,yyP227),yyP226->AnExpr.Expr->ElementalExpr.Elemental->Elemental.CA,CalcTypeSize(yyP227->AField.Type));
      FillConstFields(yyP228,yyP227->AField.Next,yyP226->AnExpr.Next,yyP225);
    
  }
   return;

  }
  }
  }
  if (Tree_IsType (yyP227->AField.Type, kArray)) {
  if (yyP226->Kind == kAnExpr) {
  if (yyP226->AnExpr.Expr->Kind == kElementalExpr) {
/* line 1318 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1319 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

      memcpy(yyP225+CalcOffset(yyP228,yyP227),yyP226->AnExpr.Expr->ElementalExpr.Elemental->Elemental.CA,CalcTypeSize(yyP227->AField.Type));
      FillConstFields(yyP228,yyP227->AField.Next,yyP226->AnExpr.Next,yyP225);
    
  }
   return;

  }
  if (Tree_IsType (yyP226->AnExpr.Expr, kStringElement)) {
/* line 1324 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1325 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

      memcpy(yyP225+CalcOffset(yyP228,yyP227),yyP226->AnExpr.Expr->StringElement.CA,CalcTypeSize(yyP227->AField.Type));
      FillConstFields(yyP228,yyP227->AField.Next,yyP226->AnExpr.Next,yyP225);
    
  }
   return;

  }
  }
  }
  if (Tree_IsType (yyP227->AField.Type, kPrimitive)) {
  if (yyP226->Kind == kAnExpr) {
/* line 1331 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1332 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

      WriteConstArray(yyP227->AField.Type,ValConstExpr(yyP226->AnExpr.Expr),yyP225+CalcOffset(yyP228,yyP227));
      FillConstFields(yyP228,yyP227->AField.Next,yyP226->AnExpr.Next,yyP225);
    
  }
   return;

  }
  }
  }
;
}

tConstArray RangeConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP231, tConstArray yyP230, register int yyP229)
# else
(yyP231, yyP230, yyP229)
 register tTree yyP231;
 tConstArray yyP230;
 register int yyP229;
# endif
{
  if (Tree_IsType (yyP231, kArray)) {
/* line 1342 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1342 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP230 = yyP230 +  (yyP229*CalcTypeSize(yyP231->Array.Type));
/* line 1343 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */


    
  }
   return yyP230;

  }
 yyAbort ("RangeConstArray");
}

tConstArray SubscriptConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP235, tConstArray yyP234, register tTree yyP233, register tTree yyP232)
# else
(yyP235, yyP234, yyP233, yyP232)
 register tTree yyP235;
 tConstArray yyP234;
 register tTree yyP233;
 register tTree yyP232;
# endif
{
  if (Tree_IsType (yyP232, kUserDataTypes)) {
/* line 1351 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1352 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP234 = yyP234 + CalcOffset (yyP232, ExprFieldList (yyP233));
  }
   return yyP234;

  }
/* line 1354 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1355 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP234 = yyP234 + (ValConstInt (yyP233) * CalcTypeSize (yyP235));
/* line 1356 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

     
    
  }
   return yyP234;

}

static tConstArray GetConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree EX)
# else
(EX)
 register tTree EX;
# endif
{
  if (EX->Kind == kElementalExpr) {
/* line 1364 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1364 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (EX))))) goto yyL1;
  }
   return EX->ElementalExpr.Elemental -> Elemental . CA;
yyL1:;

  }
  if (Tree_IsType (EX, kStringElement)) {
/* line 1365 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1365 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (EX))))) goto yyL2;
  }
   return EX -> StringElement . CA;
yyL2:;

  }
/* line 1366 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1366 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Error in ExprConstArray()", xxFatal, EX->Expr.Pos);
  }
   return (tConstArray)NULL;

}

tValue ReadConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP237, tConstArray yyP236)
# else
(yyP237, yyP236)
 register tTree yyP237;
 tConstArray yyP236;
# endif
{
/* line 1370 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tValue V; 

  switch (yyP237->Kind) {
  case kByte:
  case kUserByte:
/* line 1372 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1372 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
V.Number = *((unsigned char *)yyP236); 
  }
   return V;

  case kBool:
  case kUserBool:
/* line 1373 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1373 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
V.Number = *((unsigned char *)yyP236); 
  }
   return V;

  case kInt:
  case kUserInt:
/* line 1375 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1375 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xx16bitINT)))) goto yyL3;
  {
/* line 1376 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
short v; memcpy(&v,yyP236,2); V.Number = v; 
  }
  }
   return V;
yyL3:;

/* line 1380 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1381 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
int v; memcpy(&v,yyP236,4); V.Number = v; 
  }
   return V;

  case kInt16:
  case kUserInt16:
/* line 1377 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1378 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
short v; memcpy(&v,yyP236,2); V.Number = v; 
  }
   return V;

  case kInt32:
  case kUserInt32:
/* line 1382 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1383 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
int v; memcpy(&v,yyP236,4); V.Number = v; 
  }
   return V;

  case kReal32:
  case kUserReal32:
/* line 1384 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1385 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
float v; memcpy(&v,yyP236,4); V.RNumber.n = v; V.RNumber.p = 7; 
  }
   return V;

  case kInt64:
  case kUserInt64:
/* line 1387 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1388 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
tInt v; memcpy(&v,yyP236,8); V.Number = v; 
  }
   return V;

  case kReal64:
  case kUserReal64:
/* line 1389 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1390 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
double v; memcpy(&v,yyP236,8); V.RNumber.n = v; V.RNumber.p = 14; 
  }
   return V;

  }

 yyAbort ("ReadConstArray");
}

void WriteConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP240, tValue yyP239, tConstArray yyP238)
# else
(yyP240, yyP239, yyP238)
 register tTree yyP240;
 tValue yyP239;
 tConstArray yyP238;
# endif
{

  switch (yyP240->Kind) {
  case kByte:
  case kUserByte:
/* line 1395 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1395 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
*((char *)yyP238) = yyP239.Number; 
  }
   return;

  case kBool:
  case kUserBool:
/* line 1396 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1396 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
*((char *)yyP238) = yyP239.Number; 
  }
   return;

  case kInt:
  case kUserInt:
/* line 1398 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1398 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xx16bitINT)))) goto yyL3;
  {
/* line 1399 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
short v = yyP239.Number; memcpy(yyP238,&v,2); 
  }
  }
   return;
yyL3:;

/* line 1403 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1404 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
int v = yyP239.Number; memcpy(yyP238,&v,4); 
  }
   return;

  case kInt16:
  case kUserInt16:
/* line 1400 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1401 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
short v = yyP239.Number; memcpy(yyP238,&v,2); 
  }
   return;

  case kInt32:
  case kUserInt32:
/* line 1405 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1406 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
int v = yyP239.Number; memcpy(yyP238,&v,4); 
  }
   return;

  case kReal32:
  case kUserReal32:
/* line 1407 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1408 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
float v = yyP239.RNumber.n; memcpy(yyP238,&v,4); 
  }
   return;

  case kInt64:
  case kUserInt64:
/* line 1410 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1411 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
tInt v = yyP239.Number; memcpy(yyP238,&v,8); 
  }
   return;

  case kReal64:
  case kUserReal64:
/* line 1412 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1413 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
double v = yyP239.RNumber.n; memcpy(yyP238,&v,8); 
  }
   return;

  }

;
}

static tConstArray NewConstArray
# if defined __STDC__ | defined __cplusplus
(register int yyP241)
# else
(yyP241)
 register int yyP241;
# endif
{
/* line 1417 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tConstArray CA; 
/* line 1419 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1420 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */

    if (!(CA = (tConstArray)malloc((yyP241==0)?1:yyP241))) Message("Out of heap allocating array",xxError,NoPosition);
  
  }
   return CA;

}

static void RangeCheckSubscript
# if defined __STDC__ | defined __cplusplus
(register tTree yyP243, register tTree yyP242)
# else
(yyP243, yyP242)
 register tTree yyP243;
 register tTree yyP242;
# endif
{
/* line 1428 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1428 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP243)))) goto yyL1;
  {
/* line 1428 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP242)))) goto yyL1;
  {
/* line 1428 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP243) >= 0))) goto yyL1;
  {
/* line 1428 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP243) < ValConstInt (yyP242)))) goto yyL1;
  }
  }
  }
  }
   return;
yyL1:;

/* line 1429 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1429 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP243)))) goto yyL2;
  {
/* line 1429 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP242)))) goto yyL2;
  {
/* line 1429 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Subscript out of range", xxError, yyP243->Expr.Pos);
  }
  }
  }
   return;
yyL2:;

/* line 1430 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1430 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP243)))) goto yyL3;
  {
/* line 1430 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP243) >= 0))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 1431 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1431 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP243)))) goto yyL4;
  {
/* line 1431 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Subscript out of range", xxError, yyP243->Expr.Pos);
  }
  }
   return;
yyL4:;

/* line 1432 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

;
}

static void RangeCheckSlice
# if defined __STDC__ | defined __cplusplus
(register tTree yyP246, register tTree yyP245, register tTree yyP244)
# else
(yyP246, yyP245, yyP244)
 register tTree yyP246;
 register tTree yyP245;
 register tTree yyP244;
# endif
{
/* line 1436 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1436 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP246)))) goto yyL1;
  {
/* line 1436 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP245)))) goto yyL1;
  {
/* line 1436 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP244)))) goto yyL1;
  {
/* line 1437 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP246) >= 0))) goto yyL1;
  {
/* line 1437 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP245) >= 0))) goto yyL1;
  {
/* line 1437 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (((ValConstInt (yyP246) + ValConstInt (yyP245)) <= ValConstInt (yyP244)))) goto yyL1;
  }
  }
  }
  }
  }
  }
   return;
yyL1:;

/* line 1438 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1438 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP246)))) goto yyL2;
  {
/* line 1438 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP245)))) goto yyL2;
  {
/* line 1438 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP244)))) goto yyL2;
  {
/* line 1439 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Array slice exceeds array bounds", xxError, yyP246->Expr.Pos);
  }
  }
  }
  }
   return;
yyL2:;

/* line 1440 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1440 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   RangeCheckSubscript (yyP246, yyP244);
  }
   return;

;
}

tTree MakeConstInt
# if defined __STDC__ | defined __cplusplus
(register int yyP248, register tPosition yyP247)
# else
(yyP248, yyP247)
 register int yyP248;
 register tPosition yyP247;
# endif
{
/* line 1445 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tTree T; tValue TMP; 
/* line 1446 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1446 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   TMP . Number = yyP248;
/* line 1446 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   T = mConst (yyP247, TMP, mInt ());
/* line 1446 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   ExprType (T) = mInt ();
/* line 1446 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   ConstFlag (T -> Expr) = true;
/* line 1446 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   ValConstInt (T) = yyP248;
  }
   return T;

}

static tTree MakeAddExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP250, register tTree yyP249)
# else
(yyP250, yyP249)
 register tTree yyP250;
 register tTree yyP249;
# endif
{
/* line 1449 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tTree T; 
/* line 1450 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1450 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP250)))) goto yyL1;
  {
/* line 1450 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP249)))) goto yyL1;
  {
/* line 1450 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   T = mBinary (yyP250->Expr.Pos, yyP250, yyP249, mAdd ());
/* line 1450 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   ExprType (T) = ExprType (yyP250);
/* line 1450 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   ConstFlag (T -> Expr) = true;
/* line 1450 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   ValConstInt (T) = ValConstInt (yyP250) + ValConstInt (yyP249);
  }
  }
  }
   return T;
yyL1:;

/* line 1451 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1451 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   T = mBinary (yyP250->Expr.Pos, yyP250, yyP249, mAdd ());
/* line 1451 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   ExprType (T) = ExprType (yyP250);
/* line 1451 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   ConstFlag (T -> Expr) = false;
  }
   return T;

}

static int CountList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP252, register tTree yyP251)
# else
(yyP252, yyP251)
 register tTree yyP252;
 register tTree yyP251;
# endif
{
  if (yyP252->Kind == kAnExpr) {
/* line 1456 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1456 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SameType (yyP251, ExprType (yyP252->AnExpr.Expr)))) goto yyL1;
  }
   return CountList (yyP252->AnExpr.Next, yyP251) + 1;
yyL1:;

/* line 1458 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1458 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Type mismatch in expression list", xxError, yyP252->AnExpr.Expr->Expr.Pos);
  }
   return CountList (yyP252->AnExpr.Next, yyP251) + 1;

  }
  if (yyP252->Kind == kNoExpr) {
/* line 1457 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 1;

  }
 yyAbort ("CountList");
}

int CountExprs
# if defined __STDC__ | defined __cplusplus
(register tTree yyP253)
# else
(yyP253)
 register tTree yyP253;
# endif
{
  if (yyP253->Kind == kAnExpr) {
/* line 1462 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return CountExprs (yyP253->AnExpr.Next) + 1;

  }
  if (yyP253->Kind == kNoExpr) {
/* line 1463 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 0;

  }
 yyAbort ("CountExprs");
}

static int SizeType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP256, register tPosition yyP255, register bool yyP254, register tTree * yyP257)
# else
(yyP256, yyP255, yyP254, yyP257)
 register tTree yyP256;
 register tPosition yyP255;
 register bool yyP254;
 register tTree * yyP257;
# endif
{
/* line 1467 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 int V; 

  switch (yyP256->Kind) {
  case kArray:
  case kUserArray:
  if (yyP256->Array.Expr->Kind == kUnBound) {
 {
  tTree yyV1;
  if (equalbool (yyP254, true)) {
/* line 1468 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1469 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   V = SizeType (yyP256->Array.Type, yyP255, true, & yyV1);
/* line 1470 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 if (yyV1!=NoTree) Message("Too many unspecified dimensions to retype",xxError,yyP255); 
  }
   * yyP257 = yyP256;
  {
   return V;
  }

  }
 }
  }
/* line 1472 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  tTree yyV1;
  {
/* line 1472 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP256->Array.Expr)))) goto yyL2;
  {
/* line 1472 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (SizeType (yyP256->Array.Type, yyP255, yyP254, & yyV1))) goto yyL2;
  }
  }
   * yyP257 = yyV1;
  {
   return - 1;
  }
 }
yyL2:;

/* line 1473 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  tTree yyV1;
  {
/* line 1473 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   V = SizeType (yyP256->Array.Type, yyP255, yyP254, & yyV1);
  }
   * yyP257 = yyV1;
  {
   return (V<0)?V:V*ValConstInt(yyP256->Array.Expr);
  }
 }

  case kInt:
  case kUserInt:
/* line 1474 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   * yyP257 = NULL;
   return IS_Mode(xx16bitINT) ? 2 : 4 ;

  case kInt16:
  case kUserInt16:
/* line 1475 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   * yyP257 = NULL;
   return 2;

  case kInt32:
  case kUserInt32:
/* line 1476 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   * yyP257 = NULL;
   return 4;

  case kInt64:
  case kUserInt64:
/* line 1477 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   * yyP257 = NULL;
   return 8;

  case kReal32:
  case kUserReal32:
/* line 1478 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   * yyP257 = NULL;
   return 4;

  case kReal64:
  case kUserReal64:
/* line 1479 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   * yyP257 = NULL;
   return 8;

  case kBool:
  case kUserBool:
/* line 1480 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   * yyP257 = NULL;
   return 1;

  case kByte:
  case kUserByte:
/* line 1481 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   * yyP257 = NULL;
   return 1;

  case kChan:
/* line 1482 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   * yyP257 = NULL;
   return sizeof(void*);

  case kUserRecord:
/* line 1483 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   * yyP257 = NULL;
   return CalcRecordSize (yyP256->UserRecord.FieldList, 0);

  }

/* line 1484 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1484 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Cannot perform retype involving this base type", xxError, yyP255);
  }
   * yyP257 = NULL;
   return - 1;

}

static int AlignToNext
# if defined __STDC__ | defined __cplusplus
(register int yyP259, register int yyP258)
# else
(yyP259, yyP258)
 register int yyP259;
 register int yyP258;
# endif
{
/* line 1488 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return ((yyP259 + (yyP258 - 1)) / yyP258) * yyP258;

}

static int CalcRecordSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP261, register int yyP260)
# else
(yyP261, yyP260)
 register tTree yyP261;
 register int yyP260;
# endif
{
/* line 1492 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 int BTS; 
  if (yyP261->Kind == kNoField) {
/* line 1493 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return AlignToNext (yyP260, USER_ALIGNMENT);

  }
  if (yyP261->Kind == kAField) {
  if (Tree_IsType (yyP261->AField.Type, kPrimitive)) {
/* line 1494 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1494 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   BTS = CalcTypeSize (yyP261->AField.Type);
  }
   return CalcRecordSize (yyP261->AField.Next, AlignToNext (yyP260, BTS) + BTS);

  }
/* line 1495 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return CalcRecordSize (yyP261->AField.Next, AlignToNext (yyP260, USER_ALIGNMENT) + CalcTypeSize (yyP261->AField.Type));

  }
 yyAbort ("CalcRecordSize");
}

static int CalcPackedRecordSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP263, register int yyP262)
# else
(yyP263, yyP262)
 register tTree yyP263;
 register int yyP262;
# endif
{
/* line 1499 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 int BTS; 
  if (yyP263->Kind == kNoField) {
/* line 1500 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP262;

  }
  if (yyP263->Kind == kAField) {
/* line 1501 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return CalcPackedRecordSize (yyP263->AField.Next, yyP262 + CalcTypeSize (yyP263->AField.Type));

  }
 yyAbort ("CalcPackedRecordSize");
}

static int CalcRecordOffset
# if defined __STDC__ | defined __cplusplus
(register tTree yyP266, register tTree yyP265, register int yyP264)
# else
(yyP266, yyP265, yyP264)
 register tTree yyP266;
 register tTree yyP265;
 register int yyP264;
# endif
{
/* line 1505 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 int BTS; 
  if (yyP266->Kind == kAField) {
  if (Tree_IsType (yyP266->AField.Type, kPrimitive)) {
  if (yyP265->Kind == kAField) {
/* line 1506 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1506 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP266->AField.Sym == yyP265->AField.Sym))) goto yyL1;
  }
   return AlignToNext (yyP264, CalcTypeSize (yyP266->AField.Type));
yyL1:;

  }
/* line 1508 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1508 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   BTS = CalcTypeSize (yyP266->AField.Type);
  }
   return CalcRecordOffset (yyP266->AField.Next, yyP265, AlignToNext (yyP264, BTS) + BTS);

  }
  if (yyP265->Kind == kAField) {
/* line 1507 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1507 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP266->AField.Sym == yyP265->AField.Sym))) goto yyL2;
  }
   return AlignToNext (yyP264, USER_ALIGNMENT);
yyL2:;

  }
/* line 1509 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return CalcRecordOffset (yyP266->AField.Next, yyP265, AlignToNext (yyP264, USER_ALIGNMENT) + CalcTypeSize (yyP266->AField.Type));

  }
 yyAbort ("CalcRecordOffset");
}

static int CalcPackedRecordOffset
# if defined __STDC__ | defined __cplusplus
(register tTree yyP269, register tTree yyP268, register int yyP267)
# else
(yyP269, yyP268, yyP267)
 register tTree yyP269;
 register tTree yyP268;
 register int yyP267;
# endif
{
/* line 1513 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 int BTS; 
  if (yyP269->Kind == kAField) {
  if (yyP268->Kind == kAField) {
/* line 1514 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1514 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP269->AField.Sym == yyP268->AField.Sym))) goto yyL1;
  }
   return yyP267;
yyL1:;

  }
/* line 1515 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return CalcPackedRecordOffset (yyP269->AField.Next, yyP268, yyP267 + CalcTypeSize (yyP269->AField.Type));

  }
 yyAbort ("CalcPackedRecordOffset");
}

int CalcOffset
# if defined __STDC__ | defined __cplusplus
(register tTree yyP271, register tTree yyP270)
# else
(yyP271, yyP270)
 register tTree yyP271;
 register tTree yyP270;
# endif
{
  if (yyP271->Kind == kUserRecord) {
/* line 1519 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return CalcRecordOffset (yyP271->UserRecord.FieldList, yyP270, 0);

  }
  if (yyP271->Kind == kUserPackedRecord) {
/* line 1520 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return CalcPackedRecordOffset (yyP271->UserPackedRecord.FieldList, yyP270, 0);

  }
 yyAbort ("CalcOffset");
}

int CalcTypeSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP272)
# else
(yyP272)
 register tTree yyP272;
# endif
{

  switch (yyP272->Kind) {
  case kArray:
  case kUserArray:
/* line 1524 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1524 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP272->Array.Expr)))) goto yyL1;
  }
   return  ValConstInt(yyP272->Array.Expr) * CalcTypeSize(yyP272->Array.Type) ;
yyL1:;

  break;
  case kUserRecord:
/* line 1525 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return CalcRecordSize (yyP272->UserRecord.FieldList, 0);

  case kUserPackedRecord:
/* line 1526 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return CalcPackedRecordSize (yyP272->UserPackedRecord.FieldList, 0);

  case kInt:
  case kUserInt:
/* line 1527 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return IS_Mode(xx16bitINT) ? 2 : 4 ;

  case kInt16:
  case kUserInt16:
/* line 1528 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 2;

  case kInt32:
  case kUserInt32:
/* line 1529 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 4;

  case kInt64:
  case kUserInt64:
/* line 1530 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 8;

  case kReal32:
  case kUserReal32:
/* line 1531 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 4;

  case kReal64:
  case kUserReal64:
/* line 1532 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 8;

  case kBool:
  case kUserBool:
/* line 1533 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 1;

  case kByte:
  case kUserByte:
/* line 1534 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return 1;

  }

/* line 1535 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1535 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Internal Error - ConstArray Evaluation", xxError, NoPosition);
  }
   return - 1;

}

tTree ReduceElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP274, register tTree yyP273)
# else
(yyP274, yyP273)
 register tTree yyP274;
 register tTree yyP273;
# endif
{
  if (Tree_IsType (yyP274, kIdentifier)) {
/* line 1543 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP274;

  }
  if (yyP274->Kind == kRange) {
  if (yyP273 == NULL) {
/* line 1544 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1544 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP274->Range.Next = ReduceElement (yyP274->Range.Next, yyP274);
  }
   return yyP274;

  }
  if (yyP273->Kind == kRange) {
/* line 1545 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1545 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP273->Range.From = MakeAddExpr (yyP273->Range.From, yyP274->Range.From);
  }
   return ReduceElement (yyP274->Range.Next, yyP273);

  }
  if (yyP273->Kind == kSubscript) {
/* line 1546 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1546 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP273->Subscript.Expr = MakeAddExpr (yyP273->Subscript.Expr, yyP274->Range.From);
  }
   return ReduceElement (yyP274->Range.Next, yyP273);

  }
  }
  if (yyP274->Kind == kSubscript) {
/* line 1547 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1547 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP274->Subscript.Next = ReduceElement (yyP274->Subscript.Next, yyP274);
  }
   return yyP274;

  }
 yyAbort ("ReduceElement");
}

tTree ReduceElemental
# if defined __STDC__ | defined __cplusplus
(register tTree yyP275)
# else
(yyP275)
 register tTree yyP275;
# endif
{
  if (Tree_IsType (yyP275, kElement)) {
/* line 1552 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return ReduceElement (yyP275, NoTree);

  }
  if (Tree_IsType (yyP275, kTableElement)) {
/* line 1554 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP275;

  }
 yyAbort ("ReduceElemental");
}

static tTree SplatSymbolTableFormals
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP280, register tTree yyP279, tSymbol yyP278, register int yyP277, register tTree yyP276)
# else
(yyP280, yyP279, yyP278, yyP277, yyP276)
 register tPosition yyP280;
 register tTree yyP279;
 tSymbol yyP278;
 register int yyP277;
 register tTree yyP276;
# endif
{
  if (yyP279->Kind == kAnExpr) {
/* line 1558 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1559 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP277 == SymbolDepth (yyP278)))) goto yyL1;
  {
/* line 1560 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP278), kAFormal)))) goto yyL1;
  {
/* line 1561 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP278) -> AFormal . By, kByVal)))) goto yyL1;
  {
/* line 1562 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP278) = mVal (yyP279->AnExpr.Expr->Expr.Pos, CopyTree (SymbolType (yyP278)), yyP278, yyP279->AnExpr.Expr);
  }
  }
  }
  }
   return SplatSymbolTableFormals (yyP280, yyP279->AnExpr.Next, yyP278 + 1, yyP277, mASpec (SymbolKind (yyP278), yyP276));
yyL1:;

  if (yyP279->AnExpr.Expr->Kind == kElementalExpr) {
/* line 1564 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1565 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP277 == SymbolDepth (yyP278)))) goto yyL2;
  {
/* line 1566 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP278), kAFormal)))) goto yyL2;
  {
/* line 1567 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP278) -> AFormal . By, kByRef)))) goto yyL2;
  {
/* line 1568 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP278) = mIs (yyP279->AnExpr.Expr->ElementalExpr.Elemental->Elemental.Pos, CopyTree (SymbolType (yyP278)), yyP278, yyP279->AnExpr.Expr->ElementalExpr.Elemental);
  }
  }
  }
  }
   return SplatSymbolTableFormals (yyP280, yyP279->AnExpr.Next, yyP278 + 1, yyP277, mASpec (SymbolKind (yyP278), yyP276));
yyL2:;

  }
/* line 1570 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1571 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP277 == SymbolDepth (yyP278)))) goto yyL3;
  {
/* line 1572 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP278), kAFormal)))) goto yyL3;
  {
/* line 1573 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Expected pass by reference argument", xxError, yyP280);
  }
  }
  }
   return yyP276;
yyL3:;

/* line 1575 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1576 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too many arguments to inline function", xxError, yyP280);
  }
   return yyP276;

  }
  if (yyP279->Kind == kNoExpr) {
/* line 1578 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1579 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP277 == SymbolDepth (yyP278)))) goto yyL5;
  {
/* line 1580 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP278), kAFormal)))) goto yyL5;
  {
/* line 1581 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   Message ("Too few arguments to inline function", xxError, yyP280);
  }
  }
  }
   return yyP276;
yyL5:;

/* line 1583 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP276;

  }
 yyAbort ("SplatSymbolTableFormals");
}

static tTree AppendSpecList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP282, register tTree yyP281)
# else
(yyP282, yyP281)
 register tTree yyP282;
 register tTree yyP281;
# endif
{
  if (yyP282->Kind == kASpec) {
/* line 1588 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1589 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP282->ASpec.Next = AppendSpecList (yyP282->ASpec.Next, yyP281);
  }
   return yyP282;

  }
  if (yyP282->Kind == kNoSpec) {
/* line 1591 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP281;

  }
 yyAbort ("AppendSpecList");
}

static void UpdateFuncSymbol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP283)
# else
(yyP283)
 register tTree yyP283;
# endif
{

  switch (yyP283->Kind) {
  case kParRep:
/* line 1596 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1596 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> ParRep . Sym >= FirstFormal))) goto yyL1;
  {
/* line 1596 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> ParRep . Sym < FunctionInlining))) goto yyL1;
  {
/* line 1597 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283 -> ParRep . Sym = yyP283 -> ParRep . Sym + (FirstActual - FirstFormal);
/* line 1598 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283 -> ParRep . Sym) = yyP283;
  }
  }
  }
   return;
yyL1:;

  break;
  case kAProcess:
/* line 1600 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1600 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> AProcess . Sym >= FirstFormal))) goto yyL2;
  {
/* line 1600 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> AProcess . Sym < FunctionInlining))) goto yyL2;
  {
/* line 1601 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283 -> AProcess . Sym = yyP283 -> AProcess . Sym + (FirstActual - FirstFormal);
/* line 1602 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283 -> AProcess . Sym) = yyP283;
  }
  }
  }
   return;
yyL2:;

  break;
  case kValof:
/* line 1604 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1604 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> Valof . Sym >= FirstFormal))) goto yyL3;
  {
/* line 1604 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> Valof . Sym < FunctionInlining))) goto yyL3;
  {
/* line 1605 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283 -> Valof . Sym = yyP283 -> Valof . Sym + (FirstActual - FirstFormal);
/* line 1606 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283 -> Valof . Sym) = yyP283;
  }
  }
  }
   return;
yyL3:;

  break;
  case kTable:
  case kUserLiteral:
/* line 1608 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1608 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> Table . Sym >= FirstFormal))) goto yyL4;
  {
/* line 1608 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> Table . Sym < FunctionInlining))) goto yyL4;
  {
/* line 1609 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283 -> Table . Sym = yyP283 -> Table . Sym + (FirstActual - FirstFormal);
/* line 1610 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283 -> Table . Sym) = yyP283;
  }
  }
  }
   return;
yyL4:;

  break;
  case kString:
/* line 1612 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1612 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> String . Sym >= FirstFormal))) goto yyL5;
  {
/* line 1612 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> String . Sym < FunctionInlining))) goto yyL5;
  {
/* line 1613 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283 -> String . Sym = yyP283 -> String . Sym + (FirstActual - FirstFormal);
/* line 1614 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283 -> String . Sym) = yyP283;
  }
  }
  }
   return;
yyL5:;

  break;
  case kCCode:
/* line 1616 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1616 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> CCode . Scope >= FirstFormal))) goto yyL6;
  {
/* line 1616 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> CCode . Scope < FunctionInlining))) goto yyL6;
  {
/* line 1617 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283 -> CCode . Scope = yyP283 -> CCode . Scope + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL6:;

  break;
  case kHCode:
/* line 1619 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1619 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> HCode . Scope >= FirstFormal))) goto yyL7;
  {
/* line 1619 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> HCode . Scope < FunctionInlining))) goto yyL7;
  {
/* line 1620 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283 -> HCode . Scope = yyP283 -> HCode . Scope + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL7:;

  break;
  case kIdentifier:
  case kUnmappedIdentifier:
/* line 1622 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1622 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> Identifier . Scope >= FirstFormal))) goto yyL8;
  {
/* line 1622 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283 -> Identifier . Scope < FunctionInlining))) goto yyL8;
  {
/* line 1623 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283 -> Identifier . Scope = yyP283 -> Identifier . Scope + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL8:;

  break;
  case kIs:
/* line 1625 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1625 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->Is.Sym >= FirstFormal))) goto yyL9;
  {
/* line 1625 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->Is.Sym < FunctionInlining))) goto yyL9;
  {
/* line 1626 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->Is.Sym = yyP283->Is.Sym + (FirstActual - FirstFormal);
/* line 1627 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283->Is.Sym) = yyP283;
/* line 1628 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolType (yyP283->Is.Sym) = yyP283->Is.Type;
  }
  }
  }
   return;
yyL9:;

  break;
  case kAVal:
  case kVal:
  case kValRetypes:
  case kValReshapes:
/* line 1630 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1630 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->AVal.Sym >= FirstFormal))) goto yyL10;
  {
/* line 1630 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->AVal.Sym < FunctionInlining))) goto yyL10;
  {
/* line 1631 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->AVal.Sym = yyP283->AVal.Sym + (FirstActual - FirstFormal);
/* line 1632 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283->AVal.Sym) = yyP283;
/* line 1633 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolType (yyP283->AVal.Sym) = yyP283->AVal.Type;
  }
  }
  }
   return;
yyL10:;

  break;
  case kRetypes:
  case kReshapes:
/* line 1635 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1635 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->Retypes.Sym >= FirstFormal))) goto yyL11;
  {
/* line 1635 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->Retypes.Sym < FunctionInlining))) goto yyL11;
  {
/* line 1636 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->Retypes.Sym = yyP283->Retypes.Sym + (FirstActual - FirstFormal);
/* line 1637 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283->Retypes.Sym) = yyP283;
/* line 1638 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolType (yyP283->Retypes.Sym) = yyP283->Retypes.Type;
  }
  }
  }
   return;
yyL11:;

  break;
  case kDefSeqPro:
/* line 1640 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1640 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->DefSeqPro.Sym >= FirstFormal))) goto yyL12;
  {
/* line 1640 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->DefSeqPro.Sym < FunctionInlining))) goto yyL12;
  {
/* line 1641 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->DefSeqPro.Sym = yyP283->DefSeqPro.Sym + (FirstActual - FirstFormal);
/* line 1642 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283->DefSeqPro.Sym) = yyP283;
  }
  }
  }
   return;
yyL12:;

  break;
  case kDefTagPro:
/* line 1644 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1644 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->DefTagPro.Sym >= FirstFormal))) goto yyL13;
  {
/* line 1644 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->DefTagPro.Sym < FunctionInlining))) goto yyL13;
  {
/* line 1645 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->DefTagPro.Sym = yyP283->DefTagPro.Sym + (FirstActual - FirstFormal);
/* line 1646 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283->DefTagPro.Sym) = yyP283;
  }
  }
  }
   return;
yyL13:;

  break;
  case kDefAProc:
  case kDefProc:
  case kInlineDefProc:
  case kPrototypeProc:
/* line 1648 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1648 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->DefAProc.Sym >= FirstFormal))) goto yyL14;
  {
/* line 1648 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->DefAProc.Sym < FunctionInlining))) goto yyL14;
  {
/* line 1649 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->DefAProc.Sym = yyP283->DefAProc.Sym + (FirstActual - FirstFormal);
/* line 1650 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283->DefAProc.Sym) = yyP283;
  }
  }
  }
   return;
yyL14:;

  break;
  case kDefAFunc:
  case kDefFunc:
  case kInlineDefFunc:
  case kDefIsFunc:
  case kInlineDefIsFunc:
  case kPrototypeFunc:
/* line 1652 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1652 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->DefAFunc.Sym >= FirstFormal))) goto yyL15;
  {
/* line 1652 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->DefAFunc.Sym < FunctionInlining))) goto yyL15;
  {
/* line 1653 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->DefAFunc.Sym = yyP283->DefAFunc.Sym + (FirstActual - FirstFormal);
/* line 1654 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283->DefAFunc.Sym) = yyP283;
/* line 1655 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolType (yyP283->DefAFunc.Sym) = yyP283->DefAFunc.TypeList;
  }
  }
  }
   return;
yyL15:;

  break;
  case kAFormal:
/* line 1657 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1657 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->AFormal.Sym >= FirstFormal))) goto yyL16;
  {
/* line 1657 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->AFormal.Sym < FunctionInlining))) goto yyL16;
  {
/* line 1658 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->AFormal.Sym = yyP283->AFormal.Sym + (FirstActual - FirstFormal);
/* line 1659 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283->AFormal.Sym) = yyP283;
  }
  }
  }
   return;
yyL16:;

  break;
  case kReplicator:
/* line 1661 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1661 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->Replicator.Sym >= FirstFormal))) goto yyL17;
  {
/* line 1661 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->Replicator.Sym < FunctionInlining))) goto yyL17;
  {
/* line 1662 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->Replicator.Sym = yyP283->Replicator.Sym + (FirstActual - FirstFormal);
/* line 1663 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283->Replicator.Sym) = yyP283;
/* line 1664 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolType (yyP283->Replicator.Sym) = mInt ();
  }
  }
  }
   return;
yyL17:;

  break;
  case kATagPro:
/* line 1666 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1666 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->ATagPro.Sym >= FirstFormal))) goto yyL18;
  {
/* line 1666 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->ATagPro.Sym < FunctionInlining))) goto yyL18;
  {
/* line 1667 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->ATagPro.Sym = yyP283->ATagPro.Sym + (FirstActual - FirstFormal);
/* line 1668 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283->ATagPro.Sym) = yyP283;
  }
  }
  }
   return;
yyL18:;

  break;
  case kAnId:
/* line 1670 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1670 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->AnId.Sym >= FirstFormal))) goto yyL19;
  {
/* line 1670 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->AnId.Sym < FunctionInlining))) goto yyL19;
  {
/* line 1671 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->AnId.Sym = yyP283->AnId.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL19:;

  break;
  case kUserArray:
/* line 1673 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1673 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserArray.Sym >= FirstFormal))) goto yyL20;
  {
/* line 1673 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserArray.Sym < FunctionInlining))) goto yyL20;
  {
/* line 1674 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->UserArray.Sym = yyP283->UserArray.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL20:;

  break;
  case kUserInt:
/* line 1676 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1676 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserInt.Sym >= FirstFormal))) goto yyL21;
  {
/* line 1676 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserInt.Sym < FunctionInlining))) goto yyL21;
  {
/* line 1677 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->UserInt.Sym = yyP283->UserInt.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL21:;

  break;
  case kUserInt16:
/* line 1679 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1679 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserInt16.Sym >= FirstFormal))) goto yyL22;
  {
/* line 1679 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserInt16.Sym < FunctionInlining))) goto yyL22;
  {
/* line 1680 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->UserInt16.Sym = yyP283->UserInt16.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL22:;

  break;
  case kUserInt32:
/* line 1682 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1682 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserInt32.Sym >= FirstFormal))) goto yyL23;
  {
/* line 1682 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserInt32.Sym < FunctionInlining))) goto yyL23;
  {
/* line 1683 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->UserInt32.Sym = yyP283->UserInt32.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL23:;

  break;
  case kUserInt64:
/* line 1685 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1685 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserInt64.Sym >= FirstFormal))) goto yyL24;
  {
/* line 1685 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserInt64.Sym < FunctionInlining))) goto yyL24;
  {
/* line 1686 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->UserInt64.Sym = yyP283->UserInt64.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL24:;

  break;
  case kUserReal32:
/* line 1688 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1688 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserReal32.Sym >= FirstFormal))) goto yyL25;
  {
/* line 1688 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserReal32.Sym < FunctionInlining))) goto yyL25;
  {
/* line 1689 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->UserReal32.Sym = yyP283->UserReal32.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL25:;

  break;
  case kUserReal64:
/* line 1691 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1691 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserReal64.Sym >= FirstFormal))) goto yyL26;
  {
/* line 1691 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserReal64.Sym < FunctionInlining))) goto yyL26;
  {
/* line 1692 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->UserReal64.Sym = yyP283->UserReal64.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL26:;

  break;
  case kUserByte:
/* line 1694 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1694 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserByte.Sym >= FirstFormal))) goto yyL27;
  {
/* line 1694 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserByte.Sym < FunctionInlining))) goto yyL27;
  {
/* line 1695 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->UserByte.Sym = yyP283->UserByte.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL27:;

  break;
  case kUserBool:
/* line 1697 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1697 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserBool.Sym >= FirstFormal))) goto yyL28;
  {
/* line 1697 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserBool.Sym < FunctionInlining))) goto yyL28;
  {
/* line 1698 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->UserBool.Sym = yyP283->UserBool.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL28:;

  break;
  case kUserStructTypes:
  case kUserDataTypes:
  case kUserRecord:
  case kUserPackedRecord:
  case kUserUnion:
  case kUserChanRecord:
/* line 1700 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1700 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserStructTypes.Sym >= FirstFormal))) goto yyL29;
  {
/* line 1700 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->UserStructTypes.Sym < FunctionInlining))) goto yyL29;
  {
/* line 1701 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->UserStructTypes.Sym = yyP283->UserStructTypes.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL29:;

  break;
  case kAField:
/* line 1703 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1703 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->AField.Sym >= FirstFormal))) goto yyL30;
  {
/* line 1703 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->AField.Sym < FunctionInlining))) goto yyL30;
  {
/* line 1704 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->AField.Sym = yyP283->AField.Sym + (FirstActual - FirstFormal);
/* line 1705 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (yyP283->AField.Sym) = yyP283;
/* line 1706 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolType (yyP283->AField.Sym) = yyP283->AField.Type;
  }
  }
  }
   return;
yyL30:;

  break;
  case kNamed:
/* line 1708 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1708 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->Named.Sym >= FirstFormal))) goto yyL31;
  {
/* line 1708 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->Named.Sym < FunctionInlining))) goto yyL31;
  {
/* line 1709 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->Named.Sym = yyP283->Named.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL31:;

  break;
  case kFuncCall:
/* line 1711 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1711 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->FuncCall.Sym >= FirstFormal))) goto yyL32;
  {
/* line 1711 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->FuncCall.Sym < FunctionInlining))) goto yyL32;
  {
/* line 1712 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->FuncCall.Sym = yyP283->FuncCall.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL32:;

  break;
  case kInstance:
/* line 1714 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1714 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->Instance.Sym >= FirstFormal))) goto yyL33;
  {
/* line 1714 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP283->Instance.Sym < FunctionInlining))) goto yyL33;
  {
/* line 1715 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283 -> Instance . Scope = yyP283 -> Instance . Scope + (FirstActual - FirstFormal);
/* line 1716 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyP283->Instance.Sym = yyP283->Instance.Sym + (FirstActual - FirstFormal);
  }
  }
  }
   return;
yyL33:;

  break;
  }

/* line 1718 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

;
}

static tTree CopyFuncBody
# if defined __STDC__ | defined __cplusplus
(register tTree yyP287, register tTree yyP286, register int yyP285, tSymbol yyP284)
# else
(yyP287, yyP286, yyP285, yyP284)
 register tTree yyP287;
 register tTree yyP286;
 register int yyP285;
 tSymbol yyP284;
# endif
{
/* line 1722 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tTree NODE; 
  if (yyP287->Kind == kInlineDefFunc) {
/* line 1723 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1724 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   NODE = CopyTree (yyP287->InlineDefFunc.Valof);
/* line 1725 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   NODE -> Valof . SpecList = AppendSpecList (yyP286, NODE -> Valof . SpecList);
/* line 1726 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   NODE -> Valof . VS = yyP285;
/* line 1727 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   NODE -> Valof . Sym = yyP284;
  }
   return NODE;

  }
  if (Tree_IsType (yyP287, kDefIsFunc)) {
/* line 1729 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  register tTree yyV1;
  {
/* line 1730 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kSkip)
    yyV1->Skip.Pos = yyP287->DefIsFunc.Pos;
   {register tTree yyW1;
    yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyW1,kNoSpec)
    yyV1->Skip.SpecList = yyW1;
   }
   NODE = mValof (yyP287->DefIsFunc.Pos, yyP286, yyV1, CopyTree (yyP287->DefIsFunc.ExprList), yyP284, yyP285);
  }
  {
   return NODE;
  }
 }

  }
 yyAbort ("CopyFuncBody");
}

static bool WithinScope
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP289, tSymbol yyP288)
# else
(yyP289, yyP288)
 tSymbol yyP289;
 tSymbol yyP288;
# endif
{
/* line 1735 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1735 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP289 > yyP288))) goto yyL1;
  {
/* line 1735 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((SymbolScope (yyP289) == yyP288))) goto yyL1;
  }
  }
   return true;
yyL1:;

/* line 1736 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1736 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP289 > yyP288))) goto yyL2;
  {
/* line 1736 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (WithinScope (SymbolScope (yyP289), yyP288))) goto yyL2;
  }
  }
   return true;
yyL2:;

  return false;
}

tTree CreateFuncCall
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP293, tSymbol yyP292, register tTree yyP291, tInt yyP290)
# else
(yyP293, yyP292, yyP291, yyP290)
 register tPosition yyP293;
 tSymbol yyP292;
 register tTree yyP291;
 tInt yyP290;
# endif
{
/* line 1740 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tTree NODE; tSymbol NS; 
/* line 1742 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1742 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((IsSTVFunction (SymbolKind (yyP292))))) goto yyL1;
  {
/* line 1743 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   NS = AddSymbol (NoIdent);
/* line 1744 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   NODE = mElementalExpr (yyP293, mTableExpr (yyP293, mFuncCall (yyP293, yyP292, yyP291, yyP290), NS));
/* line 1745 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   SymbolKind (NS) = NODE;
  }
  }
   return NODE;
yyL1:;

/* line 1748 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1748 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP292), kInlineDefFunc) || Tree_IsType (SymbolKind (yyP292), kDefIsFunc)))) goto yyL2;
  {
/* line 1749 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   OpenAtScope (SymbolScope (yyP292));
/* line 1750 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
{
      int depth = SymbolDepth(yyP292)+1;
      int i;
      tTree formals = SymbolKind(yyP292)->InlineDefFunc.Formals;
      if (Tree_IsType(formals,kNoFormals))         
	FirstFormal = formals->NoFormals.Sym;
      else if (Tree_IsType(formals,kNoFormal))
	Message("Internal failure- couldn't find start of formal list",xxFatal,yyP293);
      else
	FirstFormal = formals->AFormal.Sym;
      FunctionInlining = yyP292;
      FirstActual = FunctionInlining;
      i = FirstFormal;
      while (i<yyP292) 
      {
	while (depth<SymbolDepth(i)) { OpenScope(); depth++; }
	while (depth>SymbolDepth(i)) { CloseScope(); depth--; }
	{
	  tSymbol tmp=AddSymbol(Symbol(i).Id);
	  if (FirstActual==FunctionInlining) FirstActual = tmp;
	  SymbolType(tmp) = SymbolType(i);
	  SymbolKind(tmp) = SymbolKind(i);
	}
	i++;
      }
      while (depth>SymbolDepth(i)) { CloseScope(); depth--; } ;
      NODE = CopyFuncBody(SymbolKind(yyP292),SplatSymbolTableFormals(yyP293,yyP291,FirstActual,SymbolDepth(FirstActual),mNoSpec()),yyP290,AddSymbol(NoIdent));
      NODE->Valof.FuncCall = mFuncCall(yyP293,yyP292,yyP291,yyP290);
      SymbolKind(NODE->Valof.Sym) = NODE;
      TraverseTreeTD(NODE,UpdateFuncSymbol);      
    }
  }
  }
   return NODE;
yyL2:;

/* line 1782 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return mFuncCall (yyP293, yyP292, yyP291, yyP290);

}

tTree CreateProcCall
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP298, register tTree yyP297, tSymbol yyP296, register tTree yyP295, tSymbol yyP294)
# else
(yyP298, yyP297, yyP296, yyP295, yyP294)
 register tPosition yyP298;
 register tTree yyP297;
 tSymbol yyP296;
 register tTree yyP295;
 tSymbol yyP294;
# endif
{
/* line 1786 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tTree NODE; 
/* line 1787 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1787 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP296), kInlineDefProc)))) goto yyL1;
  {
/* line 1788 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   OpenAtScope (SymbolScope (yyP296));
/* line 1789 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
{
      int depth = SymbolDepth(yyP296)+1;
      int i;
      tTree formals = SymbolKind(yyP296)->InlineDefProc.Formals;
      if (Tree_IsType(formals,kNoFormals))         
	FirstFormal = formals->NoFormals.Sym;
      else if (Tree_IsType(formals,kNoFormal))
	Message("Internal failure- couldn't find start of formal list",xxFatal,yyP298);
      else 
	FirstFormal = formals->AFormal.Sym;

      FunctionInlining = yyP296;
      FirstActual = FunctionInlining;
      i = FirstFormal;
      while (i<yyP296) 
      {
	while (depth<SymbolDepth(i)) { OpenScope(); depth++; }
	while (depth>SymbolDepth(i)) { CloseScope(); depth--; }
	{
	  tSymbol tmp=AddSymbol(Symbol(i).Id);
	  if (FirstActual==FunctionInlining) FirstActual = tmp;
	  SymbolType(tmp) = SymbolType(i);
	  SymbolKind(tmp) = SymbolKind(i);
	}
	i++;
      }
      while (depth>SymbolDepth(i)) { CloseScope(); depth--; } ;
      NODE = CopyTree(SymbolKind(yyP296)->InlineDefProc.Process);
      NODE->Process.SpecList = AppendSpecList(SplatSymbolTableFormals(yyP298,yyP295,FirstActual,SymbolDepth(FirstActual),mNoSpec()),NODE->Process.SpecList);
      TraverseTreeTD(NODE,UpdateFuncSymbol);
    }
  }
  }
   return NODE;
yyL1:;

/* line 1821 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return mInstance (yyP298, yyP297, yyP296, yyP295, yyP294);

}

bool CheckValidUserType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP299)
# else
(yyP299)
 register tTree yyP299;
# endif
{
  if (Tree_IsType (yyP299, kUserDataTypes)) {
/* line 1826 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1826 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! CheckAllDataFields (yyP299->UserDataTypes.FieldList)))) goto yyL1;
  {
/* line 1826 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;
  }
  }
yyL1:;

  }
  if (yyP299->Kind == kUserChanRecord) {
/* line 1827 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1827 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((! CheckAllChanFields (yyP299->UserChanRecord.FieldList)))) goto yyL2;
  {
/* line 1827 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return false;
  }
  }
yyL2:;

  }
/* line 1828 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

}

static bool CheckAllDataFields
# if defined __STDC__ | defined __cplusplus
(register tTree yyP300)
# else
(yyP300)
 register tTree yyP300;
# endif
{
  if (yyP300->Kind == kNoField) {
/* line 1831 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP300->Kind == kAField) {
/* line 1832 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1832 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (IsDataType (yyP300->AField.Type))) goto yyL2;
  {
/* line 1832 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckAllDataFields (yyP300->AField.Next))) goto yyL2;
  }
  }
   return true;
yyL2:;

  }
  return false;
}

static bool CheckAllChanFields
# if defined __STDC__ | defined __cplusplus
(register tTree yyP301)
# else
(yyP301)
 register tTree yyP301;
# endif
{
  if (yyP301->Kind == kNoField) {
/* line 1835 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP301->Kind == kAField) {
/* line 1836 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1836 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (IsChanType (yyP301->AField.Type))) goto yyL2;
  {
/* line 1836 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! (CheckAllChanFields (yyP301->AField.Next))) goto yyL2;
  }
  }
   return true;
yyL2:;

  }
  return false;
}

tTree GetTagProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP302)
# else
(yyP302)
 register tTree yyP302;
# endif
{
  if (yyP302 == NULL) {
/* line 1839 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return NULL;

  }
  if (yyP302->Kind == kChan) {
  if (yyP302->Chan.Protocol->Kind == kNamed) {
/* line 1840 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1840 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP302->Chan.Protocol->Named.Sym), kDefTagPro)))) goto yyL2;
  }
   return SymbolKind (yyP302->Chan.Protocol->Named.Sym) -> DefTagPro . TagProList;
yyL2:;

  }
  }
/* line 1841 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return NULL;

}

void LookupProtocolTag
# if defined __STDC__ | defined __cplusplus
(register tIdent yyP305, register tPosition yyP304, register tTree yyP303, tSymbol * yyP306)
# else
(yyP305, yyP304, yyP303, yyP306)
 register tIdent yyP305;
 register tPosition yyP304;
 register tTree yyP303;
 tSymbol * yyP306;
# endif
{
  if (yyP303->Kind == kNoTagPro) {
/* line 1844 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   * yyP306 = NoSymbol;
   return;

  }
  if (yyP303->Kind == kATagPro) {
/* line 1845 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1845 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP305 == Symbol (yyP303->ATagPro.Sym) . Id))) goto yyL2;
  }
   * yyP306 = yyP303->ATagPro.Sym;
   return;
yyL2:;

/* line 1846 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  tSymbol yyV1;
  {
/* line 1846 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   LookupProtocolTag (yyP305, yyP304, yyP303->ATagPro.Next, & yyV1);
  }
   * yyP306 = yyV1;
   return;
 }

  }
;
}

tTree LookupField
# if defined __STDC__ | defined __cplusplus
(register tIdent yyP309, register tPosition yyP308, register tTree yyP307, tSymbol * yyP310)
# else
(yyP309, yyP308, yyP307, yyP310)
 register tIdent yyP309;
 register tPosition yyP308;
 register tTree yyP307;
 tSymbol * yyP310;
# endif
{
/* line 1849 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 tTree FL; 
  if (yyP307->Kind == kNoField) {
/* line 1850 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   * yyP310 = NoSymbol;
   return yyP307;

  }
  if (yyP307->Kind == kAField) {
/* line 1851 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1851 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   if (! ((yyP309 == Symbol (yyP307->AField.Sym) . Id))) goto yyL2;
  }
   * yyP310 = yyP307->AField.Sym;
   return yyP307;
yyL2:;

/* line 1852 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
 {
  tSymbol yyV1;
  {
/* line 1852 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   FL = LookupField (yyP309, yyP308, yyP307->AField.Next, & yyV1);
  }
   * yyP310 = yyV1;
  {
   return FL;
  }
 }

  }
 yyAbort ("LookupField");
}

tTree GetFieldList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP311)
# else
(yyP311)
 register tTree yyP311;
# endif
{
  if (yyP311 == NULL) {
/* line 1855 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return NoTree;

  }
  if (Tree_IsType (yyP311, kUserStructTypes)) {
/* line 1856 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP311->UserStructTypes.FieldList;

  }
/* line 1857 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return NoTree;

}

tTree ArrayPrimType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP312)
# else
(yyP312)
 register tTree yyP312;
# endif
{
  if (Tree_IsType (yyP312, kArray)) {
/* line 1862 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return ArrayPrimType (yyP312->Array.Type);

  }
  if (Tree_IsType (yyP312, kPrimitive)) {
/* line 1863 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return yyP312;

  }
 yyAbort ("ArrayPrimType");
}

void MarkNonAtomicIf
# if defined __STDC__ | defined __cplusplus
(register tTree IF)
# else
(IF)
 register tTree IF;
# endif
{
  if (IF->Kind == kIf) {
/* line 1871 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1872 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
IF->If.ATOMIC = false; 
/* line 1873 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   MarkNonAtomicIfList (IF->If.ChoiceList);
  }
   return;

  }
  if (IF->Kind == kIfRep) {
/* line 1876 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1877 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
IF->IfRep.ATOMIC = false; 
/* line 1878 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   MarkNonAtomicIfList (IF->IfRep.ChoiceList);
  }
   return;

  }
;
}

static void MarkNonAtomicIfList
# if defined __STDC__ | defined __cplusplus
(register tTree IF)
# else
(IF)
 register tTree IF;
# endif
{
  if (IF->Kind == kAChoice) {
/* line 1883 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1884 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
IF->AChoice.ATOMIC = false; 
/* line 1885 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   MarkNonAtomicIfList (IF->AChoice.Next);
  }
   return;

  }
  if (IF->Kind == kANewIf) {
/* line 1888 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
  {
/* line 1889 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
IF->ANewIf.ATOMIC = false; 
/* line 1890 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   MarkNonAtomicIf (IF->ANewIf.IfType);
/* line 1891 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   MarkNonAtomicIfList (IF->ANewIf.Next);
  }
   return;

  }
  if (IF->Kind == kNoChoice) {
/* line 1894 "/home/simon/spoc/source/spoc.1.3//source/gmd/typechk.trafo" */
   return;

  }
;
}

void BeginTypeChk ()
{
}

void CloseTypeChk ()
{
}
